import * as i0 from '@angular/core';
import { Injectable, Component, HostBinding, Input, ViewChild, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import * as $ from 'jquery';
import * as i1 from '@angular/router';
import { NavigationEnd } from '@angular/router';
import { BehaviorSubject } from 'rxjs';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i4 from '@angular/material/list';
import { MatListModule } from '@angular/material/list';
import * as i4$1 from '@angular/material/sidenav';
import { MatSidenavModule } from '@angular/material/sidenav';
import { trigger, state, style, transition, animate } from '@angular/animations';
import * as i5 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i2 from '@angular/material/toolbar';
import { MatToolbarModule } from '@angular/material/toolbar';
import { A11yModule } from '@angular/cdk/a11y';
import { BidiModule } from '@angular/cdk/bidi';
import { ObserversModule } from '@angular/cdk/observers';
import { OverlayModule } from '@angular/cdk/overlay';
import { PlatformModule } from '@angular/cdk/platform';
import { PortalModule } from '@angular/cdk/portal';
import { CdkStepperModule } from '@angular/cdk/stepper';
import { CdkTableModule } from '@angular/cdk/table';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatChipsModule } from '@angular/material/chips';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatInputModule } from '@angular/material/input';
import { MatMenuModule } from '@angular/material/menu';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatRadioModule } from '@angular/material/radio';
import { MatRippleModule, MatNativeDateModule } from '@angular/material/core';
import { MatSelectModule } from '@angular/material/select';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSliderModule } from '@angular/material/slider';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import { MatTabsModule } from '@angular/material/tabs';
import { MatTooltipModule } from '@angular/material/tooltip';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';

class NavService {
    router;
    appDrawer;
    currentUrl = new BehaviorSubject(undefined);
    constructor(router) {
        this.router = router;
        this.router.events.subscribe((event) => {
            if (event instanceof NavigationEnd) {
                this.currentUrl.next(event.urlAfterRedirects);
            }
        });
    }
    closeNav() {
        this.appDrawer.close();
    }
    openNav() {
        this.appDrawer.open();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: NavService, deps: [{ token: i1.Router }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: NavService });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: NavService, decorators: [{
            type: Injectable
        }], ctorParameters: () => [{ type: i1.Router }] });

class MenuListItemComponent {
    navService;
    router;
    expanded;
    ariaExpanded = this.expanded;
    item;
    depth;
    constructor(navService, router) {
        this.navService = navService;
        this.router = router;
        if (this.depth === undefined) {
            this.depth = 0;
        }
    }
    ngOnInit() {
        this.navService.currentUrl.subscribe((url) => {
            if (this.item.route && url) {
                this.expanded = url.indexOf(`/${this.item.route}`) === 0;
                this.ariaExpanded = this.expanded;
            }
        });
    }
    onItemSelected(item) {
        if (!item.children || !item.children.length) {
            this.router.navigate([item.route]);
            this.navService.closeNav();
        }
        if (item.children && item.children.length) {
            this.expanded = !this.expanded;
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MenuListItemComponent, deps: [{ token: NavService }, { token: i1.Router }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: MenuListItemComponent, selector: "menu-list-item", inputs: { item: "item", depth: "depth" }, host: { properties: { "attr.aria-expanded": "this.ariaExpanded" } }, ngImport: i0, template: "<a mat-list-item [ngStyle]=\"{'padding-left': (depth * 12) + 'px'}\" (click)=\"onItemSelected(item)\"\n    [ngClass]=\"{'active': item.route ? router.isActive(item.route, true): false, 'expanded': expanded}\"\n    class=\"menu-list-item\">\n    <mat-icon class=\"routeIcon\" *ngIf=\"item.iconName!=''\">{{item.iconName}}</mat-icon>\n    <span *ngIf=\"item.iconName==''\" [class]=\"item.FontAwesomeIcon\"></span>\n    {{item.displayName}}\n    <span style=\"display: flex;align-items: center;\" fxFlex *ngIf=\"item.children && item.children.length\">\n        <span fxFlex></span>\n        <mat-icon [@indicatorRotate]=\"expanded ? 'expanded': 'collapsed'\">\n            expand_more\n        </mat-icon>\n    </span>\n</a>\n<div *ngIf=\"expanded\">\n    <menu-list-item *ngFor=\"let child of item.children\" [item]=\"child\" [depth]=\"depth+1\">\n    </menu-list-item>\n</div>", styles: [":host{display:flex;flex-direction:column;outline:none;width:100%}.mat-list-item{padding:8px 0;display:flex;width:auto}.mat-list-item .routeIcon{margin-right:40px}\n"], dependencies: [{ kind: "directive", type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i4.MatListItem, selector: "mat-list-item, a[mat-list-item], button[mat-list-item]", inputs: ["activated"], exportAs: ["matListItem"] }, { kind: "component", type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "component", type: MenuListItemComponent, selector: "menu-list-item", inputs: ["item", "depth"] }], animations: [
            trigger('indicatorRotate', [
                state('collapsed', style({ transform: 'rotate(0deg)' })),
                state('expanded', style({ transform: 'rotate(180deg)' })),
                transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4,0.0,0.2,1)')),
            ])
        ] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MenuListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'menu-list-item', animations: [
                        trigger('indicatorRotate', [
                            state('collapsed', style({ transform: 'rotate(0deg)' })),
                            state('expanded', style({ transform: 'rotate(180deg)' })),
                            transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4,0.0,0.2,1)')),
                        ])
                    ], template: "<a mat-list-item [ngStyle]=\"{'padding-left': (depth * 12) + 'px'}\" (click)=\"onItemSelected(item)\"\n    [ngClass]=\"{'active': item.route ? router.isActive(item.route, true): false, 'expanded': expanded}\"\n    class=\"menu-list-item\">\n    <mat-icon class=\"routeIcon\" *ngIf=\"item.iconName!=''\">{{item.iconName}}</mat-icon>\n    <span *ngIf=\"item.iconName==''\" [class]=\"item.FontAwesomeIcon\"></span>\n    {{item.displayName}}\n    <span style=\"display: flex;align-items: center;\" fxFlex *ngIf=\"item.children && item.children.length\">\n        <span fxFlex></span>\n        <mat-icon [@indicatorRotate]=\"expanded ? 'expanded': 'collapsed'\">\n            expand_more\n        </mat-icon>\n    </span>\n</a>\n<div *ngIf=\"expanded\">\n    <menu-list-item *ngFor=\"let child of item.children\" [item]=\"child\" [depth]=\"depth+1\">\n    </menu-list-item>\n</div>", styles: [":host{display:flex;flex-direction:column;outline:none;width:100%}.mat-list-item{padding:8px 0;display:flex;width:auto}.mat-list-item .routeIcon{margin-right:40px}\n"] }]
        }], ctorParameters: () => [{ type: NavService }, { type: i1.Router }], propDecorators: { ariaExpanded: [{
                type: HostBinding,
                args: ['attr.aria-expanded']
            }], item: [{
                type: Input
            }], depth: [{
                type: Input
            }] } });

class TopNavComponent {
    navService;
    TopNavTitle;
    MatToolBarClassName = 'primary';
    constructor(navService) {
        this.navService = navService;
    }
    ngOnInit() {
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: TopNavComponent, deps: [{ token: NavService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: TopNavComponent, selector: "top-nav", inputs: { TopNavTitle: "TopNavTitle", MatToolBarClassName: "MatToolBarClassName" }, ngImport: i0, template: "<mat-toolbar [color]=\"this.MatToolBarClassName\" class=\"mat-elevation-z1\">\n  <button class=\"button-menu\" mat-icon-button id=\"menu\" (click)=\"navService.openNav()\">\n    <mat-icon>menu</mat-icon>\n  </button>\n  <span>{{this.TopNavTitle}}</span>\n  <ng-content></ng-content>\n</mat-toolbar>", styles: [".button-menu{background:transparent;color:#fff;border:0!important;font-weight:700;display:flex;cursor:pointer;outline:none!important}\n"], dependencies: [{ kind: "component", type: i2.MatToolbar, selector: "mat-toolbar", inputs: ["color"], exportAs: ["matToolbar"] }, { kind: "component", type: i5.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: TopNavComponent, decorators: [{
            type: Component,
            args: [{ selector: 'top-nav', template: "<mat-toolbar [color]=\"this.MatToolBarClassName\" class=\"mat-elevation-z1\">\n  <button class=\"button-menu\" mat-icon-button id=\"menu\" (click)=\"navService.openNav()\">\n    <mat-icon>menu</mat-icon>\n  </button>\n  <span>{{this.TopNavTitle}}</span>\n  <ng-content></ng-content>\n</mat-toolbar>", styles: [".button-menu{background:transparent;color:#fff;border:0!important;font-weight:700;display:flex;cursor:pointer;outline:none!important}\n"] }]
        }], ctorParameters: () => [{ type: NavService }], propDecorators: { TopNavTitle: [{
                type: Input,
                args: ['TopNavTitle']
            }], MatToolBarClassName: [{
                type: Input,
                args: ["MatToolBarClassName"]
            }] } });

class DashboardComponent {
    navService;
    appDrawer;
    Items;
    title;
    DashboardClassName = 'primary';
    constructor(navService) {
        this.navService = navService;
    }
    ngOnInit() {
        $(document).ready(function () {
            var trigger = $('.hamburger'), overlay = $('.overlay'), isClosed = false;
            trigger.click(function () {
                hamburger_cross();
            });
            function hamburger_cross() {
                if (isClosed == true) {
                    overlay.hide();
                    trigger.removeClass('is-open');
                    trigger.addClass('is-closed');
                    isClosed = false;
                }
                else {
                    overlay.show();
                    trigger.removeClass('is-closed');
                    trigger.addClass('is-open');
                    isClosed = true;
                }
            }
            $('[data-toggle="offcanvas"]').click(function () {
                $('#wrapper').toggleClass('toggled');
            });
        });
    }
    ngAfterViewInit() {
        this.navService.appDrawer = this.appDrawer;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: DashboardComponent, deps: [{ token: NavService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: DashboardComponent, selector: "dashboard", inputs: { Items: "Items", title: "title", DashboardClassName: "DashboardClassName" }, viewQueries: [{ propertyName: "appDrawer", first: true, predicate: ["appDrawer"], descendants: true }], ngImport: i0, template: "<mat-sidenav-container>\n  <mat-sidenav #appDrawer mode=\"over\" opened=\"false\">\n    <mat-nav-list>\n      <menu-list-item *ngFor=\"let item of this.Items\" [item]=\"item\"></menu-list-item>\n    </mat-nav-list>\n  </mat-sidenav>\n  <top-nav fxHide.xs [TopNavTitle]=\"this.title\" [MatToolBarClassName]=\"this.DashboardClassName\">\n    <div class=\"logout-panel\" style=\"margin: auto;margin-right: 20px;\">\n      <ng-content></ng-content>\n    </div>\n  </top-nav>\n  <div class=\"router-controller\">\n    <router-outlet></router-outlet>\n  </div>\n</mat-sidenav-container>", styles: ["body{background-color:#fff}.main-container{height:100vh;width:100vw;background:#e4e2e2a6}.bottom-panel{width:98vw;margin:auto;border-radius:5px}.nav .open>a,.nav .open>a:hover,.nav .open>a:focus{background-color:transparent}#wrapper{padding-left:0;-webkit-transition:all .5s ease;-moz-transition:all .5s ease;-o-transition:all .5s ease;transition:all .5s ease}#wrapper.toggled{padding-left:220px}#sidebar-wrapper{z-index:1000;left:220px;width:0;height:calc(100vh - 48px);margin-top:48px;margin-left:-220px;overflow-y:auto;overflow-x:hidden;background:#1a1a1a;transition:all .5s ease}#sidebar-wrapper::-webkit-scrollbar{display:none}#wrapper.toggled #sidebar-wrapper{width:220px}#page-content-wrapper{width:100%}.navbar{padding:0}.sidebar-nav{position:absolute;top:0;width:220px;margin:0;padding:0;list-style:none}.sidebar-nav li{position:relative;line-height:20px;display:inline-block;width:100%}.sidebar-nav li:before{content:\"\";position:absolute;top:0;left:0;z-index:-1;height:100%;width:3px;background-color:#1c1c1c;-webkit-transition:width .2s ease-in;-moz-transition:width .2s ease-in;-ms-transition:width .2s ease-in;transition:width .2s ease-in}.sidebar-nav li:first-child a{color:#fff;background-color:#1a1a1a}.sidebar-nav li:nth-child(5n+1):before{background-color:#ec1b5a}.sidebar-nav li:nth-child(5n+2):before{background-color:#79aefe}.sidebar-nav li:nth-child(5n+3):before{background-color:#314190}.sidebar-nav li:nth-child(5n+4):before{background-color:#279636}.sidebar-nav li:nth-child(5n+5):before{background-color:#7d5d81}.sidebar-nav li:hover:before,.sidebar-nav li.open:hover:before{width:100%;-webkit-transition:width .2s ease-in;-moz-transition:width .2s ease-in;-ms-transition:width .2s ease-in;transition:width .2s ease-in}.sidebar-nav li a{display:block;color:#ddd;text-decoration:none;padding:10px 15px 10px 30px}.sidebar-nav li a:hover,.sidebar-nav li a:active,.sidebar-nav li a:focus,.sidebar-nav li.open a:hover,.sidebar-nav li.open a:active,.sidebar-nav li.open a:focus{color:#fff;text-decoration:none;background-color:transparent}.sidebar-header{text-align:center;font-size:20px;position:relative;width:100%;display:inline-block}.sidebar-brand{height:65px;position:relative;background:#212531;background:linear-gradient(to right bottom,#2f3441 50%,#212531 50%);padding-top:1em}.sidebar-brand a{color:#ddd}.sidebar-brand a:hover{color:#fff;text-decoration:none}.dropdown-header{text-align:center;font-size:1em;color:#ddd;background:#212531;background:linear-gradient(to right bottom,#2f3441 50%,#212531 50%)}.sidebar-nav .dropdown-menu{position:relative;width:100%;padding:0;margin:0;border-radius:0;border:none;background-color:#222;box-shadow:none}.dropdown-menu.show{top:0}.nav.sidebar-nav li a:before{font-family:fontawesome;content:\"\\f12e\";vertical-align:baseline;display:inline-block;padding-right:5px}a[href*=\"#Buyer Credit\"]:before{content:\"\\f015\"!important}a[href*=\"#about\"]:before{content:\"\\f129\"!important}a[href*=\"#events\"]:before{content:\"\\f073\"!important}a[href*=\"#team\"]:before{content:\"\\f0c0\"!important}a[href*=\"#works\"]:before{content:\"\\f0b1\"!important}a[href*=\"#pictures\"]:before{content:\"\\f03e\"!important}a[href*=\"#videos\"]:before{content:\"\\f03d\"!important}a[href*=\"#books\"]:before{content:\"\\f02d\"!important}a[href*=\"#art\"]:before{content:\"\\f1fc\"!important}a[href*=\"#awards\"]:before{content:\"\\f02e\"!important}a[href*=\"#services\"]:before{content:\"\\f013\"!important}a[href*=\"#contact\"]:before{content:\"\\f086\"!important}a[href*=\"#followme\"]:before{content:\"\\f099\"!important;color:#0084b4}.hamburger{position:fixed;top:8px;z-index:999;display:block;width:32px;height:32px;margin-left:9px;font-size:20px;background:transparent;border:none}.hamburger:hover,.hamburger:focus,.hamburger:active{outline:none}.hamburger.is-closed:before{content:\"\";display:block;width:100px;font-size:14px;color:#fff;line-height:32px;text-align:center;opacity:0;-webkit-transform:translate3d(0,0,0);-webkit-transition:all .35s ease-in-out}.hamburger.is-closed:hover:before{opacity:1;display:block;-webkit-transform:translate3d(-100px,0,0);-webkit-transition:all .35s ease-in-out}.hamburger.is-closed .hamb-top,.hamburger.is-closed .hamb-middle,.hamburger.is-closed .hamb-bottom,.hamburger.is-open .hamb-top,.hamburger.is-open .hamb-middle,.hamburger.is-open .hamb-bottom{position:absolute;left:0;height:4px;width:100%}.hamburger.is-closed .hamb-top,.hamburger.is-closed .hamb-middle,.hamburger.is-closed .hamb-bottom{background-color:#1a1a1a}.hamburger.is-closed .hamb-top{top:5px;-webkit-transition:all .35s ease-in-out}.hamburger.is-closed .hamb-middle{top:50%;margin-top:-2px}.hamburger.is-closed .hamb-bottom{bottom:5px;-webkit-transition:all .35s ease-in-out}.hamburger.is-closed:hover .hamb-top{top:0;-webkit-transition:all .35s ease-in-out}.hamburger.is-closed:hover .hamb-bottom{bottom:0;-webkit-transition:all .35s ease-in-out}.hamburger.is-open .hamb-top,.hamburger.is-open .hamb-middle,.hamburger.is-open .hamb-bottom{background-color:#1a1a1a}.hamburger.is-open .hamb-top,.hamburger.is-open .hamb-bottom{top:50%;margin-top:-2px}.hamburger.is-open .hamb-top{-webkit-transform:rotate(45deg);-webkit-transition:-webkit-transform .2s cubic-bezier(.73,1,.28,.08)}.hamburger.is-open .hamb-middle{display:none}.hamburger.is-open .hamb-bottom{-webkit-transform:rotate(-45deg);-webkit-transition:-webkit-transform .2s cubic-bezier(.73,1,.28,.08)}.hamburger.is-open:before{content:\"\";display:block;width:100px;font-size:14px;color:#fff;line-height:32px;text-align:center;opacity:0;-webkit-transform:translate3d(0,0,0);-webkit-transition:all .35s ease-in-out}.hamburger.is-open:hover:before{opacity:1;display:block;-webkit-transform:translate3d(-100px,0,0);-webkit-transition:all .35s ease-in-out}.overlay{position:fixed;display:none;width:100%;height:100%;inset:0;background-color:#fafafacc;z-index:1}.router{height:calc(100vh - 80px);width:98vw;margin:6px auto auto;padding:10px;border-radius:5px}.mat-sidenav{width:210px;position:absolute;top:65px;height:calc(100vh - 65px)}.mat-sidenav ::ng-deep .mdc-list-item__primary-text{text-overflow:ellipsis;white-space:nowrap;overflow:hidden;display:flex;gap:10px;align-items:center;padding-left:10px}.mat-sidenav-container{background-color:#fff!important;height:100vh}.mat-sidenav-container .mat-sidenav-content{display:flex;flex-direction:column}.sidenav-toolbar{height:64px;display:flex;flex-direction:row}@media (max-width: 600px){.sidenav-toolbar{height:56px}}.mat-nav-list{padding-top:0}.menu-list-item.mat-list-item .mat-list-item-content{flex:1 1 100%}.version-info{font-size:8pt;padding:8px;align-self:flex-end}.router-controller{width:99vw;margin:10px auto auto;height:calc(100vh - 80px);overflow:auto;padding:10px}\n"], dependencies: [{ kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: i4.MatNavList, selector: "mat-nav-list", exportAs: ["matNavList"] }, { kind: "component", type: i4$1.MatSidenav, selector: "mat-sidenav", inputs: ["fixedInViewport", "fixedTopGap", "fixedBottomGap"], exportAs: ["matSidenav"] }, { kind: "component", type: i4$1.MatSidenavContainer, selector: "mat-sidenav-container", exportAs: ["matSidenavContainer"] }, { kind: "component", type: MenuListItemComponent, selector: "menu-list-item", inputs: ["item", "depth"] }, { kind: "component", type: TopNavComponent, selector: "top-nav", inputs: ["TopNavTitle", "MatToolBarClassName"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: DashboardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dashboard', template: "<mat-sidenav-container>\n  <mat-sidenav #appDrawer mode=\"over\" opened=\"false\">\n    <mat-nav-list>\n      <menu-list-item *ngFor=\"let item of this.Items\" [item]=\"item\"></menu-list-item>\n    </mat-nav-list>\n  </mat-sidenav>\n  <top-nav fxHide.xs [TopNavTitle]=\"this.title\" [MatToolBarClassName]=\"this.DashboardClassName\">\n    <div class=\"logout-panel\" style=\"margin: auto;margin-right: 20px;\">\n      <ng-content></ng-content>\n    </div>\n  </top-nav>\n  <div class=\"router-controller\">\n    <router-outlet></router-outlet>\n  </div>\n</mat-sidenav-container>", styles: ["body{background-color:#fff}.main-container{height:100vh;width:100vw;background:#e4e2e2a6}.bottom-panel{width:98vw;margin:auto;border-radius:5px}.nav .open>a,.nav .open>a:hover,.nav .open>a:focus{background-color:transparent}#wrapper{padding-left:0;-webkit-transition:all .5s ease;-moz-transition:all .5s ease;-o-transition:all .5s ease;transition:all .5s ease}#wrapper.toggled{padding-left:220px}#sidebar-wrapper{z-index:1000;left:220px;width:0;height:calc(100vh - 48px);margin-top:48px;margin-left:-220px;overflow-y:auto;overflow-x:hidden;background:#1a1a1a;transition:all .5s ease}#sidebar-wrapper::-webkit-scrollbar{display:none}#wrapper.toggled #sidebar-wrapper{width:220px}#page-content-wrapper{width:100%}.navbar{padding:0}.sidebar-nav{position:absolute;top:0;width:220px;margin:0;padding:0;list-style:none}.sidebar-nav li{position:relative;line-height:20px;display:inline-block;width:100%}.sidebar-nav li:before{content:\"\";position:absolute;top:0;left:0;z-index:-1;height:100%;width:3px;background-color:#1c1c1c;-webkit-transition:width .2s ease-in;-moz-transition:width .2s ease-in;-ms-transition:width .2s ease-in;transition:width .2s ease-in}.sidebar-nav li:first-child a{color:#fff;background-color:#1a1a1a}.sidebar-nav li:nth-child(5n+1):before{background-color:#ec1b5a}.sidebar-nav li:nth-child(5n+2):before{background-color:#79aefe}.sidebar-nav li:nth-child(5n+3):before{background-color:#314190}.sidebar-nav li:nth-child(5n+4):before{background-color:#279636}.sidebar-nav li:nth-child(5n+5):before{background-color:#7d5d81}.sidebar-nav li:hover:before,.sidebar-nav li.open:hover:before{width:100%;-webkit-transition:width .2s ease-in;-moz-transition:width .2s ease-in;-ms-transition:width .2s ease-in;transition:width .2s ease-in}.sidebar-nav li a{display:block;color:#ddd;text-decoration:none;padding:10px 15px 10px 30px}.sidebar-nav li a:hover,.sidebar-nav li a:active,.sidebar-nav li a:focus,.sidebar-nav li.open a:hover,.sidebar-nav li.open a:active,.sidebar-nav li.open a:focus{color:#fff;text-decoration:none;background-color:transparent}.sidebar-header{text-align:center;font-size:20px;position:relative;width:100%;display:inline-block}.sidebar-brand{height:65px;position:relative;background:#212531;background:linear-gradient(to right bottom,#2f3441 50%,#212531 50%);padding-top:1em}.sidebar-brand a{color:#ddd}.sidebar-brand a:hover{color:#fff;text-decoration:none}.dropdown-header{text-align:center;font-size:1em;color:#ddd;background:#212531;background:linear-gradient(to right bottom,#2f3441 50%,#212531 50%)}.sidebar-nav .dropdown-menu{position:relative;width:100%;padding:0;margin:0;border-radius:0;border:none;background-color:#222;box-shadow:none}.dropdown-menu.show{top:0}.nav.sidebar-nav li a:before{font-family:fontawesome;content:\"\\f12e\";vertical-align:baseline;display:inline-block;padding-right:5px}a[href*=\"#Buyer Credit\"]:before{content:\"\\f015\"!important}a[href*=\"#about\"]:before{content:\"\\f129\"!important}a[href*=\"#events\"]:before{content:\"\\f073\"!important}a[href*=\"#team\"]:before{content:\"\\f0c0\"!important}a[href*=\"#works\"]:before{content:\"\\f0b1\"!important}a[href*=\"#pictures\"]:before{content:\"\\f03e\"!important}a[href*=\"#videos\"]:before{content:\"\\f03d\"!important}a[href*=\"#books\"]:before{content:\"\\f02d\"!important}a[href*=\"#art\"]:before{content:\"\\f1fc\"!important}a[href*=\"#awards\"]:before{content:\"\\f02e\"!important}a[href*=\"#services\"]:before{content:\"\\f013\"!important}a[href*=\"#contact\"]:before{content:\"\\f086\"!important}a[href*=\"#followme\"]:before{content:\"\\f099\"!important;color:#0084b4}.hamburger{position:fixed;top:8px;z-index:999;display:block;width:32px;height:32px;margin-left:9px;font-size:20px;background:transparent;border:none}.hamburger:hover,.hamburger:focus,.hamburger:active{outline:none}.hamburger.is-closed:before{content:\"\";display:block;width:100px;font-size:14px;color:#fff;line-height:32px;text-align:center;opacity:0;-webkit-transform:translate3d(0,0,0);-webkit-transition:all .35s ease-in-out}.hamburger.is-closed:hover:before{opacity:1;display:block;-webkit-transform:translate3d(-100px,0,0);-webkit-transition:all .35s ease-in-out}.hamburger.is-closed .hamb-top,.hamburger.is-closed .hamb-middle,.hamburger.is-closed .hamb-bottom,.hamburger.is-open .hamb-top,.hamburger.is-open .hamb-middle,.hamburger.is-open .hamb-bottom{position:absolute;left:0;height:4px;width:100%}.hamburger.is-closed .hamb-top,.hamburger.is-closed .hamb-middle,.hamburger.is-closed .hamb-bottom{background-color:#1a1a1a}.hamburger.is-closed .hamb-top{top:5px;-webkit-transition:all .35s ease-in-out}.hamburger.is-closed .hamb-middle{top:50%;margin-top:-2px}.hamburger.is-closed .hamb-bottom{bottom:5px;-webkit-transition:all .35s ease-in-out}.hamburger.is-closed:hover .hamb-top{top:0;-webkit-transition:all .35s ease-in-out}.hamburger.is-closed:hover .hamb-bottom{bottom:0;-webkit-transition:all .35s ease-in-out}.hamburger.is-open .hamb-top,.hamburger.is-open .hamb-middle,.hamburger.is-open .hamb-bottom{background-color:#1a1a1a}.hamburger.is-open .hamb-top,.hamburger.is-open .hamb-bottom{top:50%;margin-top:-2px}.hamburger.is-open .hamb-top{-webkit-transform:rotate(45deg);-webkit-transition:-webkit-transform .2s cubic-bezier(.73,1,.28,.08)}.hamburger.is-open .hamb-middle{display:none}.hamburger.is-open .hamb-bottom{-webkit-transform:rotate(-45deg);-webkit-transition:-webkit-transform .2s cubic-bezier(.73,1,.28,.08)}.hamburger.is-open:before{content:\"\";display:block;width:100px;font-size:14px;color:#fff;line-height:32px;text-align:center;opacity:0;-webkit-transform:translate3d(0,0,0);-webkit-transition:all .35s ease-in-out}.hamburger.is-open:hover:before{opacity:1;display:block;-webkit-transform:translate3d(-100px,0,0);-webkit-transition:all .35s ease-in-out}.overlay{position:fixed;display:none;width:100%;height:100%;inset:0;background-color:#fafafacc;z-index:1}.router{height:calc(100vh - 80px);width:98vw;margin:6px auto auto;padding:10px;border-radius:5px}.mat-sidenav{width:210px;position:absolute;top:65px;height:calc(100vh - 65px)}.mat-sidenav ::ng-deep .mdc-list-item__primary-text{text-overflow:ellipsis;white-space:nowrap;overflow:hidden;display:flex;gap:10px;align-items:center;padding-left:10px}.mat-sidenav-container{background-color:#fff!important;height:100vh}.mat-sidenav-container .mat-sidenav-content{display:flex;flex-direction:column}.sidenav-toolbar{height:64px;display:flex;flex-direction:row}@media (max-width: 600px){.sidenav-toolbar{height:56px}}.mat-nav-list{padding-top:0}.menu-list-item.mat-list-item .mat-list-item-content{flex:1 1 100%}.version-info{font-size:8pt;padding:8px;align-self:flex-end}.router-controller{width:99vw;margin:10px auto auto;height:calc(100vh - 80px);overflow:auto;padding:10px}\n"] }]
        }], ctorParameters: () => [{ type: NavService }], propDecorators: { appDrawer: [{
                type: ViewChild,
                args: ['appDrawer']
            }], Items: [{
                type: Input,
                args: ['Items']
            }], title: [{
                type: Input,
                args: ['title']
            }], DashboardClassName: [{
                type: Input,
                args: ['DashboardClassName']
            }] } });

/**
 * NgModule that includes all Material and CDK modules that are required.
 */
class MaterialModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, declarations: [DashboardComponent,
            MenuListItemComponent,
            TopNavComponent], imports: [CommonModule,
            ReactiveFormsModule,
            FormsModule,
            A11yModule,
            BidiModule,
            ObserversModule,
            OverlayModule,
            PlatformModule,
            PortalModule,
            CdkStepperModule,
            CdkTableModule,
            MatButtonToggleModule,
            MatCheckboxModule,
            MatChipsModule,
            MatDatepickerModule,
            MatExpansionModule,
            MatGridListModule,
            MatInputModule,
            MatListModule,
            MatMenuModule,
            MatProgressBarModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSlideToggleModule,
            MatSliderModule,
            MatSnackBarModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatNativeDateModule,
            MatIconModule], exports: [DashboardComponent,
            A11yModule,
            BidiModule,
            ObserversModule,
            OverlayModule,
            PlatformModule,
            PortalModule,
            CdkStepperModule,
            CdkTableModule,
            MatButtonToggleModule,
            MatCheckboxModule,
            MatChipsModule,
            MatDatepickerModule,
            MatExpansionModule,
            MatGridListModule,
            MatInputModule,
            MatListModule,
            MatMenuModule,
            MatProgressBarModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSlideToggleModule,
            MatSliderModule,
            MatSnackBarModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatNativeDateModule,
            CommonModule,
            ReactiveFormsModule,
            FormsModule,
            MenuListItemComponent,
            TopNavComponent] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, providers: [NavService], imports: [CommonModule,
            ReactiveFormsModule,
            FormsModule,
            A11yModule,
            BidiModule,
            ObserversModule,
            OverlayModule,
            PlatformModule,
            PortalModule,
            CdkStepperModule,
            CdkTableModule,
            MatButtonToggleModule,
            MatCheckboxModule,
            MatChipsModule,
            MatDatepickerModule,
            MatExpansionModule,
            MatGridListModule,
            MatInputModule,
            MatListModule,
            MatMenuModule,
            MatProgressBarModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSlideToggleModule,
            MatSliderModule,
            MatSnackBarModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatNativeDateModule,
            MatIconModule, A11yModule,
            BidiModule,
            ObserversModule,
            OverlayModule,
            PlatformModule,
            PortalModule,
            CdkStepperModule,
            CdkTableModule,
            MatButtonToggleModule,
            MatCheckboxModule,
            MatChipsModule,
            MatDatepickerModule,
            MatExpansionModule,
            MatGridListModule,
            MatInputModule,
            MatListModule,
            MatMenuModule,
            MatProgressBarModule,
            MatRadioModule,
            MatRippleModule,
            MatSelectModule,
            MatSidenavModule,
            MatSlideToggleModule,
            MatSliderModule,
            MatSnackBarModule,
            MatTabsModule,
            MatToolbarModule,
            MatTooltipModule,
            MatNativeDateModule,
            CommonModule,
            ReactiveFormsModule,
            FormsModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DashboardComponent,
                        MenuListItemComponent,
                        TopNavComponent,
                    ],
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        FormsModule,
                        A11yModule,
                        BidiModule,
                        ObserversModule,
                        OverlayModule,
                        PlatformModule,
                        PortalModule,
                        CdkStepperModule,
                        CdkTableModule,
                        MatButtonToggleModule,
                        MatCheckboxModule,
                        MatChipsModule,
                        MatDatepickerModule,
                        MatExpansionModule,
                        MatGridListModule,
                        MatInputModule,
                        MatListModule,
                        MatMenuModule,
                        MatProgressBarModule,
                        MatRadioModule,
                        MatRippleModule,
                        MatSelectModule,
                        MatSidenavModule,
                        MatSlideToggleModule,
                        MatSliderModule,
                        MatSnackBarModule,
                        MatTabsModule,
                        MatToolbarModule,
                        MatTooltipModule,
                        MatNativeDateModule,
                        MatIconModule,
                    ],
                    exports: [
                        DashboardComponent,
                        A11yModule,
                        BidiModule,
                        ObserversModule,
                        OverlayModule,
                        PlatformModule,
                        PortalModule,
                        CdkStepperModule,
                        CdkTableModule,
                        MatButtonToggleModule,
                        MatCheckboxModule,
                        MatChipsModule,
                        MatDatepickerModule,
                        MatExpansionModule,
                        MatGridListModule,
                        MatInputModule,
                        MatListModule,
                        MatMenuModule,
                        MatProgressBarModule,
                        MatRadioModule,
                        MatRippleModule,
                        MatSelectModule,
                        MatSidenavModule,
                        MatSlideToggleModule,
                        MatSliderModule,
                        MatSnackBarModule,
                        MatTabsModule,
                        MatToolbarModule,
                        MatTooltipModule,
                        MatNativeDateModule,
                        CommonModule,
                        ReactiveFormsModule,
                        FormsModule,
                        MenuListItemComponent,
                        TopNavComponent,
                    ],
                    providers: [NavService],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                }]
        }] });

class DashBoardModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: DashBoardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.9", ngImport: i0, type: DashBoardModule, imports: [MaterialModule], exports: [MaterialModule] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: DashBoardModule, imports: [MaterialModule, MaterialModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: DashBoardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        MaterialModule,
                    ],
                    providers: [],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    exports: [MaterialModule],
                }]
        }] });

/*
 * Public API Surface of modal-pop-up
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DashBoardModule, DashboardComponent, MaterialModule, MenuListItemComponent, NavService, TopNavComponent };
//# sourceMappingURL=dashboard-material-ui.mjs.map
