import * as i0 from '@angular/core';
import { NgModule, CUSTOM_ELEMENTS_SCHEMA, Injectable, Component, EventEmitter, Input, Output, ViewChild, NO_ERRORS_SCHEMA, Pipe } from '@angular/core';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i5 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import { MatDialogModule } from '@angular/material/dialog';
import { MatInputModule } from '@angular/material/input';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatCardModule } from '@angular/material/card';
import * as i7 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatSelectModule } from '@angular/material/select';
import { MatIconModule } from '@angular/material/icon';
import * as i6 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import { provideAnimations } from '@angular/platform-browser/animations';
import * as i8 from '@angular/material/radio';
import { MatRadioModule } from '@angular/material/radio';
import * as i4 from '@angular/forms';
import { FormsModule, ReactiveFormsModule, FormGroup, FormArray, FormControl, Validators } from '@angular/forms';
import { OverlayModule } from '@angular/cdk/overlay';
import { BehaviorSubject, debounceTime } from 'rxjs';
import * as i1 from '@angular/platform-browser';

class MaterialModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, imports: [CommonModule,
            MatButtonModule,
            MatDialogModule,
            MatInputModule,
            MatToolbarModule,
            MatCardModule,
            MatCheckboxModule, // Add here
            MatSelectModule,
            MatFormFieldModule,
            MatIconModule,
            MatRadioModule], exports: [MatButtonModule,
            MatDialogModule,
            MatInputModule,
            MatToolbarModule,
            MatCardModule,
            MatCheckboxModule, // Export here
            MatSelectModule,
            MatFormFieldModule,
            MatIconModule,
            MatRadioModule] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, providers: [provideAnimations()], imports: [CommonModule,
            MatButtonModule,
            MatDialogModule,
            MatInputModule,
            MatToolbarModule,
            MatCardModule,
            MatCheckboxModule, // Add here
            MatSelectModule,
            MatFormFieldModule,
            MatIconModule,
            MatRadioModule, MatButtonModule,
            MatDialogModule,
            MatInputModule,
            MatToolbarModule,
            MatCardModule,
            MatCheckboxModule, // Export here
            MatSelectModule,
            MatFormFieldModule,
            MatIconModule,
            MatRadioModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        MatDialogModule,
                        MatInputModule,
                        MatToolbarModule,
                        MatCardModule,
                        MatCheckboxModule, // Add here
                        MatSelectModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatRadioModule
                    ],
                    providers: [provideAnimations()],
                    exports: [
                        MatButtonModule,
                        MatDialogModule,
                        MatInputModule,
                        MatToolbarModule,
                        MatCardModule,
                        MatCheckboxModule, // Export here
                        MatSelectModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatRadioModule
                    ]
                }]
        }] });

class SharedHomeModule {
    ScriptElement;
    JquerySrciptElement;
    constructor() {
        // bootstrap .css add in head
        this.JquerySrciptElement = document.createElement('script');
        this.JquerySrciptElement.src = 'https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js';
        document.body.appendChild(this.JquerySrciptElement);
        // bootstrap script.js add in body
        this.ScriptElement = document.createElement("script");
        this.ScriptElement.src = "https://cdnjs.cloudflare.com/ajax/libs/bootstrap/5.3.0/js/bootstrap.min.js";
        document.body.appendChild(this.ScriptElement);
        // bootstrap .css add in head
        const linkElement = document.createElement('link');
        linkElement.rel = 'stylesheet';
        linkElement.href = 'https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css';
        document.head.appendChild(linkElement);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: SharedHomeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.9", ngImport: i0, type: SharedHomeModule, imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            OverlayModule,
            MaterialModule], exports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            OverlayModule,
            MaterialModule] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: SharedHomeModule, imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            OverlayModule,
            MaterialModule, CommonModule,
            FormsModule,
            ReactiveFormsModule,
            OverlayModule,
            MaterialModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: SharedHomeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        OverlayModule,
                        MaterialModule
                    ],
                    providers: [],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    exports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        OverlayModule,
                        MaterialModule
                    ],
                }]
        }], ctorParameters: () => [] });

class FormControllerService {
    fb;
    activeStepSubject = new BehaviorSubject(1);
    activeStep$ = this.activeStepSubject.asObservable();
    multiStepForm;
    multiStepFormList;
    FORM_CREATE_LIST = [];
    FORM_CREATE_BOOLEAN = false;
    stepDetails = [];
    TitleDescription = [];
    TitleDescriptionId = [];
    get stepForm() {
        return this.multiStepForm;
    }
    constructor(fb) {
        this.fb = fb;
    }
    goToNextStep(number) {
        this.activeStepSubject.next(number + 1);
    }
    goBackToPreviousStep(number) {
        this.activeStepSubject.next(number - 1);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: FormControllerService, deps: [{ token: i4.FormBuilder }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: FormControllerService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: FormControllerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [{ type: i4.FormBuilder }] });

class StepTrackerIconsComponent {
    formService;
    activeStep$;
    constructor(formService) {
        this.formService = formService;
    }
    ngOnInit() {
        this.formService.activeStep$.subscribe(activeStep => this.activeStep$ = activeStep);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: StepTrackerIconsComponent, deps: [{ token: FormControllerService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: StepTrackerIconsComponent, selector: "app-step-tracker-icons", ngImport: i0, template: "<div class=\"step-display\">\r\n  <div *ngFor=\"let step of this.formService.stepDetails;let i=index\" class=\"step\">\r\n    <div class=\"step_number\" [ngClass]=\"{'selected' : this.activeStep$ === step.step}\"> {{step.step}}</div>\r\n    <div class=\"step_details\" (click)=\"this.formService.goToNextStep(this.activeStep$=(i));\">\r\n      <div class=\"step_title\">Step {{step.step}}</div>\r\n      <div class=\"step_description\">{{step.description}}</div>\r\n    </div>\r\n  </div>", styles: [":host{width:100vw;height:11rem;position:relative;top:-1rem;background-size:cover}.step-display{width:11.25rem;height:6.25rem}.step_number{width:2rem;height:2rem;border-radius:50%}.step_number.selected{border:none}.step_details{display:none}\n"], dependencies: [{ kind: "directive", type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: StepTrackerIconsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-step-tracker-icons', template: "<div class=\"step-display\">\r\n  <div *ngFor=\"let step of this.formService.stepDetails;let i=index\" class=\"step\">\r\n    <div class=\"step_number\" [ngClass]=\"{'selected' : this.activeStep$ === step.step}\"> {{step.step}}</div>\r\n    <div class=\"step_details\" (click)=\"this.formService.goToNextStep(this.activeStep$=(i));\">\r\n      <div class=\"step_title\">Step {{step.step}}</div>\r\n      <div class=\"step_description\">{{step.description}}</div>\r\n    </div>\r\n  </div>", styles: [":host{width:100vw;height:11rem;position:relative;top:-1rem;background-size:cover}.step-display{width:11.25rem;height:6.25rem}.step_number{width:2rem;height:2rem;border-radius:50%}.step_number.selected{border:none}.step_details{display:none}\n"] }]
        }], ctorParameters: () => [{ type: FormControllerService }] });

class ProgressionButtonsComponent {
    formService;
    stepForm;
    activeStep$;
    ButtonDisabled = false;
    FormGroupName;
    Condition = false;
    onSubmit = new EventEmitter();
    NextEvent = new EventEmitter();
    BackEvent = new EventEmitter();
    constructor(formService) {
        this.formService = formService;
    }
    ngOnChanges(changes) {
        for (const propName in changes) {
            if (changes.hasOwnProperty(propName)) {
                const change = changes[propName];
                if (change.currentValue !== undefined) {
                    this[propName] = change.currentValue;
                }
            }
        }
    }
    ngOnInit() {
        this.stepForm = this.formService.stepForm;
        this.formService.activeStep$.subscribe(step => this.activeStep$ = step);
    }
    nextStep() {
        this.formService.goToNextStep(this.activeStep$);
        this.NextEvent.emit({ value: this.formService.stepForm, RawValue: this.formService.stepForm?.getRawValue(), index: this.activeStep$ - 1 });
    }
    goBack() {
        this.formService.goBackToPreviousStep(this.activeStep$);
        this.BackEvent.emit({ value: this.formService.stepForm, RawValue: this.formService.stepForm?.getRawValue(), index: this.activeStep$ - 1 });
    }
    confirmAndSubmitForm() {
        this.onSubmit.emit({ value: this.formService.stepForm, RawValue: this.formService.stepForm?.getRawValue(), index: this.activeStep$ });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ProgressionButtonsComponent, deps: [{ token: FormControllerService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: ProgressionButtonsComponent, selector: "app-progression-buttons", inputs: { ButtonDisabled: "ButtonDisabled", FormGroupName: "FormGroupName", Condition: "Condition" }, outputs: { onSubmit: "onSubmit", NextEvent: "NextEvent", BackEvent: "BackEvent" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"container\">\r\n        <button style=\"margin: auto;\r\n        margin-left: 0;\" class=\"btn btn-next\"\r\n                *ngIf=\"activeStep$ > 1 && activeStep$ < (this.formService?.FORM_CREATE_LIST?.length+1)\"\r\n                (click)=\"goBack()\">Go Back</button>\r\n        <button class=\"btn btn-next\" *ngIf=\"activeStep$ < this.formService?.FORM_CREATE_LIST?.length\"\r\n                [disabled]=\"ButtonDisabled\" (click)=\"nextStep()\">Next\r\n                Step</button>\r\n        <button class=\"btn btn-confirm\" *ngIf=\"activeStep$ === this.formService?.FORM_CREATE_LIST?.length\"\r\n                [disabled]=\"ButtonDisabled\" (click)=\"confirmAndSubmitForm()\" type=\"button\">Submit</button>\r\n</div>", styles: [":host{width:100%;position:absolute;bottom:0;z-index:9999999999999;height:4em;right:0}.container{width:100%;display:flex;flex-direction:row;align-items:center;justify-content:space-between;padding:0}.btn-next,.btn-confirm{margin:1rem 0 1rem auto}@media (min-width: 37.5em){:host{width:50.125em;position:absolute;bottom:0;z-index:9999999999999;height:4em;right:0}.container{width:100%;padding:0}.btn-next,.btn-confirm{margin:0 0 0 auto}}\n"], dependencies: [{ kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ProgressionButtonsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-progression-buttons', template: "<div class=\"container\">\r\n        <button style=\"margin: auto;\r\n        margin-left: 0;\" class=\"btn btn-next\"\r\n                *ngIf=\"activeStep$ > 1 && activeStep$ < (this.formService?.FORM_CREATE_LIST?.length+1)\"\r\n                (click)=\"goBack()\">Go Back</button>\r\n        <button class=\"btn btn-next\" *ngIf=\"activeStep$ < this.formService?.FORM_CREATE_LIST?.length\"\r\n                [disabled]=\"ButtonDisabled\" (click)=\"nextStep()\">Next\r\n                Step</button>\r\n        <button class=\"btn btn-confirm\" *ngIf=\"activeStep$ === this.formService?.FORM_CREATE_LIST?.length\"\r\n                [disabled]=\"ButtonDisabled\" (click)=\"confirmAndSubmitForm()\" type=\"button\">Submit</button>\r\n</div>", styles: [":host{width:100%;position:absolute;bottom:0;z-index:9999999999999;height:4em;right:0}.container{width:100%;display:flex;flex-direction:row;align-items:center;justify-content:space-between;padding:0}.btn-next,.btn-confirm{margin:1rem 0 1rem auto}@media (min-width: 37.5em){:host{width:50.125em;position:absolute;bottom:0;z-index:9999999999999;height:4em;right:0}.container{width:100%;padding:0}.btn-next,.btn-confirm{margin:0 0 0 auto}}\n"] }]
        }], ctorParameters: () => [{ type: FormControllerService }], propDecorators: { ButtonDisabled: [{
                type: Input,
                args: ["ButtonDisabled"]
            }], FormGroupName: [{
                type: Input,
                args: ["FormGroupName"]
            }], Condition: [{
                type: Input,
                args: ["Condition"]
            }], onSubmit: [{
                type: Output,
                args: ["onSubmit"]
            }], NextEvent: [{
                type: Output,
                args: ["NextEvent"]
            }], BackEvent: [{
                type: Output,
                args: ["BackEvent"]
            }] } });

class ReactiveJsonFormsService {
    dynamicFormGroup = [];
    model = {};
    SHIPPING_BILL_LIST = [];
    BL_COPY_LIST = [];
    COMMERICAL_NO = [];
    ORM_BY_PARTY_NAME = [];
    ORM_SELECTION_DATA = [];
    BOE_LIST = [];
    CURRENCY_LIST = [];
    BUYER_DETAILS = [];
    BUYER_ADDRESS_DETAILS = [];
    BENEFICIARY_DETAILS = [];
    BENEFICIARY_ADDRESS_DETAILS = [];
    INWARD_REMITTANCE_NAME_LIST = [];
    NEW_INWARD_REMITTANCE_NAME_LIST = [];
    BUYER_REMITTANCE_NAME_LIST = [];
    ConsigneeNameList = [];
    PIPO_DATA = [];
    pipourl1 = '';
    pipoArr = [];
    BUYER_LIST = [];
    CommercialNumber = [];
    COMMERCIAL_LIST = [];
    commerciallist = [];
    SHIPPING_BUNDEL = [];
    SHIPPING_BILL_MASTER_DATA = [];
    SUBMIT_ERROR = false;
    origin = [];
    commodity = [];
    location = [];
    bankDetail = [];
    bankDetail2 = [];
    Id = '';
    BANK_NAME_LIST_GLOABL = [];
    FIELDS_DATA = [];
    LOGIN_TOEKN = '';
    userData = [];
    BUYER_NOT_EXITS = false;
    BENEFICIARY_NOT_EXITS = false;
    SELECTED_PIPO = [];
    SELECTED_PIPO_ID = [];
    ToChargesAccountdata = [];
    ToCreditAccountdata = [];
    BANK_LIST_DROPDOWN = [];
    ORIGANL_BANK_LIST_DROPDOWN = [];
    CommericalNo;
    BUYER_DETAILS_MASTER = [];
    BUYER_DETAILS_DROPDOWN_MASTER = [];
    COMPANY_INFO = [];
    CHECK_BOX_BANK_LIST = [];
    CHECK_BOX_BANK_LIST_CHARGES = [];
    CHECK_BOX_REMITTER_LIST = [];
    REMITTER_LIST = [];
    PIPO_LIST = {
        "Import": [],
        "Export": [],
        "CI_EXPORT": [],
        "CI_IMPORT": []
    };
    ORM_LIST = {
        "Import": [],
        "Export": [],
        "CI_EXPORT": [],
        "CI_IMPORT": []
    };
    DAN_LIST = [];
    PAYMENTS_TEMRS = [];
    PURPOSE_CODE_FILTER_DATA = [];
    PURPOSE_CODE_LIST_DATA = [];
    A2_JSON_DATA = [];
    sumTotalAmount = 0;
    SELECTED_PURPOSE_CODE_DATA = [];
    SELECTED_PURPOSE_CODE_INDEX = [];
    SELECTED_PURPOSE_CODE_DUMP_SLEECTION = [];
    UPLOAD_STATUS = false;
    USER_DATA = [];
    PIPO_TRANSCTION_LIST = [];
    DROP_DOWN_DATA = [];
    ALL_DATA_PURPOSE_CODE = '';
    SELECT_REPORT_TYPE = null;
    ARRAY_LIST_DROP_DOWN_DATA = [];
    HSCODE_FEILD_FORM = {
        id: "",
        form: "",
        fieldName: "",
        OptionfieldIndex: "",
        FormOptionfieldName: "",
        value: "",
        callback: "",
        field: "",
        NewId: ""
    };
    MT102_SUBJECT = '';
    ReferenceNumber = this.getReferenceNumber();
    FORM_VALUE_CHANGES = new BehaviorSubject([]);
    AFTER_BUILD_FORM = new BehaviorSubject([]);
    SUBMIT_FORM = new BehaviorSubject([]);
    BuyerSpecificConsigneeNameList = [];
    ArraySelectOption = [];
    constructor() {
        this.ReferenceNumber = this.getReferenceNumber();
    }
    ResignReferenceNumber() {
        this.ReferenceNumber = this.getReferenceNumber();
    }
    ngOnInit() {
    }
    getReferenceNumber() {
        return (Math.floor((Math.random() + Math.floor(Math.random() * 9) + 1) * Math.pow(10, 8)))?.toString();
    }
    toWords(s) {
        var th = ['', 'thousand', 'million', 'billion', 'trillion'];
        var dg = ['zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine'];
        var tn = ['ten', 'eleven', 'twelve', 'thirteen', 'fourteen', 'fifteen', 'sixteen', 'seventeen', 'eighteen', 'nineteen'];
        var tw = ['twenty', 'thirty', 'forty', 'fifty', 'sixty', 'seventy', 'eighty', 'ninety'];
        s = s.toString();
        s = s.replace(/[\, ]/g, '');
        if (s != parseFloat(s))
            return 'not a number';
        var x = s.indexOf('.');
        if (x == -1)
            x = s.length;
        if (x > 15)
            return 'too big';
        var n = s.split('');
        var str = '';
        var sk = 0;
        for (var i = 0; i < x; i++) {
            if ((x - i) % 3 == 2) {
                if (n[i] == '1') {
                    str += tn[Number(n[i + 1])] + ' ';
                    i++;
                    sk = 1;
                }
                else if (n[i] != 0) {
                    str += tw[n[i] - 2] + ' ';
                    sk = 1;
                }
            }
            else if (n[i] != 0) { // 0235
                str += dg[n[i]] + ' ';
                if ((x - i) % 3 == 0)
                    str += 'hundred ';
                sk = 1;
            }
            if ((x - i) % 3 == 1) {
                if (sk)
                    str += th[(x - i - 1) / 3] + ' ';
                sk = 0;
            }
        }
        if (x != s.length) {
            var y = s.length;
            str += 'point ';
            for (let i = x + 1; i < y; i++)
                str += dg[n[i]] + ' ';
        }
        return str.replace(/\s+/g, ' ')?.toUpperCase();
    }
    BENEFICIARY_DETAILS_LIST = [];
    filterData(data) {
        this.PURPOSE_CODE_FILTER_DATA = this.A2_JSON_DATA.filter((item) => item?.RBI_Purpose_Code.includes(data));
        if (this.PURPOSE_CODE_FILTER_DATA.length == 0 || data == '') {
            this.PURPOSE_CODE_FILTER_DATA = this.A2_JSON_DATA;
        }
    }
    text_array(text) {
        let split_text = text?.indexOf("\n") != -1 ? text?.split('\n') : [text];
        return split_text;
    }
    COMPANY_SELECTED_BANK_DETAILS = [];
    async buildForm(model, id) {
        this.FORM_VALUE_CHANGES[id] = new BehaviorSubject([]);
        return new Promise(async (resolve, reject) => {
            const formGroupFields = await this.getFormControlsFields(model, id);
            this.dynamicFormGroup[id] = await new FormGroup(formGroupFields?.formGroupFields);
            this.FIELDS_DATA[id] = formGroupFields?.fields;
            await this.dynamicFormGroup;
            await resolve(this.dynamicFormGroup);
            this.dynamicFormGroup[id]?.valueChanges.pipe(debounceTime(200))?.subscribe((x) => {
                this.FORM_VALUE_CHANGES[id].next({ status: this.dynamicFormGroup[id]?.status, form: this.dynamicFormGroup[id], value: x, id: id });
            });
            this.AFTER_BUILD_FORM.next({ status: this.dynamicFormGroup[id]?.status, form: this.dynamicFormGroup[id], id: id });
            await this.FIELDS_DATA[id]?.forEach((element) => {
                if (element?.type === "yesnocheckbox") {
                    element?.HideShowInput?.forEach((HideShowInputElement) => {
                        const index = this.FIELDS_DATA[id]?.findIndex((val) => val?.fieldName?.includes(HideShowInputElement?.name));
                        if (index != -1) {
                            if (HideShowInputElement?.status == true) {
                                this.FIELDS_DATA[id][index]['disabled'] = false;
                                this.dynamicFormGroup[id]?.controls[HideShowInputElement?.name]?.enable();
                            }
                            else {
                                this.FIELDS_DATA[id][index]['disabled'] = true;
                                this.dynamicFormGroup[id]?.controls[HideShowInputElement?.name]?.disable();
                            }
                        }
                    });
                }
                if (element?.type === "YesNoRadioButton") {
                    element?.HideShowInput?.forEach((HideShowInputElement) => {
                        const index = this.FIELDS_DATA[id]?.findIndex((val) => val?.fieldName?.includes(HideShowInputElement?.name));
                        if (index != -1) {
                            if (HideShowInputElement?.status == true) {
                                this.FIELDS_DATA[id][index]['disabled'] = false;
                                this.dynamicFormGroup[id]?.controls[HideShowInputElement?.name]?.enable();
                            }
                            else {
                                this.FIELDS_DATA[id][index]['disabled'] = true;
                                this.dynamicFormGroup[id]?.controls[HideShowInputElement?.name]?.disable();
                            }
                        }
                    });
                }
            });
        });
    }
    setBankList(data) {
        this.BANK_NAME_LIST_GLOABL = [];
        setTimeout(() => {
            this.BANK_NAME_LIST_GLOABL = data;
        }, 200);
    }
    async getFormControlsFields(model, formid) {
        const formGroupFields = {};
        const fields = [];
        for (const field of Object.keys(model)) {
            const fieldProps = model[field];
            if (fieldProps?.type === "formArray") {
                const tempFormGroup = this.createFormArray(fieldProps, formid, field);
                formGroupFields[field] = await tempFormGroup.array;
                fieldProps['NewformGroup'] = tempFormGroup.fields;
                fieldProps['RemoveListIndex'] = [{ START_INDEX: -1, LAST_INDEX: -1 }];
                fields.push({ ...fieldProps, fieldName: field });
            }
            else if (fieldProps?.type === "formGroup" && fieldProps?.formArray) {
                fieldProps['NewFromGroup'] = [];
                fieldProps?.formArray?.forEach((element) => {
                    fieldProps['NewFromGroup'].push({ FromGroupObj: element });
                });
                const nestedGroupControls = this.createNestedFormGroups(fieldProps, formid);
                formGroupFields[field] = await new FormArray(nestedGroupControls);
                fields.push({ ...fieldProps, fieldName: field });
            }
            else {
                formGroupFields[field] = this.createFormControl(fieldProps, formid, field);
                fields.push({ ...fieldProps, fieldName: field });
            }
        }
        return { formGroupFields, fields };
    }
    // Helper Functions
    createFormArray(fieldProps, formid, field) {
        const tempFormGroup = [];
        const fields = [];
        for (const element of fieldProps.formGroup) {
            for (const field of Object.keys(element)) {
                const control = new FormControl({
                    value: element[field]?.value || "",
                    disabled: element[field]?.disabled !== undefined,
                }, this.setRequired(element[field]?.minLength, element[field]?.maxLength, element[field]?.rules, formid, field)[element[field]?.type || element[field]?.typeOf]);
                tempFormGroup.push(control);
                fields.push({ ...element[field], fieldName: field });
            }
        }
        return { array: new FormArray(tempFormGroup), fields };
    }
    createNestedFormGroups(fieldProps, formid) {
        return fieldProps.formArray?.map((element) => {
            const optionControls = element.reduce((controls, formArrayElement) => {
                formArrayElement['fieldName'] = formArrayElement?.name;
                controls[formArrayElement?.name] = this.createFormControl(formArrayElement, formid, formArrayElement);
                return controls;
            }, {});
            return new FormGroup(optionControls);
        }) || [];
    }
    createFormControl(fieldProps, formid, field) {
        return new FormControl({
            value: fieldProps.value,
            disabled: fieldProps.disabled !== undefined,
        }, this.setRequired(fieldProps.minLength, fieldProps.maxLength, fieldProps.rules, formid, field)[fieldProps.type || fieldProps.typeOf]);
    }
    async addNewFormArray(id, index, fieldName) {
        // Reference to the last entry in the formArray
        const lastIndex = this.FIELDS_DATA[id][index]['formArray']?.length - 1;
        const ArraylastFormData = this.FIELDS_DATA[id][index]['formArray'][lastIndex];
        this.FIELDS_DATA[id][index]?.formArray?.push(ArraylastFormData);
        this.FIELDS_DATA[id][index]['NewFromGroup']?.push({ FromGroupObj: ArraylastFormData });
        const newLabel = this.FIELDS_DATA[id][index].GroupLabel[0]?.replace('1', (this.FIELDS_DATA[id][index].GroupLabel.length + 1).toString());
        const formArray = this.dynamicFormGroup[id]?.get(fieldName);
        formArray.push(this.createNestedFormGroups({ formArray: [ArraylastFormData] }, id)[0]);
        await this.FIELDS_DATA[id][index].GroupLabel.push(newLabel);
    }
    removeNewFormArray(id, index, fieldName, optionIndex) {
        const formArray = this.dynamicFormGroup[id]?.get(fieldName);
        if (formArray.length > 1) {
            formArray.removeAt(optionIndex);
            this.FIELDS_DATA[id][index]['NewFromGroup']?.splice(optionIndex, 1);
            this.FIELDS_DATA[id][index].formArray.splice(optionIndex, 1);
            this.FIELDS_DATA[id][index].GroupLabel.splice(optionIndex, 1);
        }
    }
    ControlSetValue(id, key, value) {
        this.FIELDS_DATA[id]?.[key]?.setValue(value);
    }
    setValueFromArray(id, form, fieldName, OptionfieldIndex, FormOptionfieldName, value, callback = undefined, field = undefined) {
        const myForm = form?.controls[fieldName];
        let currentVal = value;
        myForm.value[OptionfieldIndex][FormOptionfieldName] = currentVal;
        myForm?.controls[OptionfieldIndex]?.controls[FormOptionfieldName]?.setValue(currentVal);
        myForm['touched'] = true;
        myForm['status'] = 'VALID';
        this.dynamicFormGroup[id].get(fieldName).clearValidators();
        this.dynamicFormGroup[id].get(fieldName).updateValueAndValidity();
        if (callback != undefined && callback != null) {
            callback({ id: id, form: form, fieldName: fieldName, OptionfieldIndex: OptionfieldIndex, FormOptionfieldName: FormOptionfieldName, value: value, dynamicFormGroup: this.dynamicFormGroup[id], field: this.FIELDS_DATA[id] });
        }
    }
    setValueFrom(id, form, fieldName, value, callback = undefined, field = undefined) {
        const myForm = form?.controls[fieldName];
        let currentVal = value;
        myForm?.setValue(currentVal);
        myForm['touched'] = true;
        myForm['status'] = 'VALID';
        this.dynamicFormGroup[id].get(fieldName).clearValidators();
        this.dynamicFormGroup[id].get(fieldName).updateValueAndValidity();
        if (callback != undefined && callback != null) {
            callback({ id: id, form: form, fieldName: fieldName, value: value, dynamicFormGroup: this.dynamicFormGroup[id], field: field });
        }
    }
    setValueFromChildArray(id, form, ParentfieldName, FormArrayfieldName, OptionfieldIndex, ChildOptionfieldName, ChildOptionfieldIndex, FormOptionfieldName, value, callback = undefined, field = undefined) {
        const myForm = form?.controls[ParentfieldName];
        let currentVal = value;
        myForm.value[OptionfieldIndex][FormOptionfieldName][ChildOptionfieldIndex][ChildOptionfieldName] = currentVal;
        myForm?.controls[OptionfieldIndex]?.controls[FormOptionfieldName]?.setValue(currentVal);
        myForm['touched'] = true;
        myForm['status'] = 'VALID';
        this.dynamicFormGroup[id].get(FormArrayfieldName).clearValidators();
        this.dynamicFormGroup[id].get(FormArrayfieldName).updateValueAndValidity();
        if (callback != undefined && callback != null) {
            callback({ id: id, form: form, fieldName: FormArrayfieldName, OptionfieldIndex: OptionfieldIndex, FormOptionfieldName: FormOptionfieldName, value: value, dynamicFormGroup: this.dynamicFormGroup[id], field: this.FIELDS_DATA[id] });
        }
    }
    ConfirmedValidator(controlName, matchingControlName) {
        return (formGroup) => {
            const control = formGroup.controls[controlName];
            const matchingControl = formGroup.controls[matchingControlName];
            if (matchingControl?.errors && !matchingControl?.errors?.confirmedValidator) {
                return;
            }
            if (control.value !== matchingControl.value) {
                matchingControl.setErrors({ confirmedValidator: true });
            }
            else {
                matchingControl.setErrors(null);
            }
        };
    }
    setRequired(minLength, maxLength, rule, formid, field) {
        const baseValidators = [
            minLength !== undefined ? Validators.minLength(minLength) : Validators.minLength(0),
            maxLength !== undefined ? Validators.maxLength(maxLength) : Validators.maxLength(100)
        ];
        const requiredValidator = rule?.required ? [Validators.required] : [];
        const combinedValidators = (type) => {
            return [...requiredValidator, ...baseValidators, ...(field?.Validator || [])];
        };
        const validatorsMap = {
            text: combinedValidators('text'),
            textarea: combinedValidators('textarea'),
            date: combinedValidators('date'),
            datetime: combinedValidators('datetime'),
            time: combinedValidators('time'),
            Address: combinedValidators('Address'),
            number: combinedValidators('number'),
            Amount: combinedValidators('Amount'),
            OnlyNumber: combinedValidators('OnlyNumber'),
            TextValiadtion: [...combinedValidators('TextValiadtion'), hasAmountLessThanForm(field?.EqualName, field?.errormsg)],
            TextGreaterValiadtion: [...combinedValidators('TextGreaterValiadtion'), hasAmountGreaterThanForm(field?.EqualName, field?.errormsg)],
            buyer: requiredValidator,
            ArrayCheckbox: requiredValidator,
            CompanyBankList: requiredValidator,
            MultipleMatCheckBox: requiredValidator,
            YesNoRadioButton: requiredValidator,
            BuyerRemitter: requiredValidator,
            AddSignature: requiredValidator,
            AddressInfo: requiredValidator,
            AxisBankMultiCheckBox: requiredValidator,
            MultiCheckBoxSelectionOption: requiredValidator,
            Newbuyer: requiredValidator,
            ReUpload: requiredValidator,
            DropDown: requiredValidator,
            button: requiredValidator,
            checkbox: requiredValidator,
            ArraySelectOption: requiredValidator,
            PURPOSE_CODE: requiredValidator,
            CheckboxMultiple: requiredValidator,
            SelectOption: requiredValidator,
            BankAdd: requiredValidator,
            RemitterCheckBox: requiredValidator,
            ShippingBill: requiredValidator,
            BankCheckBox: requiredValidator,
            ImagesList: requiredValidator,
            consignee: requiredValidator,
            BuyerSpecificConsignee: requiredValidator,
            commodity: requiredValidator,
            commodityadd: requiredValidator,
            origin: requiredValidator,
            location: requiredValidator,
            PaymentType: requiredValidator,
            Bank: requiredValidator,
            BankList: requiredValidator,
            currency: requiredValidator,
            CommericalNo: requiredValidator,
            typedocument: requiredValidator,
            PaymentTermType: requiredValidator,
            undefined: requiredValidator,
            MatchedValue: requiredValidator,
            Underlying: requiredValidator,
            BuySell: requiredValidator,
            IncoTerm: requiredValidator,
            MultiCheckBox: requiredValidator,
            OptionMultiCheckBox: requiredValidator,
            RemitterName: requiredValidator,
            formGroup: requiredValidator,
            benne: requiredValidator,
            CommericalListCheckBox: requiredValidator,
            BLCopy: requiredValidator,
            yesnocheckbox: requiredValidator,
            ArrayList: requiredValidator,
            ArrayList_Object: requiredValidator,
            InputButton: combinedValidators('InputButton'),
            BOE: requiredValidator,
            ORM_SELECTION: requiredValidator,
            LABLE_CHECKBOX: requiredValidator,
            EmailButton: requiredValidator,
            NumberButton: requiredValidator,
            AdvanceInfo: [],
            NotRequired: [],
            CallbackButton: [],
            LabelShow: [],
            OnlyLabelShow: [],
            SB_DETAILS_SHOW: [],
            ALPHA_NUMERIC: [
                ...combinedValidators('ALPHA_NUMERIC'),
                alphaNumericValidator
            ],
            email: combinedValidators('email'),
            password: combinedValidators('password'),
            confirmPassword: [
                ...combinedValidators('confirmPassword'),
                hasDuplicateControl({ key: 'confirmPassword', equalkey: 'password' }, this.dynamicFormGroup, formid)
            ],
        };
        return validatorsMap;
    }
    removeRequiredValidator(condition, id, fieldName) {
        const emailControl = this.dynamicFormGroup[id].get(fieldName);
        if (emailControl) {
            if (condition) {
                emailControl.setValidators([Validators.required]);
            }
            else {
                emailControl.clearValidators();
            }
            emailControl.updateValueAndValidity();
        }
    }
    valueChangesSpecficeName(id, fieldName) {
        return this.dynamicFormGroup[id].get(fieldName)?.valueChanges;
    }
    removeDuplicates(data, key) {
        let newArray = [];
        let uniqueObject = {};
        for (let i in data) {
            let objTitle = data[i][key];
            uniqueObject[objTitle] = data[i];
        }
        for (let i in uniqueObject) {
            newArray.push(uniqueObject[i]);
        }
        return newArray;
    }
    max_length_validator(id, fieldName) {
        if ((this.dynamicFormGroup[id]?.controls[fieldName]?.value?.length > this.dynamicFormGroup[id]?.controls[fieldName]?.errors?.['maxlength']?.requiredLength)) {
            return false;
        }
        return true;
    }
    max_length_validatorFormArray(id, formGroupKey, index, fieldName) {
        if ((this.dynamicFormGroup[id]?.controls[formGroupKey]?.controls[index]?.controls[fieldName]?.value?.length > this.dynamicFormGroup[id]?.controls[formGroupKey]?.controls[index]?.controls[fieldName]?.errors?.['maxlength']?.requiredLength)) {
            return false;
        }
        return true;
    }
    counter = 0;
    buildNewFormArray(field, index, element, formid, GroupLabel, MAX_LIMIT) {
        return new Promise(async (resolve, reject) => {
            this.counter = GroupLabel.length + 1;
            var temp = [];
            var tempFormGroup = [];
            let count = this.FIELDS_DATA[formid][index]['NewformGroup'].length;
            let count1 = this.FIELDS_DATA[formid][index]['NewformGroup'].length;
            for (let field2 of Object.keys(element)) {
                temp.push({ ...element[field2], fieldName: field2, index: count });
                this.FIELDS_DATA[formid][index]['NewformGroup'].push({ ...element[field2], fieldName: field2, index: count });
                tempFormGroup.push(new FormGroup({
                    [field2]: new FormControl({ value: element[field2]?.value || "", disabled: element[field2]?.disabled != undefined ? true : false }, this.setRequired(element[field2]?.minLength, element[field2]?.maxLength, element[field2]?.rules, formid, field2)[element[field2]?.typeOf != undefined ? element[field2]?.typeOf : element[field2]?.type])
                }));
                count++;
            }
            await this.FIELDS_DATA[formid][index]['formGroup'].push({ ...this.FIELDS_DATA[formid][index]['formGroup'][0], fieldName: field });
            await this.FIELDS_DATA[formid][index]['RemoveListIndex'].push({ START_INDEX: count1, LAST_INDEX: count1 + MAX_LIMIT?.MAX_LIMIT });
            await GroupLabel.push(GroupLabel[0].replace('1', GroupLabel?.length + 1));
            await resolve(await tempFormGroup);
        });
    }
    emptyvalue(data) {
        var temp = {};
        for (const key in data) {
            temp[key] = '';
        }
        return temp;
    }
    removeFormArray(formGroupKey, index, labelIndex, formid, MAX_LIMIT) {
        return new Promise(async (resolve, reject) => {
            if (index != 0) {
                let indexstore = this.FIELDS_DATA[formid][index]['RemoveListIndex'][labelIndex];
                for (var i = indexstore?.LAST_INDEX; i-- > indexstore?.START_INDEX;) {
                    this.dynamicFormGroup[formid]?.controls[formGroupKey]?.removeAt(i);
                }
                await this.FIELDS_DATA[formid][index]['formGroup']?.splice(labelIndex, 1);
                await this.FIELDS_DATA[formid][index]['GroupLabel']?.splice(labelIndex, 1);
                for (let i = indexstore?.LAST_INDEX - 1; i >= indexstore?.START_INDEX; i--) {
                    this.FIELDS_DATA[formid][index]['NewformGroup']?.splice(i, 1);
                }
                for (let i = this.FIELDS_DATA[formid][index]['RemoveListIndex']?.length - 1; i >= labelIndex; i--) {
                    this.FIELDS_DATA[formid][index]['RemoveListIndex']?.splice(i, 1);
                }
                if (indexstore?.START_INDEX != MAX_LIMIT?.MAX_LIMIT) {
                    this.FIELDS_DATA[formid][index]['NewformGroup']?.forEach((element, index) => {
                        element['index'] = index;
                    });
                    this.FIELDS_DATA[formid][index]['GroupLabel']?.forEach((element, i) => {
                        let tempelement = this.FIELDS_DATA[formid][index]['GroupLabel'][0]?.replace('1', '');
                        this.FIELDS_DATA[formid][index]['GroupLabel'][i] = tempelement + ' ' + (i + 1);
                    });
                    this.removeIndexUpdate(this.FIELDS_DATA[formid][index]['RemoveListIndex'], MAX_LIMIT?.MAX_LIMIT);
                }
            }
            await resolve('');
        });
    }
    removeIndexUpdate(data, MAX_LIMIT) {
        data?.forEach((element) => {
            for (const key in element) {
                if (element?.START_INDEX != MAX_LIMIT && element?.START_INDEX != -1) {
                    element[key] = element[key] - MAX_LIMIT;
                }
            }
        });
    }
    removeUpdateFormValue(data, MAX_LIMIT) {
        data?.forEach((element) => {
            for (const key in element) {
                if (element?.START_INDEX != MAX_LIMIT && element?.START_INDEX != -1) {
                    element[key] = element[key] - MAX_LIMIT;
                }
            }
        });
    }
    setInputVisibilty(formid, index, key, value) {
        this.FIELDS_DATA[formid][index][key] = value;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ReactiveJsonFormsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ReactiveJsonFormsService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ReactiveJsonFormsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });
function hasDuplicateFormArray(data) {
    return (formArray) => {
        if (formArray?.controls?.[data?.index]?.controls?.[data?.key]?.value != formArray?.controls?.[data?.equalindex]?.controls?.[data?.equalkey]?.value) {
            formArray?.controls?.[data?.equalindex]?.controls?.[data?.equalkey]?.setErrors({ matched: data?.errormsg });
            return null;
        }
        else {
            return null;
        }
    };
}
function hasAmountLessThanFormArray(control) {
    const ALPHA_NUMERIC_REGEX = /^[a-zA-Z0-9_]*$/;
    const ALPHA_NUMERIC_VALIDATION_ERROR = { alphaNumericError: 'only alpha numeric values are allowed' };
    return ALPHA_NUMERIC_REGEX.test(control.value) ? null : ALPHA_NUMERIC_VALIDATION_ERROR;
}
function hasAmountLessThanForm(equals, Message) {
    return (control) => {
        const equalsField = control.root.get(equals);
        if (equalsField) {
            if (parseFloat(control.value) <= parseFloat(equalsField?.value)) {
                return null;
            }
            else {
                return { matched: Message };
            }
        }
        return null;
    };
}
function hasAmountGreaterThanForm(equals, Message) {
    return (control) => {
        const equalsField = control.root.get(equals);
        if (equalsField) {
            if (parseFloat(control.value) >= parseFloat(equalsField?.value)) {
                return null;
            }
            else {
                return { matched: Message };
            }
        }
        return null;
    };
}
function hasAmountGreaterThanFormArray(control) {
    const ALPHA_NUMERIC_REGEX = /^[a-zA-Z0-9_]*$/;
    const ALPHA_NUMERIC_VALIDATION_ERROR = { alphaNumericError: 'only alpha numeric values are allowed' };
    return ALPHA_NUMERIC_REGEX.test(control.value) ? null : ALPHA_NUMERIC_VALIDATION_ERROR;
}
function RemoveValidator() {
    return (formArray) => {
        return null;
    };
}
function hasDuplicateControl(data, forms, id) {
    return (formArray) => {
        if (forms[id] != undefined) {
            if (forms[id]?.controls[data?.key] != undefined && forms[id]?.controls[data?.equalkey] != undefined) {
                if (forms[id]?.controls[data?.key]?.value != forms[id]?.controls[data?.equalkey]?.value) {
                    return { matched: 'Password and Confirm Password must be match.' };
                }
                else {
                    return null;
                }
            }
            else {
                return null;
            }
        }
        else {
            return null;
        }
    };
}
function alphaNumericValidator(control) {
    const ALPHA_NUMERIC_REGEX = /^[a-zA-Z0-9_]*$/;
    const ALPHA_NUMERIC_VALIDATION_ERROR = { alphaNumericError: 'only alpha numeric values are allowed' };
    return ALPHA_NUMERIC_REGEX.test(control.value) ? null : ALPHA_NUMERIC_VALIDATION_ERROR;
}
function alphaValidator(control) {
    const ALPHA_REGEX = /^[a-zA-Z_]*$/;
    const ALPHA_VALIDATION_ERROR = { alphaError: 'only alphabets values are allowed' };
    return ALPHA_REGEX.test(control.value) ? null : ALPHA_VALIDATION_ERROR;
}
function EmailValidator(control) {
    const EMAIL_REGEX = /^[a-z0-9._%+-]+@[a-z0-9.-]+\\.[a-z]{2,4}$/;
    const EMAIL_VALIDATION_ERROR = { emailError: 'Please insert/enter a valid email address.' };
    return EMAIL_REGEX.test(control.value) ? null : EMAIL_VALIDATION_ERROR;
}
function PasswordValidator(control) {
    const EMAIL_REGEX = /^[a-z0-9._%+-]+@[a-z0-9.-]+\\.[a-z]{2,4}$/;
    const EMAIL_VALIDATION_ERROR = { emailError: 'Please insert/enter a valid email address.' };
    return EMAIL_REGEX.test(control.value) ? null : EMAIL_VALIDATION_ERROR;
}
function ConfirmedValidator(controlName, matchingControlName) {
    return (formGroup) => {
        const control = formGroup.controls[controlName];
        const matchingControl = formGroup.controls[matchingControlName];
        if (matchingControl?.errors && !matchingControl?.errors?.confirmedValidator) {
            return;
        }
        if (control.value !== matchingControl.value) {
            matchingControl.setErrors({ confirmedValidator: 'Password and Confirm Password must be match.' });
        }
        else {
            matchingControl.setErrors(null);
        }
    };
}
// PasswordStrengthValidator
const PasswordStrengthValidator = function (control) {
    let value = control.value || '';
    if (!value) {
        return null;
    }
    let upperCaseCharacters = /[A-Z]+/g;
    if (upperCaseCharacters.test(value) === false) {
        return { passwordStrength: `text has to contine Upper case characters,current value ${value}` };
    }
    let lowerCaseCharacters = /[a-z]+/g;
    if (lowerCaseCharacters.test(value) === false) {
        return { passwordStrength: `text has to contine lower case characters,current value ${value}` };
    }
    let numberCharacters = /[0-9]+/g;
    if (numberCharacters.test(value) === false) {
        return { passwordStrength: `text has to contine number characters,current value ${value}` };
    }
    let specialCharacters = /[!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?]+/;
    if (specialCharacters.test(value) === false) {
        return { passwordStrength: `text has to contine special character,current value ${value}` };
    }
    return null;
};

class InnerDynamicErrorComponent {
    formName;
    fieldName;
    SUBMIT_ERROR = false;
    ErrorMessage = '';
    constructor() { }
    ngOnInit() {
    }
    get getMessage() {
        return this.ErrorMessage ?? this.fieldName + ` should contain ${this.formName?.controls[this.fieldName]?.errors?.['minlength']?.requiredLength} digits only`;
    }
    get getNormalMessage() {
        return this.ErrorMessage ?? ` Please enter the details.`;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: InnerDynamicErrorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: InnerDynamicErrorComponent, isStandalone: true, selector: "inner-dynamic-error", inputs: { formName: "formName", fieldName: "fieldName", SUBMIT_ERROR: "SUBMIT_ERROR", ErrorMessage: "ErrorMessage" }, ngImport: i0, template: "<div *ngIf=\"formName?.controls[fieldName]?.invalid && (formName?.controls[fieldName]?.dirty || formName?.controls[fieldName]?.touched || this.SUBMIT_ERROR==true)\"\r\n    class=\"alert alert-danger\">\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['required']\">\r\n        {{getNormalMessage}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['errorMessageStatus']==true\">\r\n        {{formName?.controls[fieldName]?.errors?.['errorMessage']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['matched']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['matched']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['alphaNumericError']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['alphaNumericError']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['alphaError']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['alphaError']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['emailError']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['emailError']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['minlength']\">\r\n        {{getMessage}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['maxlength']\">\r\n        {{fieldName}} should contain {{formName?.controls[fieldName]?.errors?.['maxlength']?.requiredLength}} digits only.\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['forbiddenName']\">\r\n        {{fieldName}} cannot be Bob.\r\n    </p>\r\n</div>", styles: [".alert-danger{width:90%!important;padding:0;background:transparent!important;border:0!important;margin:auto auto auto 10px}.alert-danger p{margin-top:0;margin-bottom:0!important}\n"], dependencies: [{ kind: "ngmodule", type: SharedHomeModule }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: InnerDynamicErrorComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [SharedHomeModule], selector: 'inner-dynamic-error', template: "<div *ngIf=\"formName?.controls[fieldName]?.invalid && (formName?.controls[fieldName]?.dirty || formName?.controls[fieldName]?.touched || this.SUBMIT_ERROR==true)\"\r\n    class=\"alert alert-danger\">\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['required']\">\r\n        {{getNormalMessage}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['errorMessageStatus']==true\">\r\n        {{formName?.controls[fieldName]?.errors?.['errorMessage']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['matched']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['matched']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['alphaNumericError']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['alphaNumericError']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['alphaError']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['alphaError']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['emailError']!=undefined\">\r\n        {{formName?.controls[fieldName]?.errors?.['emailError']}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['minlength']\">\r\n        {{getMessage}}\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['maxlength']\">\r\n        {{fieldName}} should contain {{formName?.controls[fieldName]?.errors?.['maxlength']?.requiredLength}} digits only.\r\n    </p>\r\n    <p *ngIf=\"formName?.controls[fieldName]?.errors?.['forbiddenName']\">\r\n        {{fieldName}} cannot be Bob.\r\n    </p>\r\n</div>", styles: [".alert-danger{width:90%!important;padding:0;background:transparent!important;border:0!important;margin:auto auto auto 10px}.alert-danger p{margin-top:0;margin-bottom:0!important}\n"] }]
        }], ctorParameters: () => [], propDecorators: { formName: [{
                type: Input
            }], fieldName: [{
                type: Input
            }], SUBMIT_ERROR: [{
                type: Input,
                args: ['SUBMIT_ERROR']
            }], ErrorMessage: [{
                type: Input,
                args: ['ErrorMessage']
            }] } });

class MoreContentComponent {
    constructor() { }
    ngOnInit() {
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MoreContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: MoreContentComponent, isStandalone: true, selector: "more-content", ngImport: i0, template: "<ng-content></ng-content>", styles: [""], dependencies: [{ kind: "ngmodule", type: SharedHomeModule }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: MoreContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'more-content', standalone: true, imports: [SharedHomeModule], template: "<ng-content></ng-content>" }]
        }], ctorParameters: () => [] });

class JsonReactiveComponents {
    sanitizer;
    validator;
    SUBMIT_ERROR = false;
    label = '';
    labelStyle = '';
    FormStyle = '';
    MainStyle = '';
    DetailsShow = true;
    id = '';
    SubmitButtonStyle = '';
    ButtonPanelStyle = '';
    CancelRoute = '';
    TypeOfValue = 'Normal';
    SubmitName = 'Submit';
    AddNewRequried = false;
    OnSubmitEvent = new EventEmitter();
    AddNewBank = new EventEmitter();
    RawValue = new EventEmitter();
    BankEvent = new EventEmitter();
    SelectionBank = new EventEmitter();
    YesNoCheckBoxEvent = new EventEmitter();
    SHIPPING_BILL_EVENT = new EventEmitter();
    CommericalNoEvent = new EventEmitter();
    AddButton = new EventEmitter();
    BL_COPY_EVENT = new EventEmitter();
    BENEFICIARY_EVENT = new EventEmitter();
    BUYER_BENEE_EVENT = new EventEmitter();
    PIPO_EVENT = new EventEmitter();
    HIDE_BACKGROUND = true;
    HIDE_SUBMIT_BUTTON = true;
    KEY_ENTER_ENABLED = false;
    ADD_NEW_BUTTON_VISIBLE = false;
    BuyerNotFound;
    BeneficiaryNotFound;
    morecontent = false;
    BUTTON_PANEL_SHOW = false;
    BUTTON_PANEL_HIDE = true;
    SubmitButtonDisabled = false;
    ResetForm = true;
    DropDownEvent = new EventEmitter();
    ArrayList_ObjectEvent = new EventEmitter();
    FormValueChanges = new EventEmitter();
    CancelEvent = new EventEmitter();
    ErrorMessageData;
    Account_Type = [{
            type: 'OD-over draft'
        }, {
            type: 'CC-cash credit'
        }, {
            type: 'CA-Current account'
        }, {
            type: 'EEFC - Exchange earner Foreign currency'
        }, {
            type: 'PCFC- packing credit Foreign currency'
        }, {
            type: 'EBRD- Bill discounting account'
        }];
    LOGIN_TOEKN = '';
    POPUP_VISIBLILTY = {
        BuyerNotFound: '',
        BeneficiaryNotFound: ''
    };
    HS_CODE_DATA = [];
    NEW_STATIC_PURPOSE_CODE_LIST = [];
    NEW_PURPOSE_CODE_LIST = [];
    PAGINATE_DATA = [];
    PAGINATOR_DATA = [];
    PURPOSE_CODE_DROPDOWN_DATA = [];
    PURPOSE_GROUP_NAME_DROPDOWN_DATA = [];
    constructor(sanitizer, validator) {
        this.sanitizer = sanitizer;
        this.validator = validator;
    }
    ngOnInit() { }
    paginate(items, page = 1, perPage = 10) {
        const offset = perPage * (page - 1);
        const totalPages = Math.ceil(items.length / perPage);
        const paginatedItems = items.slice(offset, perPage * page);
        return {
            previousPage: page - 1 ? page - 1 : null,
            nextPage: (totalPages > page) ? page + 1 : null,
            total: items.length,
            totalPages: totalPages,
            items: paginatedItems
        };
    }
    ;
    PAGINATION_EVENT(event) {
        let START_INDEX = (10 * event?.pageIndex);
        let END_INDEX = START_INDEX + 10;
        this.FILTER_HS_CODE_DATA = [];
        for (let index = START_INDEX; index < END_INDEX; index++) {
            this.FILTER_HS_CODE_DATA.push(this.HS_CODE_DATA[index]);
        }
    }
    get onClickButton() {
        $('.submit-button#' + this.id).click();
        return "";
    }
    get resetForm() {
        this.validator.FIELDS_DATA[this.id]?.forEach((element) => {
            element['value'] = '';
            this.validator.dynamicFormGroup[this.id]?.controls[element?.fieldName]?.setValue("");
        });
        return this.validator.dynamicFormGroup[this.id]?.reset();
    }
    onSubmit(event, e, type = '') {
        console.log(e, "OnSubmitEvent");
        event.preventDefault();
        if (e?.status == 'VALID') {
            this.OnSubmitEvent.emit(e);
            this.SUBMIT_ERROR = false;
        }
        else {
            this.RawValue.emit(false);
            this.SUBMIT_ERROR = true;
        }
    }
    get getRawValue() {
        return this.validator.dynamicFormGroup[this.id]?.getRawValue();
    }
    dumpFunc(value, callback) {
        if (callback != undefined) {
            callback(value);
        }
    }
    get geForm() {
        return this.validator.dynamicFormGroup[this.id];
    }
    setFormValue(value, index, name1, name2) {
        if (typeof value == "object") {
            let sumofstring = "";
            for (const key in value) {
                const element = value[key];
                sumofstring += element + ',';
            }
            this.validator.dynamicFormGroup[this.id]?.controls[name1]?.controls[index]?.controls[name2]?.setValue(sumofstring);
        }
        else {
            this.validator.dynamicFormGroup[this.id]?.controls[name1]?.controls[index]?.controls[name2]?.setValue(value);
        }
    }
    setValue(value, name1) {
        if (name1 != null && name1 != undefined && name1 != '') {
            this.validator.dynamicFormGroup[this.id]?.controls[name1]?.setValue(value);
            this.validator.dynamicFormGroup[this.id].value[name1] = (value);
            this.validator.dynamicFormGroup[this.id].controls[name1]['touched'] = true;
        }
    }
    addFormArray(key1, index, data, GroupLabel) {
        this.validator.buildNewFormArray(key1, index, data['formGroup'][0], this.id, GroupLabel, data).then((res) => {
            res?.forEach((element) => {
                this.validator.dynamicFormGroup[this.id]?.controls[key1].push(element);
            });
        });
    }
    removeFormArray(key1, index, labelIndex, data, data2 = {}) {
        this.validator.removeFormArray(key1, index, labelIndex, this.id, data).then((res) => { });
    }
    AUTOFILL_INPUT_NAME_LIST = [];
    ORM_SELECTION(event, index, data, AUTOFILL_INPUT_NAME_LIST, type = 'Normal') {
        if (event.target.checked) {
            this.validator.ORM_SELECTION_DATA.push(data);
            if (type == "Normal") {
                AUTOFILL_INPUT_NAME_LIST.forEach((element) => {
                    this.validator.dynamicFormGroup[this.id]?.controls[element?.input]?.setValue(this.validator.ORM_SELECTION_DATA[element?.key]);
                });
                if (this.CALLBACK != undefined && this.CALLBACK != null && this.CALLBACK != '') {
                    this.CALLBACK({ form: this.validator.dynamicFormGroup[this.id], AUTOFILL_INPUT_NAME_LIST: AUTOFILL_INPUT_NAME_LIST, FIELDS_DATA: this.field });
                }
            }
            else if (type == "formGroup") {
                AUTOFILL_INPUT_NAME_LIST.forEach((element) => {
                    this.validator.dynamicFormGroup[this.id]?.controls[element?.parent]?.controls[0]?.controls[element?.input]?.setValue(this.validator.ORM_SELECTION_DATA[element?.key]);
                });
            }
            if (this.CALLBACK != undefined && this.CALLBACK != null && this.CALLBACK != '') {
                this.CALLBACK({ form: this.validator.dynamicFormGroup[this.id], AUTOFILL_INPUT_NAME_LIST: AUTOFILL_INPUT_NAME_LIST, FIELDS_DATA: this.field });
            }
        }
        else {
            this.validator.ORM_SELECTION_DATA.splice(index, 1);
            event.target.checked = false;
        }
    }
    CALLBACK = null;
    field = null;
    dump(data, callback = null, field = null) {
        this.AUTOFILL_INPUT_NAME_LIST = data;
        this.CALLBACK = callback;
        this.field = field;
    }
    autofillCommerical(Commericaldata, AUTOFILL_INPUT_NAME_LIST) {
        AUTOFILL_INPUT_NAME_LIST.forEach((element) => {
            this.validator.dynamicFormGroup[this.id]?.controls[element?.name]?.controls[element?.index]?.controls[element?.input]?.setValue(Commericaldata?.data[element?.key]);
        });
    }
    CreateFormBank() {
        setTimeout(() => {
            this.validator.buildForm({
                BankName: {
                    type: "text",
                    value: "",
                    label: "Bank Name",
                    placeholderText: 'Bank Name',
                    rules: {
                        required: true,
                    },
                    maxLength: 200
                },
            }, 'AddNewBankName');
        }, 200);
    }
    addNewBank(e, panel) {
    }
    onAddNewBank() {
        this.AddNewBank.emit(true);
    }
    initialName(words) {
        'use strict';
        return words
            .replace(/\b(\w)\w+/g, '$1_')
            .replace(/\s/g, '')
            .replace(/\.$/, '')
            .toUpperCase();
    }
    removeAllSpecialChar(string) {
        return string?.replace(/[^a-zA-Z ]/g, "");
    }
    ngAfterViewInit() {
    }
    callbackFunction(value, callback = undefined) {
        if (callback != undefined) {
            callback(value);
        }
    }
    toggleRequiredValidator(condition, id) {
        const emailControl = this.validator.dynamicFormGroup[this.validator.HSCODE_FEILD_FORM?.id].get(this.validator.HSCODE_FEILD_FORM?.fieldName).get('email');
        if (emailControl) {
            if (condition) {
                emailControl.setValidators([Validators.required]);
            }
            else {
                emailControl.clearValidators();
            }
            emailControl.updateValueAndValidity();
        }
    }
    ValueAdd(id, form, fieldName, OptionfieldIndex, FormOptionfieldName, value, callback = undefined, field = undefined) {
        this.validator.HSCODE_FEILD_FORM["id"] = id;
        this.validator.HSCODE_FEILD_FORM["form"] = form;
        this.validator.HSCODE_FEILD_FORM["fieldName"] = fieldName;
        this.validator.HSCODE_FEILD_FORM["OptionfieldIndex"] = OptionfieldIndex;
        this.validator.HSCODE_FEILD_FORM["FormOptionfieldName"] = FormOptionfieldName;
        this.validator.HSCODE_FEILD_FORM["callback"] = callback;
        this.validator.HSCODE_FEILD_FORM["field"] = field;
        this.validator.HSCODE_FEILD_FORM["value"] = value;
        this.validator.HSCODE_FEILD_FORM["NewId"] = FormOptionfieldName + '_' + OptionfieldIndex;
        if (this.validator.HSCODE_FEILD_FORM?.FormOptionfieldName != undefined && this.validator.HSCODE_FEILD_FORM?.FormOptionfieldName != null) {
            this.ALL_DATA_HSCODE[this.validator.HSCODE_FEILD_FORM?.NewId] = [];
        }
        else {
            this.ALL_DATA_HSCODE[fieldName] = [];
        }
    }
    ToHSCode_Selected = [];
    ToHSCode(event, value, index) {
        if (this.validator.HSCODE_FEILD_FORM?.FormOptionfieldName != undefined && this.validator.HSCODE_FEILD_FORM?.FormOptionfieldName != null) {
            if (this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM?.NewId] == undefined) {
                this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM?.NewId] = [];
            }
            if (event?.target?.checked == true) {
                this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM?.NewId][index] = value;
            }
            else {
                this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM?.NewId][index] = '';
            }
        }
        else {
            if (this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM.fieldName] == undefined) {
                this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM.fieldName] = [];
            }
            if (event?.target?.checked == true) {
                this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM.fieldName][index] = value;
            }
            else {
                this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM.fieldName][index] = '';
            }
        }
    }
    ALL_DATA_HSCODE = {};
    DoneButton() {
        let temp2 = [];
        let NEW_HS_CODE = [];
        if (this.validator.HSCODE_FEILD_FORM?.FormOptionfieldName != undefined && this.validator.HSCODE_FEILD_FORM?.FormOptionfieldName != null) {
            this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM?.NewId]?.forEach((element) => {
                temp2.push(element?.hscode);
                NEW_HS_CODE.push(element);
            });
            this.ALL_DATA_HSCODE[this.validator.HSCODE_FEILD_FORM?.NewId] = temp2.join(',');
            const myForm = this.validator.HSCODE_FEILD_FORM?.form?.controls[this.validator.HSCODE_FEILD_FORM.fieldName];
            let currentVal = this.ALL_DATA_HSCODE[this.validator.HSCODE_FEILD_FORM?.NewId];
            myForm.value[this.validator.HSCODE_FEILD_FORM?.OptionfieldIndex][this.validator.HSCODE_FEILD_FORM.FormOptionfieldName] = currentVal;
            myForm?.controls[this.validator.HSCODE_FEILD_FORM?.OptionfieldIndex]?.controls[this.validator.HSCODE_FEILD_FORM.FormOptionfieldName]?.setValue(currentVal);
            myForm['touched'] = true;
            myForm['status'] = 'VALID';
            this.validator.dynamicFormGroup[this.validator.HSCODE_FEILD_FORM?.id].get(this.validator.HSCODE_FEILD_FORM?.fieldName).clearValidators();
            this.validator.dynamicFormGroup[this.validator.HSCODE_FEILD_FORM?.id].get(this.validator.HSCODE_FEILD_FORM?.fieldName).updateValueAndValidity();
            if (this.validator.HSCODE_FEILD_FORM?.callback != undefined && this.validator.HSCODE_FEILD_FORM?.callback != null) {
                this.validator.HSCODE_FEILD_FORM.callback({
                    id: this.validator.HSCODE_FEILD_FORM.id,
                    form: this.validator.HSCODE_FEILD_FORM.form, fieldName: this.validator.HSCODE_FEILD_FORM.fieldName,
                    OptionfieldIndex: this.validator.HSCODE_FEILD_FORM.OptionfieldIndex,
                    FormOptionfieldName: this.validator.HSCODE_FEILD_FORM.FormOptionfieldName,
                    value: this.validator.HSCODE_FEILD_FORM.value,
                    dynamicFormGroup: this.validator.dynamicFormGroup[this.validator.HSCODE_FEILD_FORM.id],
                    field: this.validator.FIELDS_DATA[this.validator.HSCODE_FEILD_FORM.id],
                    SELECTED_ITEMS: NEW_HS_CODE
                });
            }
        }
        else {
            this.ToHSCode_Selected[this.validator.HSCODE_FEILD_FORM.fieldName]?.forEach((element) => {
                temp2.push(element?.hscode);
                NEW_HS_CODE.push(element);
            });
            this.ALL_DATA_HSCODE[this.validator.HSCODE_FEILD_FORM.fieldName] = temp2.join(',');
            const myForm = this.validator.HSCODE_FEILD_FORM?.form;
            let currentVal = this.ALL_DATA_HSCODE[this.validator.HSCODE_FEILD_FORM.fieldName];
            myForm.value[this.validator.HSCODE_FEILD_FORM.fieldName] = currentVal;
            myForm?.controls[this.validator.HSCODE_FEILD_FORM.fieldName]?.setValue(currentVal);
            myForm['touched'] = true;
            myForm['status'] = 'VALID';
            if (this.validator.HSCODE_FEILD_FORM?.callback != undefined && this.validator.HSCODE_FEILD_FORM?.callback != null) {
                this.validator.HSCODE_FEILD_FORM.callback({
                    id: this.validator.HSCODE_FEILD_FORM.id, form: this.validator.HSCODE_FEILD_FORM.form,
                    fieldName: this.validator.HSCODE_FEILD_FORM.fieldName, OptionfieldIndex: this.validator.HSCODE_FEILD_FORM.OptionfieldIndex,
                    FormOptionfieldName: this.validator.HSCODE_FEILD_FORM.FormOptionfieldName, value: this.validator.HSCODE_FEILD_FORM.value,
                    dynamicFormGroup: this.validator.dynamicFormGroup[this.validator.HSCODE_FEILD_FORM.id],
                    field: this.validator.FIELDS_DATA[this.validator.HSCODE_FEILD_FORM.id],
                    SELECTED_ITEMS: NEW_HS_CODE
                });
            }
        }
    }
    filtertimeout = '';
    FILTER_HS_CODE_DATA = [];
    filterHSCode(value) {
        clearTimeout(this.filtertimeout);
        this.filtertimeout = setTimeout(() => {
            this.FILTER_HS_CODE_DATA = this.HS_CODE_DATA.filter((item) => item?.hscode?.indexOf(value) != -1 || item?.description?.toLowerCase()?.indexOf(value?.toLowerCase()) != -1);
            if (this.FILTER_HS_CODE_DATA.length == 0) {
                this.FILTER_HS_CODE_DATA = this.PAGINATE_DATA?.items;
            }
        }, 200);
    }
    PUPOSE_CODE_FEILD_FORM = {
        id: "",
        form: "",
        fieldName: "",
        OptionfieldIndex: "",
        FormOptionfieldName: "",
        value: "",
        callback: "",
        field: "",
        NewId: ""
    };
    SELECT_PURPOSE_CODE(event, index) {
        this.validator.SELECTED_PURPOSE_CODE_DUMP_SLEECTION[index] = { PurposeCode: event?.toString(), Description: this.validator.PURPOSE_CODE_FILTER_DATA[index]?.Value_greater_25000_equv[0] };
        this.validator.SELECTED_PURPOSE_CODE_INDEX[index] = true;
        this.validator.PURPOSE_CODE_FILTER_DATA?.forEach((element, i) => {
            if (index == i) {
                element['isActive'] = true;
            }
        });
    }
    PURPOSE_ValueAdd(id, field) {
        this.PUPOSE_CODE_FEILD_FORM['id'] = id;
        this.PUPOSE_CODE_FEILD_FORM['field'] = field;
    }
    PURPOSEDoneButton() {
        let temp2 = [];
        this.NEW_PURPOSE_CODE_LIST?.forEach((element) => {
            element[element?.keyName]?.forEach((keyNameelement) => {
                if (keyNameelement?.checked == true) {
                    temp2.push(keyNameelement?.text);
                }
            });
        });
        this.validator.ALL_DATA_PURPOSE_CODE = temp2.join(',');
        this.setValue(this.validator.ALL_DATA_PURPOSE_CODE, this.PUPOSE_CODE_FEILD_FORM?.field);
    }
    IMAGE_UPLOAD_LIST = [];
    onUploadChanges(event, autofill) {
        if (event.target.files.length > 0) {
            event.target.files.forEach((element) => {
                let fileReader = new FileReader();
                fileReader.onload = (e) => {
                    this.IMAGE_UPLOAD_LIST.push({
                        name: element?.name,
                        buffer: fileReader.result
                    });
                };
                fileReader.readAsDataURL(element);
            });
            this.validator.dynamicFormGroup[this.id]?.controls[autofill?.key]?.setValue(this.IMAGE_UPLOAD_LIST);
        }
    }
    removeImage(index, autofill) {
        this.IMAGE_UPLOAD_LIST.splice(index, 1);
        this.validator.dynamicFormGroup[this.id]?.controls[autofill?.key]?.setValue(this.IMAGE_UPLOAD_LIST);
    }
    HideShowInput(event, item, fieldIndex = -1, callback = undefined) {
        if (item != undefined) {
            if (item[event] != undefined) {
                item[event]?.forEach((element) => {
                    const index = this.validator.FIELDS_DATA[this.id]?.findIndex((val) => val?.fieldName?.includes(element));
                    if (index != -1 && item[event] != undefined) {
                        this.validator.FIELDS_DATA[this.id][index]['disabled'] = true;
                        this.validator.dynamicFormGroup[this.id]?.controls[element]?.disable();
                    }
                    else {
                        this.validator.FIELDS_DATA[this.id][index]['disabled'] = false;
                        this.validator.dynamicFormGroup[this.id]?.controls[element]?.enable();
                    }
                });
            }
            else {
                for (const key in item) {
                    const element = item[key];
                    element.forEach((fieldNameelement) => {
                        const index = this.validator.FIELDS_DATA[this.id]?.findIndex((val) => val?.fieldName?.includes(fieldNameelement));
                        if (index != -1 && item[event] != undefined) {
                            this.validator.FIELDS_DATA[this.id][index]['disabled'] = true;
                            this.validator.dynamicFormGroup[this.id]?.controls[fieldNameelement]?.disable();
                        }
                        else {
                            this.validator.FIELDS_DATA[this.id][index]['disabled'] = false;
                            this.validator.dynamicFormGroup[this.id]?.controls[fieldNameelement]?.enable();
                        }
                    });
                }
            }
        }
        if (callback != undefined) {
            callback({
                event: event,
                id: this.id,
                item: item,
                dynamicFormGroup: this.validator.dynamicFormGroup[this.id],
                field: this.validator.FIELDS_DATA[this.id],
                FIELDS_DATA: this.validator.FIELDS_DATA
            });
        }
    }
    HideInputCheckBox(bool, item) {
        if (item != undefined) {
            item.forEach((element) => {
                const index = this.validator.FIELDS_DATA[this.id]?.findIndex((val) => val?.fieldName?.includes(element?.name));
                if (index != -1) {
                    if (element?.status == true) {
                        this.validator.FIELDS_DATA[this.id][index]['disabled'] = false;
                        this.validator.dynamicFormGroup[this.id]?.controls[element?.name]?.enable();
                    }
                    else {
                        this.validator.FIELDS_DATA[this.id][index]['disabled'] = true;
                        this.validator.dynamicFormGroup[this.id]?.controls[element?.name]?.disable();
                    }
                }
            });
        }
    }
    ShowInputCheckBox(bool, item) {
        if (item != undefined) {
            item.forEach((element) => {
                const index = this.validator.FIELDS_DATA[this.id]?.findIndex((val) => val?.fieldName?.includes(element?.name));
                if (index != -1) {
                    if (element?.status == true) {
                        this.validator.FIELDS_DATA[this.id][index]['disabled'] = false;
                        this.validator.dynamicFormGroup[this.id]?.controls[element?.name]?.enable();
                    }
                    else {
                        this.validator.FIELDS_DATA[this.id][index]['disabled'] = true;
                        this.validator.dynamicFormGroup[this.id]?.controls[element?.name]?.disable();
                    }
                }
            });
        }
    }
    onLabelNameChange(event, item, item2 = '') {
        if (item != undefined) {
            if (item[event] != undefined) {
                for (const key in item[event]) {
                    const element = item[event][key];
                    const index = this.validator.FIELDS_DATA[this.id]?.findIndex((val) => val?.fieldName?.includes(key));
                    if (index != -1) {
                        if (element['type'] = "formGroup") {
                            this.validator.FIELDS_DATA[this.id][index]["NewformArray"]?.forEach((NewformArrayelement) => {
                                let ObjectKEYS = Object.keys(NewformArrayelement);
                                const formGroupindex = ObjectKEYS?.findIndex((val) => val.includes(element?.name));
                                if (formGroupindex != -1) {
                                    NewformArrayelement[element?.name]["label"] = element?.labelChange;
                                }
                            });
                        }
                    }
                }
            }
            else {
                for (const key in item["default"]) {
                    const element = item["default"][key];
                    const index = this.validator.FIELDS_DATA[this.id]?.findIndex((val) => val?.fieldName?.includes(key));
                    if (index != -1) {
                        if (element['type'] = "formGroup") {
                            this.validator.FIELDS_DATA[this.id][index]["NewformArray"]?.forEach((NewformArrayelement) => {
                                let ObjectKEYS = Object.keys(NewformArrayelement);
                                const formGroupindex = ObjectKEYS?.findIndex((val) => val.includes(element?.name));
                                if (formGroupindex != -1) {
                                    NewformArrayelement[element?.name]["label"] = element?.labelChange;
                                }
                            });
                        }
                    }
                }
            }
        }
    }
    AutoFillCurrency(value, autofillitem) {
        if (autofillitem != undefined && autofillitem != null && autofillitem != '') {
            if (autofillitem?.type == "formGroup") {
                this.validator.dynamicFormGroup[this.id]?.controls[autofillitem?.CONTROLS_NAME]?.controls?.forEach((element) => {
                    element?.controls[autofillitem?.SetInputName]?.setValue(value?.type);
                });
            }
            else {
                this.validator.dynamicFormGroup[this.id]?.controls[autofillitem?.CONTROLS_NAME]?.controls?.setValue(value?.type);
            }
        }
    }
    onSHIPPING_BILL_EVENT(value) {
        this.SHIPPING_BILL_EVENT.emit(value);
    }
    onBL_COPY_EVENT(value, fieldName, fieldIndex, callback = undefined) {
        this.BL_COPY_EVENT.emit(value);
        if (callback != undefined) {
            callback({
                form: this.validator.HSCODE_FEILD_FORM.form,
                fieldName: fieldName,
                index: fieldIndex,
                value: value,
                dynamicFormGroup: this.validator.dynamicFormGroup[this.id],
                field: this.validator.FIELDS_DATA[fieldIndex],
            });
        }
    }
    CommericalListCheckBoxList = [];
    onCommericalListCheckBox(event, fieldName, index, item, fieldIndex, callback = undefined) {
        if (event?.checked == true) {
            this.CommericalListCheckBoxList.push(item);
        }
        else {
            this.CommericalListCheckBoxList.splice(index, 1);
        }
        this.validator.dynamicFormGroup[this.id].controls[fieldName].setValue(this.CommericalListCheckBoxList);
        if (callback != undefined) {
            callback({
                form: this.validator.HSCODE_FEILD_FORM.form,
                fieldName: fieldName,
                index: fieldIndex,
                value: item,
                dynamicFormGroup: this.validator.dynamicFormGroup[this.id],
                field: this.validator.FIELDS_DATA[fieldIndex],
            });
        }
    }
    onBankCheckBox(event, fieldName, item, ItemChecked, CheckBoxCallBack = undefined) {
        this.validator.CHECK_BOX_BANK_LIST.forEach((element) => {
            element['checked'] = false;
        });
        if (event?.checked == true) {
            ItemChecked['checked'] = true;
        }
        else {
            ItemChecked['checked'] = false;
        }
        this.BankEvent.emit(item);
        this.validator.dynamicFormGroup[this.id].controls[fieldName].setValue(item);
        if (CheckBoxCallBack != undefined) {
            CheckBoxCallBack(item);
        }
    }
    onChargerBankCheckBox(event, fieldName, item, ItemChecked, CheckBoxCallBack = undefined) {
        this.validator.CHECK_BOX_BANK_LIST_CHARGES.forEach((element) => {
            element['checked'] = false;
        });
        if (event?.checked == true) {
            ItemChecked['checked'] = true;
        }
        else {
            ItemChecked['checked'] = false;
        }
        this.BankEvent.emit(item);
        this.validator.dynamicFormGroup[this.id].controls[fieldName].setValue(item);
        if (CheckBoxCallBack != undefined) {
            CheckBoxCallBack(item);
        }
    }
    onRemitterCheckBox(event, fieldName, item, ItemChecked) {
        this.validator.CHECK_BOX_REMITTER_LIST?.forEach((element) => {
            element['checked'] = false;
        });
        if (event?.checked == true) {
            ItemChecked['checked'] = true;
        }
        else {
            ItemChecked['checked'] = false;
        }
        this.validator.dynamicFormGroup[this.id].controls[fieldName].setValue(item);
    }
    BANK_CHECKBOX(value, CHECK_BOX_BANK_LIST_CHARGES, EqualBankDetails = {}, errormsg = '', fieldName = '', dynamicFormGroup = undefined, callback = undefined) {
        if (Object.keys(EqualBankDetails)?.length != 0) {
            if (EqualBankDetails?.BankUniqueId == value?.BankUniqueId) {
                this.validator.CHECK_BOX_BANK_LIST = this.validator?.bankDetail[value?.BankUniqueId];
                this.validator.CHECK_BOX_BANK_LIST_CHARGES = [];
                if (CHECK_BOX_BANK_LIST_CHARGES == true) {
                    this.validator.CHECK_BOX_BANK_LIST_CHARGES = this.validator?.ToCreditAccountdata[value?.BankUniqueId];
                }
                this.validator.CHECK_BOX_BANK_LIST?.forEach((element) => {
                    element['checked'] = false;
                });
                this.validator.CHECK_BOX_BANK_LIST_CHARGES?.forEach((element) => {
                    element['checked'] = false;
                });
                if (callback != undefined) {
                    callback(value);
                }
                this.SelectionBank.emit(value);
            }
            else {
                this.validator.CHECK_BOX_BANK_LIST = [];
                this.validator.CHECK_BOX_BANK_LIST_CHARGES = [];
                if (CHECK_BOX_BANK_LIST_CHARGES == true) {
                    this.validator.CHECK_BOX_BANK_LIST_CHARGES = [];
                }
                if (dynamicFormGroup != undefined) {
                    dynamicFormGroup?.controls[fieldName]?.reset();
                }
                if (callback != undefined) {
                    callback(value);
                }
                this.SelectionBank.emit(false);
            }
        }
        else {
            this.validator.CHECK_BOX_BANK_LIST = this.validator?.bankDetail[value?.BankUniqueId];
            this.validator.CHECK_BOX_BANK_LIST_CHARGES = [];
            if (CHECK_BOX_BANK_LIST_CHARGES == true) {
                this.validator.CHECK_BOX_BANK_LIST_CHARGES = this.validator?.ToCreditAccountdata[value?.BankUniqueId];
            }
            this.validator.CHECK_BOX_BANK_LIST?.forEach((element) => {
                element['checked'] = false;
            });
            this.validator.CHECK_BOX_BANK_LIST_CHARGES?.forEach((element) => {
                element['checked'] = false;
            });
            if (callback != undefined) {
                callback(value);
            }
            this.SelectionBank.emit(value);
        }
    }
    REMITTER_CHECKBOX(value) {
        this.validator.CHECK_BOX_REMITTER_LIST = this.validator?.REMITTER_LIST[value?.Remitter_Name];
        this.validator.CHECK_BOX_REMITTER_LIST?.forEach((element) => {
            element['checked'] = false;
        });
    }
    YesNoFunction(value, name, callback) {
        this.setValue(value, name);
        this.YesNoCheckBoxEvent.emit(value);
        if (callback != null && callback != undefined) {
            callback(value);
        }
    }
    AddAdditionalDocuments(form, name, index, fromitems) {
        if (fromitems?.items != undefined && fromitems?.items?.length != 0) {
            fromitems?.items.push(fromitems?.items[fromitems?.items?.length - 1] + 1);
            form?.value[name]?.push();
        }
    }
    removeAdditionalDocuments(form, name, index, fromitems) {
        if (fromitems?.items != undefined && fromitems?.items?.length != 0) {
            fromitems?.items?.splice(index, 1);
            form?.value[name]?.splice(index, 1);
        }
    }
    PushValueAdditionalDocuments(args, form, name, index, fromitems) {
        if (fromitems?.items != undefined && fromitems?.items?.length != 0) {
            form.value[name][index] = args[1].publicUrl;
        }
    }
    AdditionalDocumentsUrl = '';
    ViewAdditionalDocuments(doc) {
        this.AdditionalDocumentsUrl = '';
        setTimeout(() => {
            this.AdditionalDocumentsUrl = doc;
        }, 200);
    }
    UploadedViewPdfUrl = '';
    UploadedViewPdf(pdf) {
        this.UploadedViewPdfUrl = '';
        setTimeout(() => {
            this.UploadedViewPdfUrl = pdf;
        }, 200);
    }
    LETTER_HEADE_URL = new EventEmitter();
    onFileSelect(input, urladd) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();
            reader.onload = async (e) => {
                let data = e.target.result.substr(e.target.result.indexOf(',') + 1);
            };
            reader.readAsDataURL(input.files[0]);
        }
    }
    CancelRouterNavigate(url) {
        this.CancelEvent.emit({ status: true });
        if (url != undefined && url != "" && url != null) {
            // this.router.navigate([url])
            window.location.href = url;
        }
    }
    callbuyerbene(event) {
        setTimeout(() => {
            this.BUYER_BENEE_EVENT?.emit(event);
        }, 200);
    }
    ngOnDestroy() {
        if (this.ResetForm == true) {
            this.validator.dynamicFormGroup[this.id]?.reset();
            this.validator.CHECK_BOX_BANK_LIST = [];
            this.validator.CHECK_BOX_BANK_LIST_CHARGES = [];
        }
    }
    UploadDocumentResponse(args, id, parentcontrols, index, childcontrols) {
        this.validator.dynamicFormGroup[id].controls[parentcontrols].value[index] = {
            [childcontrols]: args[1]
        };
        this.validator.dynamicFormGroup[id]?.controls[parentcontrols]?.controls[index]?.controls[childcontrols]?.setValue(args[1]);
    }
    onChangeMatCheckBox(id, parentcontrols, key, selectedOption) {
        const controlValue = this.validator.dynamicFormGroup[id]?.controls[parentcontrols]?.value;
        this.validator.dynamicFormGroup[id]?.controls[parentcontrols]?.setValue({
            ...controlValue,
            [key]: selectedOption?.checked
        });
    }
    callbackfill(fieldName, fieldIndex, item, callback) {
        if (callback != undefined) {
            callback({
                form: this.validator.HSCODE_FEILD_FORM.form,
                fieldName: fieldName,
                index: fieldIndex,
                value: item,
                dynamicFormGroup: this.validator.dynamicFormGroup[this.id],
                field: this.validator.FIELDS_DATA[this.id],
            });
        }
    }
    filterGroupNameData(event) {
        console.log(event, "filterGroupNameData");
        if (event == undefined) {
            this.NEW_PURPOSE_CODE_LIST = this.NEW_STATIC_PURPOSE_CODE_LIST;
            return;
        }
        this.NEW_PURPOSE_CODE_LIST = this.NEW_STATIC_PURPOSE_CODE_LIST?.filter((item) => item?.keyName == event);
    }
    filterPurposeCodeData(event) {
        console.log(event, "filterPurposeCodeData");
        if (event == undefined) {
            this.NEW_PURPOSE_CODE_LIST = this.NEW_STATIC_PURPOSE_CODE_LIST;
            return;
        }
        this.NEW_PURPOSE_CODE_LIST = this.NEW_STATIC_PURPOSE_CODE_LIST.filter((item1) => item1[item1.keyName]?.some((item2) => item2.text === event));
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: JsonReactiveComponents, deps: [{ token: i1.DomSanitizer }, { token: ReactiveJsonFormsService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: JsonReactiveComponents, isStandalone: true, selector: "Json-Reactive-Forms", inputs: { label: "label", labelStyle: "labelStyle", FormStyle: "FormStyle", MainStyle: "MainStyle", DetailsShow: "DetailsShow", id: "id", SubmitButtonStyle: "SubmitButtonStyle", ButtonPanelStyle: "ButtonPanelStyle", CancelRoute: "CancelRoute", TypeOfValue: "TypeOfValue", SubmitName: "SubmitName", AddNewRequried: "AddNewRequried", HIDE_BACKGROUND: "HIDE_BACKGROUND", HIDE_SUBMIT_BUTTON: "HIDE_SUBMIT_BUTTON", KEY_ENTER_ENABLED: "KEY_ENTER_ENABLED", ADD_NEW_BUTTON_VISIBLE: "ADD_NEW_BUTTON_VISIBLE", morecontent: "morecontent", BUTTON_PANEL_SHOW: "BUTTON_PANEL_SHOW", BUTTON_PANEL_HIDE: "BUTTON_PANEL_HIDE", SubmitButtonDisabled: "SubmitButtonDisabled", ResetForm: "ResetForm", ErrorMessageData: "ErrorMessageData" }, outputs: { OnSubmitEvent: "OnSubmitEvent", AddNewBank: "AddNewBank", RawValue: "RawValueEvent", BankEvent: "BankEvent", SelectionBank: "SelectionBank", YesNoCheckBoxEvent: "YesNoCheckBoxEvent", SHIPPING_BILL_EVENT: "SHIPPING_BILL_EVENT", CommericalNoEvent: "CommericalNoEvent", AddButton: "AddButton", BL_COPY_EVENT: "BL_COPY_EVENT", BENEFICIARY_EVENT: "BENEFICIARY_EVENT", BUYER_BENEE_EVENT: "BUYER_BENEE_EVENT", PIPO_EVENT: "PIPO_EVENT", DropDownEvent: "DropDownEvent", ArrayList_ObjectEvent: "ArrayList_ObjectEvent", FormValueChanges: "FormValueChanges", CancelEvent: "CancelEvent", LETTER_HEADE_URL: "LETTER_HEADE_URL" }, viewQueries: [{ propertyName: "BuyerNotFound", first: true, predicate: ["BuyerNotFoundPanel"], descendants: true }, { propertyName: "BeneficiaryNotFound", first: true, predicate: ["BeneficiaryNotFoundPanel"], descendants: true }], ngImport: i0, template: "<div class=\"form-container-fluid\" [style]=\"MainStyle\"\r\n    *ngIf=\"this.validator.dynamicFormGroup!=undefined && this.validator.dynamicFormGroup[this.id]!=undefined\"\r\n    [hidden]=\"this.validator.dynamicFormGroup[this.id]!=undefined?false:true\">\r\n    <div class=\"form-group mb-0 ErrorMessageData\" *ngIf=\"this.ErrorMessageData?.status==true\">\r\n        <label>{{this.ErrorMessageData?.text}}</label>\r\n    </div>\r\n    <ng-content *ngIf=\"morecontent==true\" select=\"more-content\"></ng-content>\r\n    <form class=\"col-12\"\r\n        *ngIf=\"this.validator.dynamicFormGroup!=undefined && this.validator.dynamicFormGroup[this.id]!=undefined\"\r\n        [formGroup]=\"this.validator.dynamicFormGroup[this.id]\" onsubmit=\"return false;\"\r\n        [ngClass]=\"{'division-panel':this.HIDE_BACKGROUND==true}\" [style]=\"this.FormStyle\"\r\n        (keyup.enter)=\"this.KEY_ENTER_ENABLED==true?onSubmit($event,this.validator.dynamicFormGroup[this.id]):''\"\r\n        autocomplete=\"disabled\" autocomplete=\"off\">\r\n        <label *ngIf=\"label!=undefined && label!=''\" class=\"Details-form-label\"\r\n            [style]=\"labelStyle\">{{this.label}}</label>\r\n        <div class=\"col-12 p-1\" [ngClass]=\"{'hidden':field?.disabled==true}\"\r\n            *ngFor=\"let field of this.validator?.FIELDS_DATA[this.id];let fieldIndex=index\">\r\n            <ng-container [ngSwitch]=\"field.type\">\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'LabelShow'\">\r\n                    <label class=\"form-control\" *ngIf=\"field?.label\">{{\r\n                        field?.label }} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <span [innerHTML]=\"field.value\"></span>\r\n                </div>\r\n\r\n                <!-- Text Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'text'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [placeholder]=\"field.placeholderText\" [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- DateTime Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'datetime'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"datetime-local\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- Time Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'time'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"time\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- Checkbox -->\r\n                <mat-checkbox *ngSwitchCase=\"'checkbox'\" [(ngModel)]=\"field.value\"\r\n                    [disabled]=\"field?.CheckboxDisabled\">{{field.label}}\r\n                    <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span>\r\n                </mat-checkbox>\r\n\r\n                <!-- Select Dropdown -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'SelectOption'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <select class=\"form-control\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\">\r\n                        <option *ngFor=\"let item of field?.items\" [value]=\"item\">{{item}}</option>\r\n                    </select>\r\n                </div>\r\n\r\n                <!-- TextArea -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'textarea'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <textarea [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\"></textarea>\r\n                </div>\r\n\r\n                <!-- Email Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'email'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"email\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- Number Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'number'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"number\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'EmailButton'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div [ngStyle]=\"field?.DivStyle\">\r\n                        <div>\r\n                            <label>{{ field.placeholderText }}</label>\r\n                            <input [(ngModel)]=\"field.value\" [disabled]=\"field?.Inputdisabled\" EmailValidator\r\n                                (keypress)=\"this.validator.max_length_validator(this.id, field.fieldName)\"\r\n                                [type]=\"field.InputType\" [name]=\"field.fieldName\" [formControlName]=\"field.fieldName\"\r\n                                [ngStyle]=\"field?.InputStyle\"\r\n                                (keydown)=\"dumpFunc({ value: field.value, field: this.validator?.FIELDS_DATA[this.id], form: this.validator.dynamicFormGroup[this.id] }, field?.KeyPressCallBack)\" />\r\n                        </div>\r\n                        <button mat-raised-button [style]=\"field?.buttonStyle\"\r\n                            [disabled]=\"field?.buttondisabled || this.validator.dynamicFormGroup[this.id]?.controls[field.fieldName]?.errors\">\r\n                            {{ field?.ButtonText }}\r\n                        </button>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'NumberButton'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div [ngStyle]=\"field?.DivStyle\">\r\n                        <div>\r\n                            <label>{{ field.placeholderText }}</label>\r\n                            <input [(ngModel)]=\"field.value\" [disabled]=\"field?.Inputdisabled\" MaxMinValidation\r\n                                (keypress)=\"this.validator.max_length_validator(this.id, field.fieldName)\"\r\n                                [type]=\"field?.InputType\" [name]=\"field.fieldName\" [formControlName]=\"field.fieldName\"\r\n                                [ngStyle]=\"field?.InputStyle\"\r\n                                (keydown)=\"dumpFunc({ value: field.value, field: this.validator?.FIELDS_DATA[this.id], form: this.validator.dynamicFormGroup[this.id] }, field?.KeyPressCallBack)\" />\r\n                        </div>\r\n                        <button mat-raised-button [style]=\"field?.buttonStyle\"\r\n                            [disabled]=\"field?.buttondisabled || this.validator.dynamicFormGroup[this.id]?.controls[field.fieldName]?.errors\">\r\n                            {{ field?.ButtonText }}\r\n                        </button>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'password'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div class=\"col-12 p-0\">\r\n                        <div>\r\n                            <label>{{ field.placeholderText }}</label>\r\n                            <input [(ngModel)]=\"field.value\" PasswordValidation\r\n                                (keypress)=\"this.validator.max_length_validator(this.id, field.fieldName)\"\r\n                                [type]=\"field.showhide ? 'text' : 'password'\" [name]=\"field.fieldName\" />\r\n                            <button mat-icon-button matSuffix (click)=\"field.showhide = !field.showhide\">\r\n                            </button>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'date'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div>\r\n                        <label>{{ field.placeholderText }}</label>\r\n                        <input [(ngModel)]=\"field.value\" [disabled]=\"field?.Inputdisabled\"\r\n                            (change)=\"dumpFunc({ value: $event?.target, field: this.validator?.FIELDS_DATA[this.id], form: this.validator.dynamicFormGroup[this.id] }, field?.callback)\"\r\n                            [type]=\"field.type\" [name]=\"field.fieldName\" [formControlName]=\"field.fieldName\" />\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MatCheckBox'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <mat-radio-group [(ngModel)]=\"field.value\"\r\n                        (change)=\"field?.callback ? field?.callback($event) : ''\">\r\n                        <mat-radio-button *ngFor=\"let item of field?.items\" [value]=\"item.value\">{{ item.text\r\n                            }}</mat-radio-button>\r\n                    </mat-radio-group>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MultiCheckBox'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <mat-checkbox [formControlName]=\"field.fieldName\" *ngFor=\"let checkbox of field?.checkboxlabel\"\r\n                        [(ngModel)]=\"checkbox.checked\"\r\n                        (change)=\"HideShowInput($event, field?.HideShowInput, fieldIndex, field?.callback)\">\r\n                        {{ checkbox.label }}\r\n                    </mat-checkbox>\r\n                </div>\r\n                <div class=\"form-group mb-0 p-0\" *ngIf=\"field?.showhide === true || field?.showhide === undefined\">\r\n                    <div class=\"form-group mb-0\" *ngSwitchCase=\"'formGroup'\" [formArrayName]=\"field.fieldName\">\r\n                        <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                                *ngIf=\"field?.rules?.required\">*</span></label>\r\n                        <div class=\"col-12 p-0\" [style]=\"field?.ParentStyle\">\r\n                            <div class=\"col-12 formGroup-division-panel\" [style]=\"field?.Style\"\r\n                                *ngFor=\"let Optionfield of field?.NewFromGroup; let OptionfieldIndex = index\">\r\n                                <label>{{ field?.GroupLabel[OptionfieldIndex] }}</label>\r\n                                <div class=\"col-12 row m-0 add-btn-panel p-0\" *ngIf=\"field?.AddNewRequried === true\">\r\n                                    <button mat-raised-button color=\"primary\"\r\n                                        *ngIf=\"(field?.NewFromGroup?.length - 1) === OptionfieldIndex && (field?.NewFromGroup?.length) !== field?.MAX_LIMIT\"\r\n                                        (click)=\"this.validator.addNewFormArray(this.id, fieldIndex, field.fieldName)\">\r\n                                        <span>+</span>\r\n                                    </button>\r\n                                    <button mat-raised-button color=\"warn\" *ngIf=\"OptionfieldIndex !== 0\"\r\n                                        (click)=\"this.validator.removeNewFormArray(this.id, fieldIndex, field.fieldName, OptionfieldIndex)\">\r\n                                        <span>-</span>\r\n                                    </button>\r\n                                </div>\r\n                                <div class=\"col-10 p-0\"\r\n                                    *ngFor=\"let FormOptionfield of Optionfield?.FromGroupObj; let FormOptionfieldIndex = index\"\r\n                                    [formGroupName]=\"OptionfieldIndex\"\r\n                                    [ngClass]=\"{'hidden': FormOptionfield?.disabled === true}\">\r\n                                    <ng-container [ngSwitch]=\"FormOptionfield?.type\">\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'LabelShow'\">\r\n                                            <label class=\"form-control\" *ngIf=\"FormOptionfield?.label\">{{\r\n                                                FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                    *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                            <span [innerHTML]=\"FormOptionfield.value\"></span>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'text'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"text\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'email'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"email\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'number'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"number\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'date'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"date\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MatCheckBox'\">\r\n                                            <label *ngIf=\"FormOptionfield.label\">{{ FormOptionfield.label }} <span\r\n                                                    style=\"color: red;\"\r\n                                                    *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                            <mat-radio-group [(ngModel)]=\"FormOptionfield.value\"\r\n                                                [formControlName]=\"FormOptionfield.fieldName\"\r\n                                                (change)=\"FormOptionfield?.callback ? FormOptionfield?.callback($event) : ''\">\r\n                                                <mat-radio-button *ngFor=\"let item of FormOptionfield?.items\"\r\n                                                    [value]=\"item.value\">{{ item.text\r\n                                                    }}</mat-radio-button>\r\n                                            </mat-radio-group>\r\n                                        </div>\r\n\r\n                                        <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MultiCheckBox'\">\r\n                                            <label *ngIf=\"FormOptionfield.label\">{{ FormOptionfield.label }} <span\r\n                                                    style=\"color: red;\"\r\n                                                    *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                            <mat-checkbox [formControlName]=\"FormOptionfield.fieldName\"\r\n                                                *ngFor=\"let checkbox of FormOptionfield?.checkboxlabel\"\r\n                                                [(ngModel)]=\"checkbox.checked\"\r\n                                                (change)=\"HideShowInput($event, field?.HideShowInput, fieldIndex, field?.callback)\">\r\n                                                {{ checkbox?.label }}\r\n                                            </mat-checkbox>\r\n                                        </div>\r\n                                    </ng-container>\r\n                                    <inner-dynamic-error [SUBMIT_ERROR]=\"this.SUBMIT_ERROR\"\r\n                                        [formName]=\"this.validator.dynamicFormGroup[this.id]?.controls[field.fieldName]?.controls[OptionfieldIndex]\"\r\n                                        [fieldName]=\"FormOptionfield?.fieldName\"></inner-dynamic-error>\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </ng-container>\r\n            <inner-dynamic-error [SUBMIT_ERROR]=\"this.SUBMIT_ERROR\"\r\n                [formName]=\"this.validator.dynamicFormGroup[this.id]\" [fieldName]=\"field.fieldName\"\r\n                [ErrorMessage]=\"field?.ErrorMessage\"></inner-dynamic-error>\r\n        </div>\r\n    </form>\r\n    <div [ngClass]=\"{'more-button-panel':this.BUTTON_PANEL_SHOW==true}\"\r\n        [style]=\"this.BUTTON_PANEL_HIDE==true?'display:flex;':'display:none'\" [style]=\"ButtonPanelStyle\">\r\n        <ng-content></ng-content>\r\n        <div class=\"btn-controller\"\r\n            [ngClass]=\"{'button-show':this.HIDE_SUBMIT_BUTTON==true,'button-hide':this.HIDE_SUBMIT_BUTTON==false}\">\r\n            <button class=\"btn btn-danger\" (click)=\"CancelRouterNavigate(this.CancelRoute)\">Cancel</button>\r\n            <button *ngIf=\"BUTTON_PANEL_SHOW==true\" type=\"button\" class=\"btn btn-primary submit-button\" [id]=\"this.id\"\r\n                [style]=\"this.HIDE_SUBMIT_BUTTON==true?'display:block;':'display:none'\" [style]=\"SubmitButtonStyle\"\r\n                [disabled]=\"this.validator.dynamicFormGroup[this.id]?.invalid\"\r\n                (click)=\"onSubmit($event,this.validator.dynamicFormGroup[this.id]);\">{{SubmitName}}</button>\r\n            <button *ngIf=\"BUTTON_PANEL_SHOW==false\" type=\"button\" class=\"btn btn-primary submit-button\" [id]=\"this.id\"\r\n                [style]=\"SubmitButtonStyle\" [disabled]=\"this.validator.dynamicFormGroup[this.id]?.invalid\"\r\n                (click)=\"onSubmit($event,this.validator.dynamicFormGroup[this.id]);\">{{SubmitName}}</button>\r\n        </div>\r\n    </div>\r\n</div>", styles: [".content-wrap{margin:auto}.upload-panel{display:grid;grid-template-columns:60% 40%;padding:10px;gap:10px;margin-right:10px;position:absolute;width:100%;top:35px}.form-container-fluid{padding:0;overflow:unset;max-height:unset;border-radius:10px;width:98%;margin:auto}.division-panel{padding:30px;border-radius:10px;margin-bottom:10px}.formGroup-division-panel{padding:10px;border-radius:10px;margin-bottom:10px;background-color:#fff}.add-btn-panel{display:block}.add-btn-panel button{background:#2f58b8;color:#fff;border:none;border-radius:50px;width:25px!important;height:25px;display:flex;align-items:center;float:right;justify-content:center;margin-right:10px;cursor:pointer}.disbaled-h5{display:block;width:100%;height:calc(1.55em + .75rem + 2px);padding:.375rem .75rem;font-size:1rem;font-weight:300;line-height:1.55;color:#000;background-color:#fff;background-clip:padding-box;border:1px solid #c1ccd3;border-radius:.3rem;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}.envelope-icon,.lock-icon{position:absolute;top:18px;left:13px;color:#000;z-index:999}.eye-open-close-icon{position:absolute;top:18px;right:15px;color:#000;cursor:pointer;z-index:999}.email-password-padding{border-radius:50px;padding:23px 30px;position:relative}.email-input-icon{position:relative}.form-container-fluid::placeholder{color:red;opacity:1}.form-container-fluid:-ms-input-placeholder{color:red}.form-container-fluid::-ms-input-placeholder{color:red}.email-input-icon:before{font-family:\"Font Awesome 5 Free\";position:absolute;left:11px;top:28%;content:\"\\f0e0\";z-index:9999;display:flex;margin:auto}.img-popup{width:100%;height:100%;border-radius:5px}.form-container-fluid ::ng-deep custom-checkbox{display:grid;grid-template-columns:repeat(2,1fr);align-items:center;justify-content:center}.image-card-list{display:flex;flex-wrap:wrap;gap:10px;margin-top:10px;align-items:center;justify-content:center}.image-card-list .image-card{display:flex;flex-direction:column;position:relative;flex-basis:23.7%;align-items:center;justify-content:center}.image-card-list .image-card button{position:absolute;right:-1px;top:-1px;background:transparent;color:red;border:0}.image-card-list .image-card img{width:100%;height:150px;padding:5px;border-radius:5px}.image-card-list .image-card p{position:absolute;bottom:0;margin:0;z-index:999999;background:#000;width:100%;border-bottom-left-radius:5px;border-bottom-right-radius:5px;color:#fff;text-align:center;font-size:12px}.hidden,.button-hide{display:none!important}.more-button-panel{justify-content:flex-end;display:inline-flex;justify-items:flex-end;align-items:flex-start;margin:auto 0 auto auto;width:100%;gap:20px}.button-show{display:block;height:50px;margin:auto 0 0 auto}.yes-btn{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.no-btn{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.no-button{float:left;padding:0 10px;margin:0;height:32px;background:#fc5e5e!important;border:1px solid #FC5E5E!important;border-radius:0 5px 5px 0;color:#fff}.yes-button{float:left;padding:0 10px;margin:0;height:32px;background:#0079ff!important;border:1px solid #D9D9D9!important;color:#fff;border-radius:5px 0 0 5px}.remove-no-button-1{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.remove-no-button-2{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.row-reverse{flex-direction:row-reverse}.row-reverse .yes-btn{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.row-reverse .no-btn{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.row-reverse .no-button{float:left;padding:0 10px;margin:0;height:32px;background:#0079ff;border:1px solid #D9D9D9;color:#fff;border-radius:5px 0 0 5px}.row-reverse .yes-button{float:left;padding:0 10px;margin:0;height:32px;background:#fc5e5e;border:1px solid #FC5E5E;border-radius:0 5px 5px 0;color:#fff}.row-reverse .remove-no-button-1{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.row-reverse .remove-no-button-2{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.import_export_sec{margin:auto auto auto 0}.filter_section_top{display:grid;width:100%;background-color:#fff!important;margin:0;border-radius:30px;box-shadow:unset;padding:5px}.middle_datatable .support{height:calc(100vh - 159px)}.table-padding{background-color:transparent!important;box-shadow:none}.content-wrap.scroll-bar-main{overflow:auto;padding:0;overflow-x:hidden}.filter_right_new.padding_new_top{display:flex;gap:10px}.heading_common_tag{display:inline-block;width:100%;font-size:14px;font-weight:400;color:#fffaf0;margin-left:20px}.upload-panel{display:grid;grid-template-columns:calc(100% - 389px) 389px;padding:10px;gap:10px;margin-right:10px;position:unset!important;width:100%!important}.form-container-fluid{padding:0;overflow:unset;max-height:unset;border-radius:10px}.custom{width:300px}.custom ::ng-deep .ng-select .ng-select-container{color:#333;background-color:#fff;border:1px solid #ccc;min-height:36px;align-items:center;border-radius:5px 0 0 5px}.label-name-amount{display:grid;grid-template-columns:repeat(1,1fr);background:#fff;padding:10px;border-radius:10px;box-shadow:0 0 2px 2px #d4d4d4;margin-bottom:10px}.label-name-amount p{font-size:14px;margin:0}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-header-description{display:flex;flex-grow:1;flex-basis:unset!important;align-items:center;overflow:auto;margin-right:0!important}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-header-title{display:flex;flex-grow:1;flex-basis:unset!important;align-items:center;background:#000;width:100%!important;padding:5px;margin-right:0!important;color:#fff;border-top-left-radius:5px;border-top-right-radius:5px}.SHIPING_BILL_POPUP .col-td-th-3{width:170px!important}.SHIPING_BILL_POPUP .table>:not(caption)>*>*{background-color:transparent!important}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-body{padding:0 24px 16px;overflow:auto}.SHIPING_BILL_POPUP ::ng-deep .mat-accordion{margin-top:10px!important;margin:auto;display:flex;flex-direction:column;width:calc(100vw - 270px)}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-spacing{margin:16px 0;background-color:#fffaf0}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel{margin-bottom:20px}.SHIPING_BILL_POPUP ::ng-deep .d-grid{display:grid!important;grid-template-columns:repeat(6,1fr);padding:20px;border-radius:10px;margin-top:10px;margin-left:20px;gap:20px}.SHIPING_BILL_POPUP .flex-column{flex-direction:column!important;width:100%}.SHIPING_BILL_POPUP .flex-column-1{flex-direction:column!important;width:200px}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-header{height:auto;padding:0}.SHIPING_BILL_POPUP .prevent-click{pointer-events:none}.SHIPING_BILL_POPUP .authorize-click{pointer-events:auto}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-indicator{display:none!important}.match-off ::ng-deep .upload-components-header{position:relative!important}.disabled-tr{pointer-events:none;opacity:.6;position:relative}.disabled-tr:after{content:\"Already Used\";position:absolute;left:0;font-size:20px;color:red;opacity:1;background:#6495ed;padding:20px}.Transaction-btn{margin:auto 20px auto auto;background-color:transparent;border:none}.Transaction-btn:hover{color:#597a8a}::ng-deep ng-custom-filter-popup .filter_main{width:540px!important}.form-label-control{display:block;width:100%;padding:.5rem .75rem;font-size:1rem;line-height:1.25;color:#495057;background-color:#fff;background-image:none;background-clip:padding-box;border:1px solid rgba(0,0,0,.15);border-radius:.25rem;transition:border-color ease-in-out .15s,box-shadow ease-in-out .15s}.table-custom{height:100%;width:100%;padding:10px}.thead-card{display:grid;grid-template-columns:200px calc(100% - 200px);align-items:center}.tbody-card{display:grid;grid-template-columns:200px auto;align-items:center;background-color:#21609b;margin-bottom:20px;border-radius:5px;color:#000}.tbody-card .p-border{height:99%;padding:0;margin:0;text-align:center;display:flex;align-items:center;justify-content:center}.colspan{display:grid;grid-template-columns:150px auto}.colspan p{margin:auto;display:flex;flex-direction:column;text-align:left!important;padding:10px;width:100%}.groupname-text{background-color:#3e34c9;border-top-left-radius:10px;border-bottom-left-radius:10px;color:#fff}.colspanitem{background-color:#7508ce;width:100%;border-top-right-radius:10px;border-bottom-right-radius:10px}.text-left{text-align:left!important;padding:10px;width:95%;display:flex;align-items:center;justify-content:center;text-overflow:clip;white-space:pre-wrap;font-size:12px}.card-layout{background-color:#fff;border-radius:5px;white-space:pre-wrap;height:100%;min-height:50px;max-height:100%;margin-left:10px;margin-top:10px;margin-bottom:10px;width:97%;cursor:pointer}.label-text{text-align:center;font-size:14px;font-weight:700;margin-bottom:10px}.p-text{font-size:12px}.isActive{background-color:coral;color:#fff}.btn-control-panel{position:fixed;bottom:22px;right:100px;display:flex;gap:10px}.btn-control-panel-2{right:165px}.question-list{display:flex;flex-direction:column;gap:10px;border-radius:10px;margin-top:10px;width:100%}.question-list label{width:100%;background-color:#f9f9f9;border-top-left-radius:10px;border-top-right-radius:10px;color:#fff;padding:10px 10px 10px 20px}.question-list ::ng-deep .form-container-fluid custom-checkbox{display:block!important}.question-list ::ng-deep .form-container-fluid custom-checkbox .checkbox-container-label{display:block}.grid-templeate{display:grid;grid-template-columns:repeat(1,1fr);gap:10px}.grid{display:grid;grid-template-columns:90% auto}.grid input{border-radius:5px 0 0 5px}.grid button{border-radius:0 5px 5px 0}.button-disabled{pointer-events:none;opacity:.8;background-color:#e9ecef;padding:5px!important;border-radius:5px}#dropzone{font-family:EuropaNuova-Regular,sans-serif!important;position:absolute;margin:0;padding:0;outline:none;cursor:pointer;opacity:0}.iframe i{font-size:35px;color:#0003;margin-bottom:2%}.iframe h5{color:#000c;margin-bottom:1px}.iframe p{font-family:Poppins,sans-serif!important;text-align:center;line-height:30px;color:#303030}.iframe{cursor:pointer;width:100%;background-color:#fff;border:1px dashed #51AEE5;display:flex;background:#f2f9fd;flex-direction:column;align-items:center;border-radius:10px;padding:40px 0;margin-bottom:30px}.UploadLetterHead{display:flex;flex-direction:row;align-items:center;border:2px dashed #439bc0;width:100%;height:100%;cursor:pointer;padding:20px;border-radius:5px;position:relative}.UploadLetterHead img{margin:auto;width:45px}.UploadLetterHead-dropzone-container{font-family:EuropaNuova-Regular,sans-serif!important;position:absolute;margin:0;padding:0;outline:none;cursor:pointer;opacity:0}::ng-deep .HS_CODE_POPUP .mat-paginator-page-size{display:none;align-items:baseline;margin-right:8px}.formbold-mb-3{margin-bottom:15px}.formbold-relative{position:relative}.formbold-opacity-0{opacity:0}.formbold-stroke-current{stroke:currentColor}#supportCheckbox:checked~div span{opacity:1}.formbold-main-wrapper{display:flex;align-items:center;justify-content:center;padding:48px}.formbold-form-wrapper{margin:0 auto;max-width:570px;width:100%;background:#fff;padding:40px}.formbold-img{margin-bottom:45px}.formbold-form-title{margin-bottom:30px}.formbold-form-title h2{font-weight:600;font-size:28px;line-height:34px;color:#07074d}.formbold-form-title p{font-size:16px;line-height:24px;color:#536387;margin-top:12px}.formbold-input-flex{display:flex;gap:20px;margin-bottom:15px}.formbold-input-flex>div{width:50%}.formbold-form-input{text-align:center;width:100%;padding:13px 22px;border-radius:5px;border:1px solid #dde3ec;background:#fff;font-weight:500;font-size:16px;color:#536387;outline:none;resize:none}.formbold-form-input:focus{border-color:#6a64f1}.formbold-form-label{color:#536387;font-size:14px;line-height:24px;display:block;margin-bottom:10px}.formbold-checkbox-label{display:flex;cursor:pointer;-webkit-user-select:none;user-select:none;font-size:16px;line-height:24px;color:#536387}.formbold-checkbox-label a{margin-left:5px;color:#6a64f1}.formbold-input-checkbox{position:absolute;width:1px;height:1px;padding:0;margin:-1px;overflow:hidden;clip:rect(0,0,0,0);white-space:nowrap;border-width:0}.formbold-checkbox-inner{display:flex;align-items:center;justify-content:center;width:20px;height:20px;margin-right:16px;margin-top:2px;border:.7px solid #dde3ec;border-radius:3px}.formbold-btn{font-size:16px;border-radius:5px;padding:14px 25px;border:none;font-weight:500;background-color:#6a64f1;color:#fff;cursor:pointer;margin-top:25px}.formbold-btn:hover{box-shadow:0 3px 8px #0000000d}.Details-form-label{color:#022831;font-size:16px;border-bottom:2px solid #D4D4D4;width:100%;padding-bottom:9px}.form-container-fluid label{color:#022831;font-size:15px}.form-container-fluid .btn-primary{color:#fff;background-color:#022831;border-color:#022831;width:100%}.form-container-fluid .btn-danger{color:#fd5353;background-color:#fdd;border-color:#fd5353;display:block;width:100%}.form-container-fluid .input-button{display:grid;grid-template-columns:70% 30%;gap:10px}.form-container-fluid .input-button ::ng-deep ng-select{padding:0!important}.btn-controller{display:flex;align-items:center;justify-content:center;gap:30px;width:90%;margin:auto;padding-bottom:20px}.question-list ::ng-deep custom-checkbox{display:block!important}.question-list ::ng-deep custom-checkbox .checkbox-container-label{display:block}.disabled-ng-select{pointer-events:none;cursor:not-allowed;opacity:.6}.ErrorMessageData{position:absolute;top:10px;height:100%;background:#1f1e1e69;z-index:99;display:flex;align-items:center;border-radius:10px;width:100%}.ErrorMessageData label{background:#d12e26;padding:10px;border-radius:5px;margin:auto;color:#fff;width:calc(100% - 20px);text-align:center}.Purpose-Code .wrapper-cards{margin:auto;display:flex;align-items:center;justify-content:center;width:100%}.Purpose-Code .card{display:flex;cursor:pointer;background:#fff;box-shadow:0 2px 10px #0000001a,3px 5px 20px #0000001a;width:100%;min-height:310px;padding:24px;margin:auto}.Purpose-Code .card-tag{color:#000;font-size:20px;font-weight:700;letter-spacing:.08em}.Purpose-Code .card-article--title{color:#00000080;font-size:14px;padding-right:32px;font-weight:600}.Purpose-Code .card-article--button{display:flex;flex-flow:row nowrap;width:100%;z-index:3}.Purpose-Code .card-article--link{color:#00000080;font-size:16px;font-weight:500;letter-spacing:.06em;padding-right:.6em;z-index:3}.Purpose-Code .card-article--icon{fill:#00000080;width:1.6em;height:1.6em;padding-top:3px;z-index:3}.Purpose-Code .card-border{position:absolute;top:0;left:0;height:3px;width:100%;z-index:2;background-color:#0003;background-color:#00000080;transform-origin:top;transition:all .6s ease-in-out}.grid-controller{display:grid;grid-template-columns:repeat(auto-fit,minmax(200px,1fr));gap:10px}.NEW_PURPOSE_CODE_LIST{box-shadow:0 0 13px 7px #d4d4d4;border-radius:10px;padding:10px;margin-bottom:20px}.HSCODE ::ng-deep ng-input{padding:0!important}.HSCODE ::ng-deep ng-input input{border-radius:0!important;border-top-left-radius:.25rem!important;border-bottom-left-radius:.25rem!important}.HS_CODE_POPUP{border-radius:0!important;border-top-right-radius:.25rem!important;border-bottom-right-radius:.25rem!important}.ng-input-button{display:grid;grid-template-columns:repeat(2,1fr)}.form-container-fluid ::ng-deep .mdc-text-field{overflow:unset!important}.mat-label-input{display:flex;flex-direction:column;gap:5px}.mat-label-input label{font-size:15px}.mat-label-input input{display:block;width:100%;padding:.375rem .75rem;font-size:1rem;font-weight:400;line-height:1.5;color:#212529;background-color:#fff;background-clip:padding-box;border:1px solid #ced4da;-webkit-appearance:none;-moz-appearance:none;appearance:none;border-radius:.25rem;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;outline:none}.formGroup-division-btn-add{background:transparent;color:#000;border:2px solid black;border-radius:50px;width:25px!important;height:25px;display:flex;align-items:center;float:right;justify-content:center;cursor:pointer;position:absolute;top:-72px;right:30px}.formGroup-division-btn-remove{background:transparent;color:#000;border:2px solid black;border-radius:50px;width:25px!important;height:25px;display:flex;align-items:center;float:right;justify-content:center;cursor:pointer;position:absolute;top:-72px;right:0}.compact-input ::ng-deep .mat-form-field-infix{padding:0 4px;min-height:24px}.compact-input ::ng-deep input.mat-input-element{height:24px;padding:4px;line-height:1.4}.display-column{display:flex;flex-direction:column}\n"], dependencies: [{ kind: "ngmodule", type: SharedHomeModule }, { kind: "directive", type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i3.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i3.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i4.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i4.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i4.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i4.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i4.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i4.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i4.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i4.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i4.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i4.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i4.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "directive", type: i4.FormGroupName, selector: "[formGroupName]", inputs: ["formGroupName"] }, { kind: "directive", type: i4.FormArrayName, selector: "[formArrayName]", inputs: ["formArrayName"] }, { kind: "component", type: i5.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "component", type: i5.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "directive", type: i6.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "component", type: i7.MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { kind: "directive", type: i8.MatRadioGroup, selector: "mat-radio-group", inputs: ["color", "name", "labelPosition", "value", "selected", "disabled", "required", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioGroup"] }, { kind: "component", type: i8.MatRadioButton, selector: "mat-radio-button", inputs: ["id", "name", "aria-label", "aria-labelledby", "aria-describedby", "disableRipple", "tabIndex", "checked", "value", "labelPosition", "disabled", "required", "color", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioButton"] }, { kind: "component", type: InnerDynamicErrorComponent, selector: "inner-dynamic-error", inputs: ["formName", "fieldName", "SUBMIT_ERROR", "ErrorMessage"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: JsonReactiveComponents, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [SharedHomeModule, InnerDynamicErrorComponent, MoreContentComponent], selector: 'Json-Reactive-Forms', template: "<div class=\"form-container-fluid\" [style]=\"MainStyle\"\r\n    *ngIf=\"this.validator.dynamicFormGroup!=undefined && this.validator.dynamicFormGroup[this.id]!=undefined\"\r\n    [hidden]=\"this.validator.dynamicFormGroup[this.id]!=undefined?false:true\">\r\n    <div class=\"form-group mb-0 ErrorMessageData\" *ngIf=\"this.ErrorMessageData?.status==true\">\r\n        <label>{{this.ErrorMessageData?.text}}</label>\r\n    </div>\r\n    <ng-content *ngIf=\"morecontent==true\" select=\"more-content\"></ng-content>\r\n    <form class=\"col-12\"\r\n        *ngIf=\"this.validator.dynamicFormGroup!=undefined && this.validator.dynamicFormGroup[this.id]!=undefined\"\r\n        [formGroup]=\"this.validator.dynamicFormGroup[this.id]\" onsubmit=\"return false;\"\r\n        [ngClass]=\"{'division-panel':this.HIDE_BACKGROUND==true}\" [style]=\"this.FormStyle\"\r\n        (keyup.enter)=\"this.KEY_ENTER_ENABLED==true?onSubmit($event,this.validator.dynamicFormGroup[this.id]):''\"\r\n        autocomplete=\"disabled\" autocomplete=\"off\">\r\n        <label *ngIf=\"label!=undefined && label!=''\" class=\"Details-form-label\"\r\n            [style]=\"labelStyle\">{{this.label}}</label>\r\n        <div class=\"col-12 p-1\" [ngClass]=\"{'hidden':field?.disabled==true}\"\r\n            *ngFor=\"let field of this.validator?.FIELDS_DATA[this.id];let fieldIndex=index\">\r\n            <ng-container [ngSwitch]=\"field.type\">\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'LabelShow'\">\r\n                    <label class=\"form-control\" *ngIf=\"field?.label\">{{\r\n                        field?.label }} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <span [innerHTML]=\"field.value\"></span>\r\n                </div>\r\n\r\n                <!-- Text Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'text'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [placeholder]=\"field.placeholderText\" [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- DateTime Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'datetime'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"datetime-local\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- Time Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'time'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"time\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- Checkbox -->\r\n                <mat-checkbox *ngSwitchCase=\"'checkbox'\" [(ngModel)]=\"field.value\"\r\n                    [disabled]=\"field?.CheckboxDisabled\">{{field.label}}\r\n                    <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span>\r\n                </mat-checkbox>\r\n\r\n                <!-- Select Dropdown -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'SelectOption'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <select class=\"form-control\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\">\r\n                        <option *ngFor=\"let item of field?.items\" [value]=\"item\">{{item}}</option>\r\n                    </select>\r\n                </div>\r\n\r\n                <!-- TextArea -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'textarea'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <textarea [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\"></textarea>\r\n                </div>\r\n\r\n                <!-- Email Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'email'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"email\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n                <!-- Number Input -->\r\n                <div class=\"mat-label-input\" *ngSwitchCase=\"'number'\">\r\n                    <label>{{field.label}} <span style=\"color: red;\" *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <input type=\"number\" [formControlName]=\"field.fieldName\" [(ngModel)]=\"field.value\"\r\n                        [disabled]=\"field?.Inputdisabled\"\r\n                        (keypress)=\"validator.max_length_validator(id, field.fieldName)\">\r\n                </div>\r\n\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'EmailButton'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div [ngStyle]=\"field?.DivStyle\">\r\n                        <div>\r\n                            <label>{{ field.placeholderText }}</label>\r\n                            <input [(ngModel)]=\"field.value\" [disabled]=\"field?.Inputdisabled\" EmailValidator\r\n                                (keypress)=\"this.validator.max_length_validator(this.id, field.fieldName)\"\r\n                                [type]=\"field.InputType\" [name]=\"field.fieldName\" [formControlName]=\"field.fieldName\"\r\n                                [ngStyle]=\"field?.InputStyle\"\r\n                                (keydown)=\"dumpFunc({ value: field.value, field: this.validator?.FIELDS_DATA[this.id], form: this.validator.dynamicFormGroup[this.id] }, field?.KeyPressCallBack)\" />\r\n                        </div>\r\n                        <button mat-raised-button [style]=\"field?.buttonStyle\"\r\n                            [disabled]=\"field?.buttondisabled || this.validator.dynamicFormGroup[this.id]?.controls[field.fieldName]?.errors\">\r\n                            {{ field?.ButtonText }}\r\n                        </button>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'NumberButton'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div [ngStyle]=\"field?.DivStyle\">\r\n                        <div>\r\n                            <label>{{ field.placeholderText }}</label>\r\n                            <input [(ngModel)]=\"field.value\" [disabled]=\"field?.Inputdisabled\" MaxMinValidation\r\n                                (keypress)=\"this.validator.max_length_validator(this.id, field.fieldName)\"\r\n                                [type]=\"field?.InputType\" [name]=\"field.fieldName\" [formControlName]=\"field.fieldName\"\r\n                                [ngStyle]=\"field?.InputStyle\"\r\n                                (keydown)=\"dumpFunc({ value: field.value, field: this.validator?.FIELDS_DATA[this.id], form: this.validator.dynamicFormGroup[this.id] }, field?.KeyPressCallBack)\" />\r\n                        </div>\r\n                        <button mat-raised-button [style]=\"field?.buttonStyle\"\r\n                            [disabled]=\"field?.buttondisabled || this.validator.dynamicFormGroup[this.id]?.controls[field.fieldName]?.errors\">\r\n                            {{ field?.ButtonText }}\r\n                        </button>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'password'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div class=\"col-12 p-0\">\r\n                        <div>\r\n                            <label>{{ field.placeholderText }}</label>\r\n                            <input [(ngModel)]=\"field.value\" PasswordValidation\r\n                                (keypress)=\"this.validator.max_length_validator(this.id, field.fieldName)\"\r\n                                [type]=\"field.showhide ? 'text' : 'password'\" [name]=\"field.fieldName\" />\r\n                            <button mat-icon-button matSuffix (click)=\"field.showhide = !field.showhide\">\r\n                            </button>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0\" *ngSwitchCase=\"'date'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <div>\r\n                        <label>{{ field.placeholderText }}</label>\r\n                        <input [(ngModel)]=\"field.value\" [disabled]=\"field?.Inputdisabled\"\r\n                            (change)=\"dumpFunc({ value: $event?.target, field: this.validator?.FIELDS_DATA[this.id], form: this.validator.dynamicFormGroup[this.id] }, field?.callback)\"\r\n                            [type]=\"field.type\" [name]=\"field.fieldName\" [formControlName]=\"field.fieldName\" />\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MatCheckBox'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <mat-radio-group [(ngModel)]=\"field.value\"\r\n                        (change)=\"field?.callback ? field?.callback($event) : ''\">\r\n                        <mat-radio-button *ngFor=\"let item of field?.items\" [value]=\"item.value\">{{ item.text\r\n                            }}</mat-radio-button>\r\n                    </mat-radio-group>\r\n                </div>\r\n\r\n                <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MultiCheckBox'\">\r\n                    <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                            *ngIf=\"field?.rules?.required\">*</span></label>\r\n                    <mat-checkbox [formControlName]=\"field.fieldName\" *ngFor=\"let checkbox of field?.checkboxlabel\"\r\n                        [(ngModel)]=\"checkbox.checked\"\r\n                        (change)=\"HideShowInput($event, field?.HideShowInput, fieldIndex, field?.callback)\">\r\n                        {{ checkbox.label }}\r\n                    </mat-checkbox>\r\n                </div>\r\n                <div class=\"form-group mb-0 p-0\" *ngIf=\"field?.showhide === true || field?.showhide === undefined\">\r\n                    <div class=\"form-group mb-0\" *ngSwitchCase=\"'formGroup'\" [formArrayName]=\"field.fieldName\">\r\n                        <label *ngIf=\"field.label\">{{ field.label }} <span style=\"color: red;\"\r\n                                *ngIf=\"field?.rules?.required\">*</span></label>\r\n                        <div class=\"col-12 p-0\" [style]=\"field?.ParentStyle\">\r\n                            <div class=\"col-12 formGroup-division-panel\" [style]=\"field?.Style\"\r\n                                *ngFor=\"let Optionfield of field?.NewFromGroup; let OptionfieldIndex = index\">\r\n                                <label>{{ field?.GroupLabel[OptionfieldIndex] }}</label>\r\n                                <div class=\"col-12 row m-0 add-btn-panel p-0\" *ngIf=\"field?.AddNewRequried === true\">\r\n                                    <button mat-raised-button color=\"primary\"\r\n                                        *ngIf=\"(field?.NewFromGroup?.length - 1) === OptionfieldIndex && (field?.NewFromGroup?.length) !== field?.MAX_LIMIT\"\r\n                                        (click)=\"this.validator.addNewFormArray(this.id, fieldIndex, field.fieldName)\">\r\n                                        <span>+</span>\r\n                                    </button>\r\n                                    <button mat-raised-button color=\"warn\" *ngIf=\"OptionfieldIndex !== 0\"\r\n                                        (click)=\"this.validator.removeNewFormArray(this.id, fieldIndex, field.fieldName, OptionfieldIndex)\">\r\n                                        <span>-</span>\r\n                                    </button>\r\n                                </div>\r\n                                <div class=\"col-10 p-0\"\r\n                                    *ngFor=\"let FormOptionfield of Optionfield?.FromGroupObj; let FormOptionfieldIndex = index\"\r\n                                    [formGroupName]=\"OptionfieldIndex\"\r\n                                    [ngClass]=\"{'hidden': FormOptionfield?.disabled === true}\">\r\n                                    <ng-container [ngSwitch]=\"FormOptionfield?.type\">\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'LabelShow'\">\r\n                                            <label class=\"form-control\" *ngIf=\"FormOptionfield?.label\">{{\r\n                                                FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                    *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                            <span [innerHTML]=\"FormOptionfield.value\"></span>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'text'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"text\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'email'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"email\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'number'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"number\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0\" *ngSwitchCase=\"'date'\">\r\n                                            <div>\r\n                                                <label *ngIf=\"FormOptionfield?.label\">{{\r\n                                                    FormOptionfield?.label }} <span style=\"color: red;\"\r\n                                                        *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                                <input class=\"form-control\" type=\"date\"\r\n                                                    [formControlName]=\"FormOptionfield?.fieldName\"\r\n                                                    [(ngModel)]=\"FormOptionfield.value\"\r\n                                                    [disabled]=\"FormOptionfield?.disabled\" />\r\n                                            </div>\r\n                                        </div>\r\n                                        <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MatCheckBox'\">\r\n                                            <label *ngIf=\"FormOptionfield.label\">{{ FormOptionfield.label }} <span\r\n                                                    style=\"color: red;\"\r\n                                                    *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                            <mat-radio-group [(ngModel)]=\"FormOptionfield.value\"\r\n                                                [formControlName]=\"FormOptionfield.fieldName\"\r\n                                                (change)=\"FormOptionfield?.callback ? FormOptionfield?.callback($event) : ''\">\r\n                                                <mat-radio-button *ngFor=\"let item of FormOptionfield?.items\"\r\n                                                    [value]=\"item.value\">{{ item.text\r\n                                                    }}</mat-radio-button>\r\n                                            </mat-radio-group>\r\n                                        </div>\r\n\r\n                                        <div class=\"form-group mb-0 display-column\" *ngSwitchCase=\"'MultiCheckBox'\">\r\n                                            <label *ngIf=\"FormOptionfield.label\">{{ FormOptionfield.label }} <span\r\n                                                    style=\"color: red;\"\r\n                                                    *ngIf=\"FormOptionfield?.rules?.required\">*</span></label>\r\n                                            <mat-checkbox [formControlName]=\"FormOptionfield.fieldName\"\r\n                                                *ngFor=\"let checkbox of FormOptionfield?.checkboxlabel\"\r\n                                                [(ngModel)]=\"checkbox.checked\"\r\n                                                (change)=\"HideShowInput($event, field?.HideShowInput, fieldIndex, field?.callback)\">\r\n                                                {{ checkbox?.label }}\r\n                                            </mat-checkbox>\r\n                                        </div>\r\n                                    </ng-container>\r\n                                    <inner-dynamic-error [SUBMIT_ERROR]=\"this.SUBMIT_ERROR\"\r\n                                        [formName]=\"this.validator.dynamicFormGroup[this.id]?.controls[field.fieldName]?.controls[OptionfieldIndex]\"\r\n                                        [fieldName]=\"FormOptionfield?.fieldName\"></inner-dynamic-error>\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </ng-container>\r\n            <inner-dynamic-error [SUBMIT_ERROR]=\"this.SUBMIT_ERROR\"\r\n                [formName]=\"this.validator.dynamicFormGroup[this.id]\" [fieldName]=\"field.fieldName\"\r\n                [ErrorMessage]=\"field?.ErrorMessage\"></inner-dynamic-error>\r\n        </div>\r\n    </form>\r\n    <div [ngClass]=\"{'more-button-panel':this.BUTTON_PANEL_SHOW==true}\"\r\n        [style]=\"this.BUTTON_PANEL_HIDE==true?'display:flex;':'display:none'\" [style]=\"ButtonPanelStyle\">\r\n        <ng-content></ng-content>\r\n        <div class=\"btn-controller\"\r\n            [ngClass]=\"{'button-show':this.HIDE_SUBMIT_BUTTON==true,'button-hide':this.HIDE_SUBMIT_BUTTON==false}\">\r\n            <button class=\"btn btn-danger\" (click)=\"CancelRouterNavigate(this.CancelRoute)\">Cancel</button>\r\n            <button *ngIf=\"BUTTON_PANEL_SHOW==true\" type=\"button\" class=\"btn btn-primary submit-button\" [id]=\"this.id\"\r\n                [style]=\"this.HIDE_SUBMIT_BUTTON==true?'display:block;':'display:none'\" [style]=\"SubmitButtonStyle\"\r\n                [disabled]=\"this.validator.dynamicFormGroup[this.id]?.invalid\"\r\n                (click)=\"onSubmit($event,this.validator.dynamicFormGroup[this.id]);\">{{SubmitName}}</button>\r\n            <button *ngIf=\"BUTTON_PANEL_SHOW==false\" type=\"button\" class=\"btn btn-primary submit-button\" [id]=\"this.id\"\r\n                [style]=\"SubmitButtonStyle\" [disabled]=\"this.validator.dynamicFormGroup[this.id]?.invalid\"\r\n                (click)=\"onSubmit($event,this.validator.dynamicFormGroup[this.id]);\">{{SubmitName}}</button>\r\n        </div>\r\n    </div>\r\n</div>", styles: [".content-wrap{margin:auto}.upload-panel{display:grid;grid-template-columns:60% 40%;padding:10px;gap:10px;margin-right:10px;position:absolute;width:100%;top:35px}.form-container-fluid{padding:0;overflow:unset;max-height:unset;border-radius:10px;width:98%;margin:auto}.division-panel{padding:30px;border-radius:10px;margin-bottom:10px}.formGroup-division-panel{padding:10px;border-radius:10px;margin-bottom:10px;background-color:#fff}.add-btn-panel{display:block}.add-btn-panel button{background:#2f58b8;color:#fff;border:none;border-radius:50px;width:25px!important;height:25px;display:flex;align-items:center;float:right;justify-content:center;margin-right:10px;cursor:pointer}.disbaled-h5{display:block;width:100%;height:calc(1.55em + .75rem + 2px);padding:.375rem .75rem;font-size:1rem;font-weight:300;line-height:1.55;color:#000;background-color:#fff;background-clip:padding-box;border:1px solid #c1ccd3;border-radius:.3rem;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}.envelope-icon,.lock-icon{position:absolute;top:18px;left:13px;color:#000;z-index:999}.eye-open-close-icon{position:absolute;top:18px;right:15px;color:#000;cursor:pointer;z-index:999}.email-password-padding{border-radius:50px;padding:23px 30px;position:relative}.email-input-icon{position:relative}.form-container-fluid::placeholder{color:red;opacity:1}.form-container-fluid:-ms-input-placeholder{color:red}.form-container-fluid::-ms-input-placeholder{color:red}.email-input-icon:before{font-family:\"Font Awesome 5 Free\";position:absolute;left:11px;top:28%;content:\"\\f0e0\";z-index:9999;display:flex;margin:auto}.img-popup{width:100%;height:100%;border-radius:5px}.form-container-fluid ::ng-deep custom-checkbox{display:grid;grid-template-columns:repeat(2,1fr);align-items:center;justify-content:center}.image-card-list{display:flex;flex-wrap:wrap;gap:10px;margin-top:10px;align-items:center;justify-content:center}.image-card-list .image-card{display:flex;flex-direction:column;position:relative;flex-basis:23.7%;align-items:center;justify-content:center}.image-card-list .image-card button{position:absolute;right:-1px;top:-1px;background:transparent;color:red;border:0}.image-card-list .image-card img{width:100%;height:150px;padding:5px;border-radius:5px}.image-card-list .image-card p{position:absolute;bottom:0;margin:0;z-index:999999;background:#000;width:100%;border-bottom-left-radius:5px;border-bottom-right-radius:5px;color:#fff;text-align:center;font-size:12px}.hidden,.button-hide{display:none!important}.more-button-panel{justify-content:flex-end;display:inline-flex;justify-items:flex-end;align-items:flex-start;margin:auto 0 auto auto;width:100%;gap:20px}.button-show{display:block;height:50px;margin:auto 0 0 auto}.yes-btn{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.no-btn{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.no-button{float:left;padding:0 10px;margin:0;height:32px;background:#fc5e5e!important;border:1px solid #FC5E5E!important;border-radius:0 5px 5px 0;color:#fff}.yes-button{float:left;padding:0 10px;margin:0;height:32px;background:#0079ff!important;border:1px solid #D9D9D9!important;color:#fff;border-radius:5px 0 0 5px}.remove-no-button-1{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.remove-no-button-2{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.row-reverse{flex-direction:row-reverse}.row-reverse .yes-btn{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.row-reverse .no-btn{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.row-reverse .no-button{float:left;padding:0 10px;margin:0;height:32px;background:#0079ff;border:1px solid #D9D9D9;color:#fff;border-radius:5px 0 0 5px}.row-reverse .yes-button{float:left;padding:0 10px;margin:0;height:32px;background:#fc5e5e;border:1px solid #FC5E5E;border-radius:0 5px 5px 0;color:#fff}.row-reverse .remove-no-button-1{float:left;padding:0 10px;margin:0;border-radius:0 5px 5px 0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777}.row-reverse .remove-no-button-2{float:left;padding:0 10px;margin:0;height:32px;background:#fff;border:1px solid #D9D9D9;color:#777;border-radius:5px 0 0 5px}.import_export_sec{margin:auto auto auto 0}.filter_section_top{display:grid;width:100%;background-color:#fff!important;margin:0;border-radius:30px;box-shadow:unset;padding:5px}.middle_datatable .support{height:calc(100vh - 159px)}.table-padding{background-color:transparent!important;box-shadow:none}.content-wrap.scroll-bar-main{overflow:auto;padding:0;overflow-x:hidden}.filter_right_new.padding_new_top{display:flex;gap:10px}.heading_common_tag{display:inline-block;width:100%;font-size:14px;font-weight:400;color:#fffaf0;margin-left:20px}.upload-panel{display:grid;grid-template-columns:calc(100% - 389px) 389px;padding:10px;gap:10px;margin-right:10px;position:unset!important;width:100%!important}.form-container-fluid{padding:0;overflow:unset;max-height:unset;border-radius:10px}.custom{width:300px}.custom ::ng-deep .ng-select .ng-select-container{color:#333;background-color:#fff;border:1px solid #ccc;min-height:36px;align-items:center;border-radius:5px 0 0 5px}.label-name-amount{display:grid;grid-template-columns:repeat(1,1fr);background:#fff;padding:10px;border-radius:10px;box-shadow:0 0 2px 2px #d4d4d4;margin-bottom:10px}.label-name-amount p{font-size:14px;margin:0}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-header-description{display:flex;flex-grow:1;flex-basis:unset!important;align-items:center;overflow:auto;margin-right:0!important}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-header-title{display:flex;flex-grow:1;flex-basis:unset!important;align-items:center;background:#000;width:100%!important;padding:5px;margin-right:0!important;color:#fff;border-top-left-radius:5px;border-top-right-radius:5px}.SHIPING_BILL_POPUP .col-td-th-3{width:170px!important}.SHIPING_BILL_POPUP .table>:not(caption)>*>*{background-color:transparent!important}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-body{padding:0 24px 16px;overflow:auto}.SHIPING_BILL_POPUP ::ng-deep .mat-accordion{margin-top:10px!important;margin:auto;display:flex;flex-direction:column;width:calc(100vw - 270px)}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-spacing{margin:16px 0;background-color:#fffaf0}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel{margin-bottom:20px}.SHIPING_BILL_POPUP ::ng-deep .d-grid{display:grid!important;grid-template-columns:repeat(6,1fr);padding:20px;border-radius:10px;margin-top:10px;margin-left:20px;gap:20px}.SHIPING_BILL_POPUP .flex-column{flex-direction:column!important;width:100%}.SHIPING_BILL_POPUP .flex-column-1{flex-direction:column!important;width:200px}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-panel-header{height:auto;padding:0}.SHIPING_BILL_POPUP .prevent-click{pointer-events:none}.SHIPING_BILL_POPUP .authorize-click{pointer-events:auto}.SHIPING_BILL_POPUP ::ng-deep .mat-expansion-indicator{display:none!important}.match-off ::ng-deep .upload-components-header{position:relative!important}.disabled-tr{pointer-events:none;opacity:.6;position:relative}.disabled-tr:after{content:\"Already Used\";position:absolute;left:0;font-size:20px;color:red;opacity:1;background:#6495ed;padding:20px}.Transaction-btn{margin:auto 20px auto auto;background-color:transparent;border:none}.Transaction-btn:hover{color:#597a8a}::ng-deep ng-custom-filter-popup .filter_main{width:540px!important}.form-label-control{display:block;width:100%;padding:.5rem .75rem;font-size:1rem;line-height:1.25;color:#495057;background-color:#fff;background-image:none;background-clip:padding-box;border:1px solid rgba(0,0,0,.15);border-radius:.25rem;transition:border-color ease-in-out .15s,box-shadow ease-in-out .15s}.table-custom{height:100%;width:100%;padding:10px}.thead-card{display:grid;grid-template-columns:200px calc(100% - 200px);align-items:center}.tbody-card{display:grid;grid-template-columns:200px auto;align-items:center;background-color:#21609b;margin-bottom:20px;border-radius:5px;color:#000}.tbody-card .p-border{height:99%;padding:0;margin:0;text-align:center;display:flex;align-items:center;justify-content:center}.colspan{display:grid;grid-template-columns:150px auto}.colspan p{margin:auto;display:flex;flex-direction:column;text-align:left!important;padding:10px;width:100%}.groupname-text{background-color:#3e34c9;border-top-left-radius:10px;border-bottom-left-radius:10px;color:#fff}.colspanitem{background-color:#7508ce;width:100%;border-top-right-radius:10px;border-bottom-right-radius:10px}.text-left{text-align:left!important;padding:10px;width:95%;display:flex;align-items:center;justify-content:center;text-overflow:clip;white-space:pre-wrap;font-size:12px}.card-layout{background-color:#fff;border-radius:5px;white-space:pre-wrap;height:100%;min-height:50px;max-height:100%;margin-left:10px;margin-top:10px;margin-bottom:10px;width:97%;cursor:pointer}.label-text{text-align:center;font-size:14px;font-weight:700;margin-bottom:10px}.p-text{font-size:12px}.isActive{background-color:coral;color:#fff}.btn-control-panel{position:fixed;bottom:22px;right:100px;display:flex;gap:10px}.btn-control-panel-2{right:165px}.question-list{display:flex;flex-direction:column;gap:10px;border-radius:10px;margin-top:10px;width:100%}.question-list label{width:100%;background-color:#f9f9f9;border-top-left-radius:10px;border-top-right-radius:10px;color:#fff;padding:10px 10px 10px 20px}.question-list ::ng-deep .form-container-fluid custom-checkbox{display:block!important}.question-list ::ng-deep .form-container-fluid custom-checkbox .checkbox-container-label{display:block}.grid-templeate{display:grid;grid-template-columns:repeat(1,1fr);gap:10px}.grid{display:grid;grid-template-columns:90% auto}.grid input{border-radius:5px 0 0 5px}.grid button{border-radius:0 5px 5px 0}.button-disabled{pointer-events:none;opacity:.8;background-color:#e9ecef;padding:5px!important;border-radius:5px}#dropzone{font-family:EuropaNuova-Regular,sans-serif!important;position:absolute;margin:0;padding:0;outline:none;cursor:pointer;opacity:0}.iframe i{font-size:35px;color:#0003;margin-bottom:2%}.iframe h5{color:#000c;margin-bottom:1px}.iframe p{font-family:Poppins,sans-serif!important;text-align:center;line-height:30px;color:#303030}.iframe{cursor:pointer;width:100%;background-color:#fff;border:1px dashed #51AEE5;display:flex;background:#f2f9fd;flex-direction:column;align-items:center;border-radius:10px;padding:40px 0;margin-bottom:30px}.UploadLetterHead{display:flex;flex-direction:row;align-items:center;border:2px dashed #439bc0;width:100%;height:100%;cursor:pointer;padding:20px;border-radius:5px;position:relative}.UploadLetterHead img{margin:auto;width:45px}.UploadLetterHead-dropzone-container{font-family:EuropaNuova-Regular,sans-serif!important;position:absolute;margin:0;padding:0;outline:none;cursor:pointer;opacity:0}::ng-deep .HS_CODE_POPUP .mat-paginator-page-size{display:none;align-items:baseline;margin-right:8px}.formbold-mb-3{margin-bottom:15px}.formbold-relative{position:relative}.formbold-opacity-0{opacity:0}.formbold-stroke-current{stroke:currentColor}#supportCheckbox:checked~div span{opacity:1}.formbold-main-wrapper{display:flex;align-items:center;justify-content:center;padding:48px}.formbold-form-wrapper{margin:0 auto;max-width:570px;width:100%;background:#fff;padding:40px}.formbold-img{margin-bottom:45px}.formbold-form-title{margin-bottom:30px}.formbold-form-title h2{font-weight:600;font-size:28px;line-height:34px;color:#07074d}.formbold-form-title p{font-size:16px;line-height:24px;color:#536387;margin-top:12px}.formbold-input-flex{display:flex;gap:20px;margin-bottom:15px}.formbold-input-flex>div{width:50%}.formbold-form-input{text-align:center;width:100%;padding:13px 22px;border-radius:5px;border:1px solid #dde3ec;background:#fff;font-weight:500;font-size:16px;color:#536387;outline:none;resize:none}.formbold-form-input:focus{border-color:#6a64f1}.formbold-form-label{color:#536387;font-size:14px;line-height:24px;display:block;margin-bottom:10px}.formbold-checkbox-label{display:flex;cursor:pointer;-webkit-user-select:none;user-select:none;font-size:16px;line-height:24px;color:#536387}.formbold-checkbox-label a{margin-left:5px;color:#6a64f1}.formbold-input-checkbox{position:absolute;width:1px;height:1px;padding:0;margin:-1px;overflow:hidden;clip:rect(0,0,0,0);white-space:nowrap;border-width:0}.formbold-checkbox-inner{display:flex;align-items:center;justify-content:center;width:20px;height:20px;margin-right:16px;margin-top:2px;border:.7px solid #dde3ec;border-radius:3px}.formbold-btn{font-size:16px;border-radius:5px;padding:14px 25px;border:none;font-weight:500;background-color:#6a64f1;color:#fff;cursor:pointer;margin-top:25px}.formbold-btn:hover{box-shadow:0 3px 8px #0000000d}.Details-form-label{color:#022831;font-size:16px;border-bottom:2px solid #D4D4D4;width:100%;padding-bottom:9px}.form-container-fluid label{color:#022831;font-size:15px}.form-container-fluid .btn-primary{color:#fff;background-color:#022831;border-color:#022831;width:100%}.form-container-fluid .btn-danger{color:#fd5353;background-color:#fdd;border-color:#fd5353;display:block;width:100%}.form-container-fluid .input-button{display:grid;grid-template-columns:70% 30%;gap:10px}.form-container-fluid .input-button ::ng-deep ng-select{padding:0!important}.btn-controller{display:flex;align-items:center;justify-content:center;gap:30px;width:90%;margin:auto;padding-bottom:20px}.question-list ::ng-deep custom-checkbox{display:block!important}.question-list ::ng-deep custom-checkbox .checkbox-container-label{display:block}.disabled-ng-select{pointer-events:none;cursor:not-allowed;opacity:.6}.ErrorMessageData{position:absolute;top:10px;height:100%;background:#1f1e1e69;z-index:99;display:flex;align-items:center;border-radius:10px;width:100%}.ErrorMessageData label{background:#d12e26;padding:10px;border-radius:5px;margin:auto;color:#fff;width:calc(100% - 20px);text-align:center}.Purpose-Code .wrapper-cards{margin:auto;display:flex;align-items:center;justify-content:center;width:100%}.Purpose-Code .card{display:flex;cursor:pointer;background:#fff;box-shadow:0 2px 10px #0000001a,3px 5px 20px #0000001a;width:100%;min-height:310px;padding:24px;margin:auto}.Purpose-Code .card-tag{color:#000;font-size:20px;font-weight:700;letter-spacing:.08em}.Purpose-Code .card-article--title{color:#00000080;font-size:14px;padding-right:32px;font-weight:600}.Purpose-Code .card-article--button{display:flex;flex-flow:row nowrap;width:100%;z-index:3}.Purpose-Code .card-article--link{color:#00000080;font-size:16px;font-weight:500;letter-spacing:.06em;padding-right:.6em;z-index:3}.Purpose-Code .card-article--icon{fill:#00000080;width:1.6em;height:1.6em;padding-top:3px;z-index:3}.Purpose-Code .card-border{position:absolute;top:0;left:0;height:3px;width:100%;z-index:2;background-color:#0003;background-color:#00000080;transform-origin:top;transition:all .6s ease-in-out}.grid-controller{display:grid;grid-template-columns:repeat(auto-fit,minmax(200px,1fr));gap:10px}.NEW_PURPOSE_CODE_LIST{box-shadow:0 0 13px 7px #d4d4d4;border-radius:10px;padding:10px;margin-bottom:20px}.HSCODE ::ng-deep ng-input{padding:0!important}.HSCODE ::ng-deep ng-input input{border-radius:0!important;border-top-left-radius:.25rem!important;border-bottom-left-radius:.25rem!important}.HS_CODE_POPUP{border-radius:0!important;border-top-right-radius:.25rem!important;border-bottom-right-radius:.25rem!important}.ng-input-button{display:grid;grid-template-columns:repeat(2,1fr)}.form-container-fluid ::ng-deep .mdc-text-field{overflow:unset!important}.mat-label-input{display:flex;flex-direction:column;gap:5px}.mat-label-input label{font-size:15px}.mat-label-input input{display:block;width:100%;padding:.375rem .75rem;font-size:1rem;font-weight:400;line-height:1.5;color:#212529;background-color:#fff;background-clip:padding-box;border:1px solid #ced4da;-webkit-appearance:none;-moz-appearance:none;appearance:none;border-radius:.25rem;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;outline:none}.formGroup-division-btn-add{background:transparent;color:#000;border:2px solid black;border-radius:50px;width:25px!important;height:25px;display:flex;align-items:center;float:right;justify-content:center;cursor:pointer;position:absolute;top:-72px;right:30px}.formGroup-division-btn-remove{background:transparent;color:#000;border:2px solid black;border-radius:50px;width:25px!important;height:25px;display:flex;align-items:center;float:right;justify-content:center;cursor:pointer;position:absolute;top:-72px;right:0}.compact-input ::ng-deep .mat-form-field-infix{padding:0 4px;min-height:24px}.compact-input ::ng-deep input.mat-input-element{height:24px;padding:4px;line-height:1.4}.display-column{display:flex;flex-direction:column}\n"] }]
        }], ctorParameters: () => [{ type: i1.DomSanitizer }, { type: ReactiveJsonFormsService }], propDecorators: { label: [{
                type: Input,
                args: ['label']
            }], labelStyle: [{
                type: Input,
                args: ['labelStyle']
            }], FormStyle: [{
                type: Input,
                args: ['FormStyle']
            }], MainStyle: [{
                type: Input,
                args: ['MainStyle']
            }], DetailsShow: [{
                type: Input,
                args: ['DetailsShow']
            }], id: [{
                type: Input,
                args: ['id']
            }], SubmitButtonStyle: [{
                type: Input,
                args: ['SubmitButtonStyle']
            }], ButtonPanelStyle: [{
                type: Input,
                args: ['ButtonPanelStyle']
            }], CancelRoute: [{
                type: Input,
                args: ['CancelRoute']
            }], TypeOfValue: [{
                type: Input,
                args: ['TypeOfValue']
            }], SubmitName: [{
                type: Input,
                args: ['SubmitName']
            }], AddNewRequried: [{
                type: Input,
                args: ['AddNewRequried']
            }], OnSubmitEvent: [{
                type: Output,
                args: ['OnSubmitEvent']
            }], AddNewBank: [{
                type: Output,
                args: ['AddNewBank']
            }], RawValue: [{
                type: Output,
                args: ['RawValueEvent']
            }], BankEvent: [{
                type: Output,
                args: ['BankEvent']
            }], SelectionBank: [{
                type: Output,
                args: ['SelectionBank']
            }], YesNoCheckBoxEvent: [{
                type: Output,
                args: ['YesNoCheckBoxEvent']
            }], SHIPPING_BILL_EVENT: [{
                type: Output,
                args: ['SHIPPING_BILL_EVENT']
            }], CommericalNoEvent: [{
                type: Output,
                args: ['CommericalNoEvent']
            }], AddButton: [{
                type: Output,
                args: ['AddButton']
            }], BL_COPY_EVENT: [{
                type: Output,
                args: ['BL_COPY_EVENT']
            }], BENEFICIARY_EVENT: [{
                type: Output,
                args: ['BENEFICIARY_EVENT']
            }], BUYER_BENEE_EVENT: [{
                type: Output,
                args: ['BUYER_BENEE_EVENT']
            }], PIPO_EVENT: [{
                type: Output,
                args: ['PIPO_EVENT']
            }], HIDE_BACKGROUND: [{
                type: Input,
                args: ['HIDE_BACKGROUND']
            }], HIDE_SUBMIT_BUTTON: [{
                type: Input,
                args: ['HIDE_SUBMIT_BUTTON']
            }], KEY_ENTER_ENABLED: [{
                type: Input,
                args: ['KEY_ENTER_ENABLED']
            }], ADD_NEW_BUTTON_VISIBLE: [{
                type: Input,
                args: ['ADD_NEW_BUTTON_VISIBLE']
            }], BuyerNotFound: [{
                type: ViewChild,
                args: ['BuyerNotFoundPanel']
            }], BeneficiaryNotFound: [{
                type: ViewChild,
                args: ['BeneficiaryNotFoundPanel']
            }], morecontent: [{
                type: Input,
                args: ['morecontent']
            }], BUTTON_PANEL_SHOW: [{
                type: Input,
                args: ['BUTTON_PANEL_SHOW']
            }], BUTTON_PANEL_HIDE: [{
                type: Input,
                args: ['BUTTON_PANEL_HIDE']
            }], SubmitButtonDisabled: [{
                type: Input,
                args: ['SubmitButtonDisabled']
            }], ResetForm: [{
                type: Input,
                args: ['ResetForm']
            }], DropDownEvent: [{
                type: Output,
                args: ['DropDownEvent']
            }], ArrayList_ObjectEvent: [{
                type: Output,
                args: ['ArrayList_ObjectEvent']
            }], FormValueChanges: [{
                type: Output,
                args: ['FormValueChanges']
            }], CancelEvent: [{
                type: Output,
                args: ['CancelEvent']
            }], ErrorMessageData: [{
                type: Input,
                args: ['ErrorMessageData']
            }], LETTER_HEADE_URL: [{
                type: Output,
                args: ['LETTER_HEADE_URL']
            }] } });

class FormControllerComponent {
    formService;
    validator;
    stepForm;
    activeStep$;
    onSubmit = new EventEmitter();
    onSubmitArray = new EventEmitter();
    onSubmitFull = new EventEmitter();
    OnChangesToggleEvent = new EventEmitter();
    NextEvent = new EventEmitter();
    BackEvent = new EventEmitter();
    ref = new EventEmitter();
    id = "demo";
    ButtonName = "Submit";
    item;
    STORE_MULTI_FORM_VALUE = {};
    bootstraptoasts;
    constructor(formService, validator) {
        this.formService = formService;
        this.validator = validator;
    }
    ngOnInit() {
        this.ref.emit(this);
    }
    ngOnChanges(changes) {
        for (const propName in changes) {
            if (changes.hasOwnProperty(propName)) {
                const change = changes[propName];
                if (change.currentValue !== undefined) {
                    this[propName] = change.currentValue;
                }
            }
        }
        this.stepForm = this.formService.stepForm;
        this.formService.FORM_CREATE_LIST = this.item?.FORM_CREATE_LIST;
        this.formService.FORM_CREATE_BOOLEAN = false;
        if (Object.keys(this.item?.FORM_LIST)?.length != 0) {
            this.formService.multiStepFormList = [];
            this.formService.FORM_CREATE_LIST?.forEach(async (element) => {
                console.log(this.item?.FORM_LIST, "changes");
                const form_create = await this.validator.buildForm({ ...this.item?.FORM_LIST[element] }, element);
                this.formService.multiStepFormList?.push(form_create[element]);
                if (this.formService.multiStepFormList?.length == this.formService.FORM_CREATE_LIST?.length) {
                    this.formService.FORM_CREATE_BOOLEAN = true;
                    console.log(this.formService.multiStepFormList, "this.formService.multiStepFormList");
                }
            });
        }
    }
    confirmAndSubmitForm(value) {
        let temp_value = [];
        this.formService.multiStepFormList?.forEach(element => {
            temp_value?.push(element?.getRawValue());
        });
        this.NextEvent.emit({ value: temp_value[temp_value?.length - 1], status: value?.value?.status, index: value?.index });
        const isEmpty = !Object.values(this.formService.multiStepFormList[this.formService.multiStepFormList?.length - 1]).some(x => x !== null && x !== '');
        if (isEmpty == false && value?.index == temp_value?.length) {
            this.onSubmitFull.emit({ status: "VALID", value: temp_value[temp_value?.length - 1] });
            this.onSubmit.emit(temp_value[temp_value?.length - 1]);
        }
    }
    get getmultiStepFormList() {
        return this.formService.multiStepFormList;
    }
    getStatus(item, i) {
        const bool = this.validator?.dynamicFormGroup[item]?.status != 'INVALID' && this.formService.TitleDescription[i]?.condition;
        return !bool;
    }
    get ResetForm() {
        if (this.formService.multiStepFormList != undefined) {
            this.formService.multiStepFormList.forEach(element => {
                element?.reset();
            });
            this.formService.activeStepSubject.next(1);
        }
        return true;
    }
    getFormData() {
        this.getAllFormErrors();
        let allFormValues = {};
        let status = "VALID"; // Default to VALID
        this.formService.multiStepFormList.forEach((formGroup, index) => {
            $('.submit-button#' + this.formService.FORM_CREATE_LIST[index]).click();
            allFormValues = { ...allFormValues, ...formGroup?.value };
            // Check if the formGroup status is INVALID
            if (formGroup?.status === "INVALID") {
                status = "INVALID"; // Mark status as INVALID if any formGroup is invalid
            }
        });
        this.onSubmit.emit({ value: allFormValues, status: status });
        console.log(this.formService.multiStepFormList, allFormValues, status, "this.formService.multiStepFormList");
    }
    ERROR_STATUS = false;
    allErrors = []; // Object to hold errors
    getAllFormErrors() {
        this.allErrors = [];
        this.ERROR_STATUS = false;
        // Custom messages for form validation errors
        const errorMessages = {
            required: (error, fieldName) => `This ${fieldName} field is required.`,
            minlength: (error, fieldName) => `This ${fieldName} field is Minimum length is ${error.requiredLength} characters. You entered ${error.actualLength} characters.`,
            maxlength: (error, fieldName) => `This ${fieldName} field is Maximum length is ${error.requiredLength} characters. You entered ${error.actualLength} characters.`,
            email: (error, fieldName) => `This ${fieldName} Please enter a valid email address.`,
            pattern: (error, fieldName) => `This ${fieldName} Invalid format.`
        };
        this.formService.multiStepFormList.forEach((formGroup, index) => {
            Object.keys(formGroup.controls).forEach((controlName) => {
                const control = formGroup.get(controlName); // Get the form control
                if (control && control.errors) {
                    Object.keys(control.errors).forEach((errorKey) => {
                        const error = control.errors[errorKey];
                        if (errorMessages[errorKey]) {
                            if (typeof errorMessages[errorKey] === 'function') {
                                this.allErrors.push(errorMessages[errorKey](error, controlName));
                            }
                            else {
                                this.allErrors.push(errorMessages[errorKey]);
                            }
                        }
                        else {
                            this.allErrors.push(`Error: ${errorKey}`);
                        }
                    });
                }
            });
        });
        if (this.allErrors.length != 0) {
            this.ERROR_STATUS = true;
            this.bootstraptoasts?.OpenModel;
        }
        else {
            this.ERROR_STATUS = false;
        }
        return this.allErrors; // Return the collected errors
    }
    OnChangesToggle(value) {
        this.OnChangesToggleEvent.emit(value);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: FormControllerComponent, deps: [{ token: FormControllerService }, { token: ReactiveJsonFormsService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.9", type: FormControllerComponent, selector: "progress-form", inputs: { id: "id", ButtonName: "ButtonName", item: "item" }, outputs: { onSubmit: "onSubmit", onSubmitArray: "onSubmitArray", onSubmitFull: "onSubmitFull", OnChangesToggleEvent: "OnChangesToggleEvent", NextEvent: "NextEvent", BackEvent: "BackEvent", ref: "ref" }, viewQueries: [{ propertyName: "bootstraptoasts", first: true, predicate: ["bootstraptoasts"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div class=\"company-update-form\">\r\n  <div class=\"company-update-form-row\">\r\n    <div class=\"company-update-form-column\">\r\n      <form [formGroup]=\"stepForm\" name=\"stepForm\">\r\n        <ng-container *ngIf=\"this.formService.FORM_CREATE_BOOLEAN==true\">\r\n          <div *ngFor=\"let item of this.formService.FORM_CREATE_LIST;let i=index;\" class=\"stepForm-div\">\r\n            <div *ngIf=\"this.formService.TitleDescription?.length!=0\" class=\"form-label-sticky\">\r\n              <label class=\"title-text\"\r\n                >{{this.formService.TitleDescription[i]?.Title}}</label>\r\n              <p class=\"description\" >\r\n                {{this.formService.TitleDescription[i]?.description}}</p>\r\n            </div>\r\n            <Json-Reactive-Forms \r\n              [FormStyle]=\"this.formService.TitleDescription[i]?.Style\" [ResetForm]=\"false\" [HIDE_SUBMIT_BUTTON]=\"false\"\r\n              [KEY_ENTER_ENABLED]=\"true\" [id]=\"item\" [HIDE_BACKGROUND]=\"false\" #FACTOR_AUTH_PANEL>\r\n              <ng-content></ng-content>\r\n            </Json-Reactive-Forms>\r\n          </div>\r\n          <button type=\"submit\" class=\"btn btn-primary form-submit-btn\"\r\n            (click)=\"getFormData()\">{{this.ButtonName}}</button>\r\n        </ng-container>\r\n      </form>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<boot-strap-toasts TitleText=\"Error\" #bootstraptoasts [TimeStamp]=\"'Total Error Showing : '+this.allErrors?.length\">\r\n  <ol class=\"col-12 error-controller\">\r\n    <li *ngFor=\"let item of this.allErrors;\">\r\n      {{item}}</li>\r\n  </ol>\r\n</boot-strap-toasts>", styles: [".title-text{border-bottom:2px solid #D4D4D4;width:100%;padding-bottom:10px;color:#022831}.stepForm-div{width:100%;background-color:#fff;border-radius:10px;padding:20px;margin-bottom:20px}.company-update-form{height:80vh;overflow:auto;padding-right:10px}.company-update-form-column form{display:flex;flex-direction:column}.company-update-form-column form .form-submit-btn{position:sticky;bottom:0;right:0;margin:auto 10px auto auto;background-color:#022831}.form-label-sticky{position:sticky;top:0;margin:0 auto auto}.error-controller{height:80vh;overflow:auto;padding-left:40px}.arrow-filter{position:absolute;right:10px;top:8px;cursor:pointer}.toggle-button-controller{display:flex;width:100%;gap:10px}.hide-show-view-more{margin:auto 0 10px auto;display:flex;width:100%;text-align:right;justify-content:end;color:#00f;text-decoration:underline;font-size:16px;text-transform:uppercase;cursor:pointer}.hide-show-view-more:hover{color:#022831}\n"], dependencies: [{ kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i4.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i4.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i4.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "component", type: JsonReactiveComponents, selector: "Json-Reactive-Forms", inputs: ["label", "labelStyle", "FormStyle", "MainStyle", "DetailsShow", "id", "SubmitButtonStyle", "ButtonPanelStyle", "CancelRoute", "TypeOfValue", "SubmitName", "AddNewRequried", "HIDE_BACKGROUND", "HIDE_SUBMIT_BUTTON", "KEY_ENTER_ENABLED", "ADD_NEW_BUTTON_VISIBLE", "morecontent", "BUTTON_PANEL_SHOW", "BUTTON_PANEL_HIDE", "SubmitButtonDisabled", "ResetForm", "ErrorMessageData"], outputs: ["OnSubmitEvent", "AddNewBank", "RawValueEvent", "BankEvent", "SelectionBank", "YesNoCheckBoxEvent", "SHIPPING_BILL_EVENT", "CommericalNoEvent", "AddButton", "BL_COPY_EVENT", "BENEFICIARY_EVENT", "BUYER_BENEE_EVENT", "PIPO_EVENT", "DropDownEvent", "ArrayList_ObjectEvent", "FormValueChanges", "CancelEvent", "LETTER_HEADE_URL"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: FormControllerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'progress-form', template: "<div class=\"company-update-form\">\r\n  <div class=\"company-update-form-row\">\r\n    <div class=\"company-update-form-column\">\r\n      <form [formGroup]=\"stepForm\" name=\"stepForm\">\r\n        <ng-container *ngIf=\"this.formService.FORM_CREATE_BOOLEAN==true\">\r\n          <div *ngFor=\"let item of this.formService.FORM_CREATE_LIST;let i=index;\" class=\"stepForm-div\">\r\n            <div *ngIf=\"this.formService.TitleDescription?.length!=0\" class=\"form-label-sticky\">\r\n              <label class=\"title-text\"\r\n                >{{this.formService.TitleDescription[i]?.Title}}</label>\r\n              <p class=\"description\" >\r\n                {{this.formService.TitleDescription[i]?.description}}</p>\r\n            </div>\r\n            <Json-Reactive-Forms \r\n              [FormStyle]=\"this.formService.TitleDescription[i]?.Style\" [ResetForm]=\"false\" [HIDE_SUBMIT_BUTTON]=\"false\"\r\n              [KEY_ENTER_ENABLED]=\"true\" [id]=\"item\" [HIDE_BACKGROUND]=\"false\" #FACTOR_AUTH_PANEL>\r\n              <ng-content></ng-content>\r\n            </Json-Reactive-Forms>\r\n          </div>\r\n          <button type=\"submit\" class=\"btn btn-primary form-submit-btn\"\r\n            (click)=\"getFormData()\">{{this.ButtonName}}</button>\r\n        </ng-container>\r\n      </form>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<boot-strap-toasts TitleText=\"Error\" #bootstraptoasts [TimeStamp]=\"'Total Error Showing : '+this.allErrors?.length\">\r\n  <ol class=\"col-12 error-controller\">\r\n    <li *ngFor=\"let item of this.allErrors;\">\r\n      {{item}}</li>\r\n  </ol>\r\n</boot-strap-toasts>", styles: [".title-text{border-bottom:2px solid #D4D4D4;width:100%;padding-bottom:10px;color:#022831}.stepForm-div{width:100%;background-color:#fff;border-radius:10px;padding:20px;margin-bottom:20px}.company-update-form{height:80vh;overflow:auto;padding-right:10px}.company-update-form-column form{display:flex;flex-direction:column}.company-update-form-column form .form-submit-btn{position:sticky;bottom:0;right:0;margin:auto 10px auto auto;background-color:#022831}.form-label-sticky{position:sticky;top:0;margin:0 auto auto}.error-controller{height:80vh;overflow:auto;padding-left:40px}.arrow-filter{position:absolute;right:10px;top:8px;cursor:pointer}.toggle-button-controller{display:flex;width:100%;gap:10px}.hide-show-view-more{margin:auto 0 10px auto;display:flex;width:100%;text-align:right;justify-content:end;color:#00f;text-decoration:underline;font-size:16px;text-transform:uppercase;cursor:pointer}.hide-show-view-more:hover{color:#022831}\n"] }]
        }], ctorParameters: () => [{ type: FormControllerService }, { type: ReactiveJsonFormsService }], propDecorators: { onSubmit: [{
                type: Output,
                args: ["onSubmit"]
            }], onSubmitArray: [{
                type: Output,
                args: ["onSubmitArray"]
            }], onSubmitFull: [{
                type: Output,
                args: ["onSubmitFull"]
            }], OnChangesToggleEvent: [{
                type: Output,
                args: ["OnChangesToggleEvent"]
            }], NextEvent: [{
                type: Output,
                args: ["NextEvent"]
            }], BackEvent: [{
                type: Output,
                args: ["BackEvent"]
            }], ref: [{
                type: Output,
                args: ["ref"]
            }], id: [{
                type: Input,
                args: ["id"]
            }], ButtonName: [{
                type: Input,
                args: ["ButtonName"]
            }], item: [{
                type: Input,
                args: ["item"]
            }], bootstraptoasts: [{
                type: ViewChild,
                args: ["bootstraptoasts"]
            }] } });

class JsonReactiveFormModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: JsonReactiveFormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.9", ngImport: i0, type: JsonReactiveFormModule, imports: [CommonModule,
            OverlayModule,
            SharedHomeModule,
            JsonReactiveComponents,
            InnerDynamicErrorComponent,
            MoreContentComponent], exports: [OverlayModule,
            JsonReactiveComponents,
            InnerDynamicErrorComponent,
            MoreContentComponent] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: JsonReactiveFormModule, providers: [ReactiveJsonFormsService], imports: [CommonModule,
            OverlayModule,
            SharedHomeModule,
            JsonReactiveComponents,
            InnerDynamicErrorComponent,
            MoreContentComponent, OverlayModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: JsonReactiveFormModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        OverlayModule,
                        SharedHomeModule,
                        JsonReactiveComponents,
                        InnerDynamicErrorComponent,
                        MoreContentComponent,
                    ],
                    providers: [ReactiveJsonFormsService],
                    exports: [
                        OverlayModule,
                        JsonReactiveComponents,
                        InnerDynamicErrorComponent,
                        MoreContentComponent,
                    ],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }] });

class ProgressFormControllerModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ProgressFormControllerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.9", ngImport: i0, type: ProgressFormControllerModule, declarations: [StepTrackerIconsComponent,
            ProgressionButtonsComponent,
            FormControllerComponent], imports: [CommonModule,
            SharedHomeModule,
            MaterialModule,
            JsonReactiveFormModule], exports: [StepTrackerIconsComponent,
            ProgressionButtonsComponent,
            FormControllerComponent,
            JsonReactiveFormModule] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ProgressFormControllerModule, providers: [FormControllerService], imports: [CommonModule,
            SharedHomeModule,
            MaterialModule,
            JsonReactiveFormModule, JsonReactiveFormModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: ProgressFormControllerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        StepTrackerIconsComponent,
                        ProgressionButtonsComponent,
                        FormControllerComponent,
                    ],
                    providers: [FormControllerService],
                    imports: [
                        CommonModule,
                        SharedHomeModule,
                        MaterialModule,
                        JsonReactiveFormModule
                    ],
                    exports: [
                        StepTrackerIconsComponent,
                        ProgressionButtonsComponent,
                        FormControllerComponent,
                        JsonReactiveFormModule
                    ],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA]
                }]
        }] });

class CustomSlicePipePipe {
    transform(value, ...args) {
        let start_index = args[0];
        let batch_size = args[1];
        if (start_index > 0) {
            let b = ((start_index + 1) * batch_size);
            let end = value.length > b ? b : value.length;
            let a = b - args[1];
            let data = value.slice(a, end);
            return data;
        }
        return value.slice(start_index, batch_size);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: CustomSlicePipePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
    static ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "18.2.9", ngImport: i0, type: CustomSlicePipePipe, name: "customSlicePipe" });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.9", ngImport: i0, type: CustomSlicePipePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'customSlicePipe'
                }]
        }] });

/*
 * Public API Surface of modal-pop-up
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ConfirmedValidator, CustomSlicePipePipe, EmailValidator, FormControllerComponent, FormControllerService, InnerDynamicErrorComponent, JsonReactiveComponents, JsonReactiveFormModule, MaterialModule, MoreContentComponent, PasswordStrengthValidator, PasswordValidator, ProgressFormControllerModule, ProgressionButtonsComponent, ReactiveJsonFormsService, RemoveValidator, SharedHomeModule, StepTrackerIconsComponent, alphaNumericValidator, alphaValidator, hasAmountGreaterThanForm, hasAmountGreaterThanFormArray, hasAmountLessThanForm, hasAmountLessThanFormArray, hasDuplicateControl, hasDuplicateFormArray };
//# sourceMappingURL=json-reactive-form-angular-18.mjs.map
