export interface FieldRules {
    required?: boolean;
}
export interface formArrayTypeConfig {
    type: 'text' | 'number' | 'date' | 'email' | 'password' | 'checkbox' | 'radio' | 'SelectOption' | 'textarea' | 'datetime-local' | 'MultiCheckBox' | 'MatCheckBox' | 'NumberButton' | 'EmailButton';
    value?: any;
    label?: string;
    name?: string;
    callback?: (item: any) => void;
    rules: FieldRules;
    minLength?: number;
    maxLength?: number;
    pattern?: string;
    customValidator?: (value: string) => boolean;
    placeholderText?: string;
    items?: Array<any>;
    Inputdisabled?: boolean;
    buttonList?: Array<any>;
    buttonStyle?: string;
    NgClass?: string;
    InputType?: string;
    ButtonText?: string;
    showhide?: boolean;
    autofill?: Array<any>;
    checkboxlabel?: Array<{
        checked: boolean;
        label: string;
    }>;
    HideShowInput?: Array<any>;
    errorMessage?: string;
    ParentStyle?: string;
    disabled?: boolean;
}
export interface FieldConfig {
    type: 'text' | 'number' | 'date' | 'email' | 'password' | 'checkbox' | 'radio' | 'SelectOption' | 'textarea' | 'datetime-local' | 'formGroup' | 'MultiCheckBox' | 'MatCheckBox' | 'NumberButton' | 'EmailButton';
    value: any;
    label: string;
    rules: FieldRules;
    minLength?: number;
    maxLength?: number;
    pattern?: string;
    callback?: (item: any) => void;
    customValidator?: (value: string) => boolean;
    placeholderText?: string;
    items?: Array<any>;
    Inputdisabled?: boolean;
    buttonList?: Array<any>;
    buttonStyle?: string;
    NgClass?: string;
    InputType?: string;
    ButtonText?: string;
    showhide?: boolean;
    autofill?: Array<any>;
    checkboxlabel?: Array<any>;
    HideShowInput?: Array<any>;
    errorMessage?: string;
    ParentStyle?: string;
    GroupLabel?: Array<any>;
    AddNewRequried?: boolean;
    formArray?: [formArrayTypeConfig[]];
}
export interface FormConfig {
    [key: string]: FieldConfig;
}
